/* 操作提示框 */
function promptBox(text, status, closeTime) {
    if (closeTime == undefined || closeTime < 200) {
        closeTime = 1000;
    }
    $(function () {
        /* 先删除div层，防止重复叠加 */
        $(".promptBox").remove();
        //判断成功或者失败
        if (status)
            var id = "success";
        else
            var id = "failure";
        //生成html添加到body
        var addHtml = "";
        addHtml += '<div class="promptBox" id="' + id + '">';
        addHtml += '<div class="outer">';
        addHtml += '<div class="transparent"></div>';
        addHtml += '<i class="boxClose">X</i>';
        addHtml += '<div class="inner">';
        addHtml += text;
        addHtml += '</div>';
        addHtml += '</div>';
        addHtml += '</div>';
        $(addHtml).appendTo("body");
        //根据文字定义外层宽度
        var innerWidth = $(".inner").outerWidth(true) + 40;
        $(".promptBox .outer,.promptBox .outer .transparent").width(innerWidth);
        $(".promptBox").css({
            marginLeft : -innerWidth / 2
        });
        //淡淡显示出来
        $(".promptBox").animate({
            'opacity' : 1
        }, 1000);
        //关闭提示框
        $(".boxClose").click(function () {
            $(".promptBox").fadeOut(1000, function () {
                $(this).remove();
            });
        });
        //3秒后自动关闭
        setTimeout(function () {
            $(".boxClose").click();
        }, closeTime);
    });
}
function return_prepage() {
    if (window.document.referrer == ""
        || window.document.referrer == window.location.href) {
        window.location.href = "{dede:type}[field:typelink /]{/dede:type}";
    } else {
        window.location.href = window.document.referrer;
    }
}
/**
 * 获取验证码按钮禁用,并且倒计时
 * @author liuchunhua
 * @date 20151203
 * @copyright www.cwq.com
 * @param object button_element 按钮元素
 * return void
 */
function disable_button(button_element){
    if (!button_element.hasClass('disabled')) {
        button_element.addClass('disabled');
        button_element.attr('lt',120);
    }
    var lt = parseInt(button_element.attr('lt'));
    button_element.html(lt);
    if (lt > 0) {
        lt--;
        button_element.attr('lt',lt);
        setTimeout(function(){
            disable_button(button_element);
        },1000);
    } else {
        button_element.html('获取验证码');
        button_element.removeClass('disabled');
    }
}
/**
 * 获取手机验证码,这里不验证数据合法性.
 * 请验证数据合法性后调用
 * @author liuchunhua
 * @date 20151203
 * @copyright www.cwq.com
 * @param string url         获取验证码接口地址
 * @param string telephone   手机号
 * @param string verify      图像验证码
 * @return void
 */
function get_register_code(url,telephone,verify) {
    var post_data = {'telephone':telephone,'verify':verify};
    $.post(url,post_data,function(d){
        if (d.status == 1){
            promptBox(d.msg,1);
        } else {
            promptBox(d.msg,0);
        }
    },'JSON');
    disable_button($('.phone_verify button'));
}

/**
 * 正则校验qq号码
 * @author liuchunhua
 * @date 20151203
 * @copyright www.cwq.com
 * @param int qq 输入的qq号码
 * @return boolean
 */
function preg_qq(qq){
    var reg = /^[\d]{5,10}/;
    return reg.test(qq);
}
/**
 * 正则校验手机号码
 * @author liuchunhua
 * @date 20151203
 * @copyright www.cwq.com
 * @param string|int phone 输入的手机号码
 * @return boolean
 */
function preg_phone(phone){
    if (phone.length != 11) {
        return false;
    }
    var reg = /^1[34578]{1}[\d]{9}$/;
    if (reg.test(phone)) {
        return true;
    } else {
        return false;
    }
}