
CREATE TABLE IF NOT EXISTS `{dbprefix}member_cash_log` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '申请人uid',
  `username` varchar(50) NOT NULL COMMENT '申请人账号',
  `bank` varchar(50) NOT NULL  COMMENT '银行名称',
  `branch` varchar(100) NOT NULL COMMENT '开户网点',
  `account` varchar(50) NOT NULL COMMENT '收款帐号',
  `truename` varchar(50) NOT NULL COMMENT '收款户名',
  `amount` decimal(10,2) unsigned NOT NULL DEFAULT '0.00' COMMENT '提款金额',
  `fee` decimal(10,2) unsigned NOT NULL DEFAULT '0.00' COMMENT '手续费',
  `inputip` varchar(50) NOT NULL DEFAULT '' COMMENT '申请IP',
  `inputtime` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '申请时间',
  `euid` mediumint(8) unsigned NOT NULL COMMENT '处理人uid',
  `editor` varchar(30) NOT NULL DEFAULT '' COMMENT '处理人账号',
  `edittime` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '处理时间',
  `note` text DEFAULT NULL COMMENT '处理备注',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '处理状态',
  PRIMARY KEY (`id`),
  KEY (`uid`),
  KEY (`uid`,`status`),
  KEY (`username`),
  KEY (`inputtime`),
  KEY (`euid`),
  KEY (`editor`),
  KEY (`edittime`),
  KEY (`status`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='会员申请提现记录';


CREATE TABLE IF NOT EXISTS `{dbprefix}member_cash_account` (
  `uid` mediumint(8) unsigned NOT NULL COMMENT '申请人uid',
  `bank` varchar(50) NOT NULL  COMMENT '银行名称',
  `branch` varchar(100) NOT NULL COMMENT '开户网点',
  `account` varchar(50) NOT NULL COMMENT '收款帐号',
  `truename` varchar(50) NOT NULL COMMENT '收款户名',
  PRIMARY KEY (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='会员申请提现账号';