<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');


require FCPATH.'system/core/D_Admin_Table.php';

class Cash extends D_Admin_Table {

    /**
     * 构造函数
     */
    public function __construct() {
        parent::__construct();
        $this->mydb = $this->db; // 数据库
		$this->tfield = 'inputtime'; // 时间字段用于搜索和排序
		$this->mytable = 'member_cash_log'; // 表名
		$this->myfield = array(
			'username' => array(
				'ismain' => 1,
				'fieldname' => 'username',
				'name' => fc_lang('会员名称'),
			),
			'editor' => array(
				'ismain' => 1,
				'fieldname' => 'editor',
				'name' => fc_lang('受理人'),
			),
			'editor' => array(
				'ismain' => 1,
				'fieldname' => 'editor',
				'name' => fc_lang('受理人'),
			),
		); // 表字段
        $this->template->assign(array(
			'menu' => $this->get_menu(array(
				fc_lang('提现管理') => 'cash/admin/cash/index',
				fc_lang('提现配置') => 'cash/admin/cash/setting'
			)),
			'field' => $this->myfield,
		));
    }

	// 管理
	public function index() {

		if ($this->input->post('action') == 'del') {
			$ids = $this->input->post('ids');
			if (!$ids) {
				exit(dr_json(0, fc_lang('您还没有选择呢')));
			}
			foreach ($ids as $id) {
				$row = $this->mydb->where('id', (int)$id)->get($this->mytable)->row_array();
				if ($row) {
					$this->mydb->where('id', (int)$id)->delete($this->mytable);
					$this->system_log('删除提现申请【'.$row['username'].'】'); // 记录日志
				}
			}
			exit(dr_json(1, fc_lang('操作成功，正在刷新...')));
		}

		$this->_index();
		$this->template->display('cash_index.html');
	}

	// 受理
	public function edit() {

		$id = (int)$this->input->get($this->myid);
		$data = $this->_get_data($id);
		if (!$data) {
			$this->admin_msg(fc_lang('对不起，数据被删除或者查询不存在'));
		}
		$m = $this->db->where('uid', (int)$data['uid'])->get('member')->row_array();

		if (IS_POST) {
			$myfield = array(
				'status' => array(
					'ismain' => 1,
					'fieldname' => 'status',
					'fieldtype' => 'Text',
				),
				'note' => array(
					'ismain' => 1,
					'fieldname' => 'note',
					'fieldtype' => 'Ueditor',
				),
			);
			$post = $this->validate_filter($myfield, $data);
			if (isset($post['error'])) {
				$this->admin_msg($post['error']['msg']);
			} else {
				$post[1]['euid'] = $this->member['uid'];
				$post[1]['editor'] = $this->member['username'];
				$post[1]['edittime'] = SYS_TIME;
				if ($data['status'] == 2) {
					// 表示处理成功了的
					unset($post[1]['status'], $post[1]['edittime']);
				} elseif ($data['status'] == 1) {
					// 表示未通过的
					unset($post[1]['status'], $post[1]['edittime']);
				}
				if (isset($post[1]['status']) && $post[1]['status'] == 2) {
					// 本次操作处理成功时，确定扣款
					$this->db->where('uid', (int)$m['uid'])->update('member', array(
						'freeze' => max(0, $m['freeze'] - $data['amount']),
					));
					$this->member_model->add_notice((int)$m['uid'], 1, fc_lang('提现受理成功，金额：￥%s元', $data['amount']));
					// 更新空i记录表
					$this->db->insert('member_paylog', array(
						'uid' => (int)$m['uid'],
						'type' => 0,
						'note' => fc_lang('提现受理成功，金额：￥%s元', $data['amount']),
						'value' => -$data['amount'],
						'order' => 0,
						'status' => 1,
						'module' => '',
						'inputtime' => SYS_TIME,
					));
				} elseif (isset($post[1]['status']) && $post[1]['status'] == 1) {
					// 本次操作处理未通过时，退款
					$this->db->where('uid', (int)$m['uid'])->update('member', array(
						'money' => $m['money'] + $data['amount'],
						'freeze' => max(0, $m['freeze'] - $data['amount']),
					));
					$this->member_model->add_notice((int)$m['uid'], 1, fc_lang('提现受理未通过，退回金额：￥%s元', $data['amount']));
				}
				$this->_update_data($id, $post[1], $data);
				// 操作成功处理附件
				$this->attachment_handle($this->uid, $this->db->dbprefix($this->mytable).'-'.$id, $myfield, $post);
				$this->admin_msg(fc_lang('操作成功，正在刷新...'), dr_url(APP_DIR.'/'.$this->router->class.'/index'), 1);
			}
		}

		$this->template->assign(array(
			'm' => $m,
			'data' => $data,
		));

		$this->template->display('cash_edit.html');
	}

	/**
	 * 提现配置
	 */
	public function setting() {

		if (IS_POST) {
			$this->member_model->cash($this->input->post('data'));
			$this->member_model->cache();
			$this->system_log('财务提现配置设置'); // 记录日志
		}
		$this->template->assign(array(
			'data' => $this->member_model->cash(),
		));
		$this->template->display('setting_cash.html');
	}
}