<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');




class Cash extends M_Controller {

    /**
     * 构造函数
     */
    public function __construct() {
        parent::__construct();
    }

	// 管理
	public function index() {

		$kw = dr_safe_replace($this->input->get('kw', TRUE));
		$page = (int)$this->input->get('page');
		$order = dr_get_order_string(isset($_GET['order']) && strpos($_GET['order'], "undefined") !== 0 ? $this->input->get('order', TRUE) : 'status asc,inputtime desc', 'status asc,inputtime desc');
		$this->db->where('uid', $this->uid);
		// 银行卡搜索
		if ($kw) {
			$this->db->where('account', $kw);
		}
		// 排序
		$this->db->order_by($order);
		if ($this->input->get('action') == 'search') {
			// ajax搜索数据
			$page = max((int)$this->input->get('page'), 1);
			$data = $this->db->limit($this->pagesize, $this->pagesize * ($page - 1))->get('member_cash_log')->result_array();
			if (!$data) {
				exit('null');
			}
			$this->template->assign(array(
				'kw' => $kw,
				'list' => $data,
			));
			$this->template->display('cash_data.html');
		} else {
			$this->template->assign(array(
				'kw' => $kw,
				'page' => max(2, $page + 1),
				'list' => $this->db->limit($page ? $page * $this->pagesize : $this->pagesize)->get('member_cash_log')->result_array(),
				'order' => $order,
				'moreurl' => 'index.php?s=member&app=cash&c=cash&m=index&action=search&order='.$order.'&kw='.$kw,
			));
			$this->template->display('cash_index.html');
		}
	}

	// 申请提现
	public function add() {

		$my = $this->db->where('uid', $this->uid)->get('member_cash_account')->row_array();
		if (!$my) {
			$this->member_msg(fc_lang('您还没有设置提现账号'), dr_member_url('cash/cash/my'));
		}

		$config = $this->get_cache('member', 'setting', 'cash');
		$this->template->assign(array(
			'my' => $my,
			'config' => $config,
		));

		if (IS_POST) {
			$money = dr_safe_replace($this->input->post('money'));
			$sxf = $config['fl'] ? $money * ($config['fl']/100) : 0;
			if (empty($money)) {
				$this->member_msg(fc_lang('输入不完整'), dr_member_url('cash/cash/add'));
			} elseif ($config['min'] && $money < $config['min']) {
				$this->member_msg(fc_lang('提现金额不能低于最小提现金额'), dr_member_url('cash/cash/add'));
			} elseif ($money > $this->member['money']) {
				$this->member_msg(fc_lang('账号余额不足'), dr_member_url('cash/cash/add'));
			}
			if ($this->input->post('confirm')) {
				$this->db->insert('member_cash_log', array(
					'uid' => $this->uid,
					'username' => $this->member['username'],
					'bank' => $my['bank'],
					'branch' => $my['branch'],
					'account' => $my['account'],
					'truename' => $my['truename'],
					'amount' => $money,
					'fee' => $sxf,
					'inputip' => $this->input->ip_address(),
					'inputtime' => SYS_TIME,
					'euid' => 0,
					'editor' => '',
					'edittime' => 0,
					'note' => '',
					'status' => 0,
				));
				// 将价格冻结
				$this->db->where('uid', $this->uid)->update('member', array(
					'money' => $this->member['money'] - $money,
					'freeze' => $this->member['money'] + $money,
				));
				$this->member_model->add_notice($this->uid, 1, fc_lang('冻结提现金额：￥%s元（含手续费）', $money));
				$this->member_msg(fc_lang('申请提交成功，我们会尽快为您处理...'), dr_member_url('cash/cash/index'), 1);
			} else {
				$this->template->assign(array(
					'sxf' => $sxf,
					'money' => $money,
				));
				$this->template->display('cash_confirm.html');
			}
		} else {
			$this->template->display('cash_add.html');
		}
	}

	// 查看提现记录
	public function show() {

		$id = (int)$this->input->get('id');
		$data = $this->db->where('id', $id)->get('member_cash_log')->row_array();
		if (!$data) {
			$this->member_msg(fc_lang('对不起，数据被删除或者查询不存在'));
		}

		$this->template->assign(array(
			'data' => $data,
		));
		$this->template->display('cash_show.html');
	}

	// 我的银行卡设置
	public function my() {

		$data = $this->db->where('uid', $this->uid)->get('member_cash_account')->row_array();
		if (IS_POST) {
			$post = $this->input->post('data', true);
			if (empty($post['bank']) || empty($post['branch']) || empty($post['account']) || empty($post['truename'])) {
				$this->member_msg(fc_lang('输入不完整'));
			}
			$this->db->replace('member_cash_account', array(
				'uid' => $this->uid,
				'bank' => dr_safe_replace($post['bank']),
				'branch' => dr_safe_replace($post['branch']),
				'account' => dr_safe_replace($post['account']),
				'truename' => dr_safe_replace($post['truename']),
			));
			$this->member_msg(fc_lang('操作成功，正在刷新...'), dr_member_url('cash/cash/my'), 1);
		}

		$this->template->assign(array(
			'data' => $data,
		));
		$this->template->display('cash_my.html');
	}
	
}