<?php

if (!defined('BASEPATH')) exit('No direct script access allowed');

/**
 * 诚信商人出品
 */

class Home extends M_Controller {

    /**
     * 构造函数
     */
    public function __construct() {
        parent::__construct();
		$this->load->model('application_model');
    }

    /**
     * 配置应用
     */
    public function index() {
		 redirect(SITE_URL.$this->url('content/index'), 'refresh');
    }
	
	/**
     * 安装应用
     */
    public function install() {
		// 判断权限
		if (!$this->is_auth('admin/application/install')) {
            $this->admin_msg(dr_lang('049', 'application/install'));
        }
		// 插入应用数据库
		$id = $this->application_model->add(APP_DIR);
		$this->m_model->install_admin_menu(APP_DIR, $id);
		$this->admin_msg('应用安装成功，请更新缓存，再按F5刷新整个界面', $this->url('home/index'), 1, 9);
    }
	
	/**
     * 卸载应用
     */
    public function uninstall() {
		// 判断权限
		if (!$this->is_auth('admin/application/uninstall')) {
            $this->admin_msg(dr_lang('049', 'application/uninstall'));
        }
		// 应用数据
		$data = $this->application_model->get(APP_DIR);
		// 删除应用数据库
    	$this->application_model->del($data['id']);
    	$this->admin_msg(lang('000'), dr_url('application/index'), 1);
    }
	
	/**
	 * 应用缓存
	 *
	 * @return	NULL
	 */
	public function cache() {
		$this->input->get('admin') or $this->admin_msg(lang('000'), isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : '', 1);
		
	}

}
