

DROP TABLE IF EXISTS `dr_1_block`;

CREATE TABLE `dr_1_block` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL COMMENT '文本块名称',
  `content` text NOT NULL COMMENT '内容',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='文本块表';


INSERT INTO `dr_1_block` (`id`, `name`, `content`)
VALUES
	(1,'会员中心公告','新版本隆重上线！');



# Dump of table dr_1_form
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_form`;

CREATE TABLE `dr_1_form` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL COMMENT '名称',
  `table` varchar(50) NOT NULL COMMENT '表名',
  `setting` text COMMENT '配置信息',
  PRIMARY KEY (`id`),
  UNIQUE KEY `table` (`table`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='表单模型表';



# Dump of table dr_1_navigator
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_navigator`;

CREATE TABLE `dr_1_navigator` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `pid` smallint(5) unsigned NOT NULL COMMENT '上级id',
  `pids` text COMMENT '所有上级id数据项',
  `type` tinyint(1) unsigned NOT NULL COMMENT '导航类型',
  `name` varchar(255) NOT NULL COMMENT '导航名称',
  `title` varchar(255) NOT NULL COMMENT 'seo标题',
  `url` varchar(255) NOT NULL COMMENT '导航地址',
  `thumb` varchar(255) NOT NULL COMMENT '图片标示',
  `show` tinyint(1) unsigned NOT NULL COMMENT '显示',
  `mark` varchar(255) DEFAULT NULL COMMENT '类型标示',
  `extend` tinyint(1) unsigned DEFAULT NULL COMMENT '是否继承下级',
  `child` tinyint(1) unsigned NOT NULL COMMENT '是否有下级',
  `childids` text COMMENT '所有下级数据项',
  `target` tinyint(1) unsigned NOT NULL COMMENT '是否站外链接',
  `displayorder` tinyint(3) NOT NULL COMMENT '显示顺序',
  PRIMARY KEY (`id`),
  KEY `list` (`id`,`type`,`show`,`displayorder`),
  KEY `mark` (`mark`),
  KEY `extend` (`extend`),
  KEY `pid` (`pid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='网站导航表';



INSERT INTO `dr_1_navigator` (`id`, `pid`, `pids`, `type`, `name`, `title`, `url`, `thumb`, `show`, `mark`, `extend`, `child`, `childids`, `target`, `displayorder`)
VALUES
	(1,0,'0',0,'新闻','','/index.php?s=news','',1,'module-news-0',0,0,'1',0,0),
	(38,0,'0',0,'微信','','/index.php?s=weixin','',1,'module-weixin-0',0,0,'38',0,0),
	(36,0,'0',0,'微博','','/index.php?s=weibo','',1,'module-weibo-0',0,0,'36',0,0),
	(9,0,'0',0,'会员中心','','/index.php?s=member','',1,'',0,0,'9',0,9),
	(37,0,'0',0,'朋友圈','','/index.php?s=quan','',1,'module-quan-0',0,0,'37',0,0);


DROP TABLE IF EXISTS `dr_1_news`;


CREATE TABLE IF NOT EXISTS `dr_1_news` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `catid` smallint(5) unsigned NOT NULL COMMENT '栏目id',
  `title` varchar(255) DEFAULT NULL COMMENT '主题',
  `thumb` varchar(255) DEFAULT NULL,
  `keywords` varchar(255) DEFAULT NULL COMMENT '关键字',
  `description` text COMMENT '描述',
  `hits` mediumint(8) unsigned DEFAULT NULL COMMENT '浏览数',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '作者id',
  `author` varchar(50) NOT NULL COMMENT '作者名称',
  `status` tinyint(2) NOT NULL COMMENT '状态',
  `url` varchar(255) DEFAULT NULL COMMENT '地址',
  `link_id` int(10) NOT NULL DEFAULT '0' COMMENT '同步id',
  `tableid` smallint(5) unsigned NOT NULL COMMENT '附表id',
  `inputip` varchar(15) DEFAULT NULL COMMENT '录入者ip',
  `inputtime` int(10) unsigned NOT NULL COMMENT '录入时间',
  `updatetime` int(10) unsigned NOT NULL COMMENT '更新时间',
  `comments` int(10) unsigned NOT NULL COMMENT '评论数量',
  `favorites` int(10) unsigned NOT NULL COMMENT '收藏数量',
  `displayorder` tinyint(3) NOT NULL DEFAULT '0',
  `diqu` mediumint(8) unsigned DEFAULT NULL,
  `order_price` decimal(10,2) DEFAULT NULL,
  `order_price_sj` decimal(10,2) DEFAULT NULL,
  `xingyefenlei` varchar(222) DEFAULT NULL,
  `xinwenyuan` varchar(255) DEFAULT NULL,
  `wangzhishoulu` varchar(255) DEFAULT NULL,
  `shifouxuyaolaiyuan` varchar(255) DEFAULT NULL,
  `anlidizhi` varchar(255) DEFAULT NULL,
  `meitidizhi` varchar(255) DEFAULT NULL,
  `zhoumonengfoufagao` varchar(255) DEFAULT NULL,
  `wenbenlianjie` varchar(255) DEFAULT NULL,
  `biaotichangduxianzhi` varchar(255) DEFAULT NULL,
  `menhuleixing` varchar(255) DEFAULT NULL,
  `meitijietu` varchar(255) DEFAULT NULL,
  `isflag` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `catid` (`catid`,`updatetime`),
  KEY `link_id` (`link_id`),
  KEY `comments` (`comments`),
  KEY `favorites` (`favorites`),
  KEY `status` (`status`),
  KEY `hits` (`hits`),
  KEY `displayorder` (`displayorder`,`updatetime`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='主表';



# Dump of table dr_1_news_category
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_news_category`;

CREATE TABLE `dr_1_news_category` (
  `id` tinyint(3) unsigned NOT NULL AUTO_INCREMENT,
  `pid` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '上级id',
  `pids` varchar(255) NOT NULL COMMENT '所有上级id',
  `name` varchar(30) NOT NULL COMMENT '栏目名称',
  `letter` char(1) NOT NULL COMMENT '首字母',
  `dirname` varchar(30) NOT NULL COMMENT '栏目目录',
  `pdirname` varchar(100) NOT NULL COMMENT '上级目录',
  `child` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否有下级',
  `childids` text NOT NULL COMMENT '下级所有id',
  `thumb` varchar(255) NOT NULL COMMENT '栏目图片',
  `show` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '是否显示',
  `permission` text COMMENT '会员权限',
  `setting` text NOT NULL COMMENT '属性配置',
  `displayorder` tinyint(3) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `show` (`show`),
  KEY `module` (`pid`,`displayorder`,`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='栏目表';



INSERT INTO `dr_1_news_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`)
VALUES
	(1,0,'0','全部新闻媒体','q','quanbuxinwenmeiti','',0,'1','',1,'a:1:{s:3:\\\"4_5\\\";a:10:{s:10:\\\"experience\\\";s:1:\\\"0\\\";s:5:\\\"score\\\";s:1:\\\"0\\\";s:7:\\\"postnum\\\";s:1:\\\"0\\\";s:6:\\\"verify\\\";s:1:\\\"1\\\";s:9:\\\"postcount\\\";s:1:\\\"0\\\";s:3:\\\"add\\\";s:1:\\\"1\\\";s:3:\\\"del\\\";s:1:\\\"1\\\";s:4:\\\"show\\\";N;s:4:\\\"edit\\\";s:1:\\\"1\\\";s:9:\\\"forbidden\\\";N;}}','a:6:{s:4:\\\"edit\\\";s:1:\\\"0\\\";s:7:\\\"linkurl\\\";s:0:\\\"\\\";s:3:\\\"seo\\\";a:4:{s:10:\\\"show_title\\\";s:74:\\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\\";s:10:\\\"list_title\\\";s:58:\\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\\";s:13:\\\"list_keywords\\\";s:0:\\\"\\\";s:16:\\\"list_description\\\";s:0:\\\"\\\";}s:8:\\\"template\\\";a:5:{s:8:\\\"pagesize\\\";s:2:\\\"20\\\";s:4:\\\"show\\\";s:9:\\\"show.html\\\";s:8:\\\"category\\\";s:13:\\\"category.html\\\";s:4:\\\"list\\\";s:9:\\\"list.html\\\";s:6:\\\"search\\\";s:11:\\\"search.html\\\";}s:5:\\\"admin\\\";a:0:{}s:6:\\\"member\\\";a:0:{}}',0);






# Dump of table dr_1_news_favorite
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_news_favorite`;

CREATE TABLE `dr_1_news_favorite` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `cid` int(10) unsigned NOT NULL COMMENT '文档id',
  `eid` int(10) unsigned DEFAULT NULL COMMENT '扩展id',
  `uid` mediumint(8) unsigned NOT NULL COMMENT 'uid',
  `url` varchar(255) NOT NULL COMMENT 'URL地址',
  `title` varchar(255) NOT NULL COMMENT '标题',
  `inputtime` int(10) unsigned NOT NULL COMMENT '录入时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `cid` (`cid`),
  KEY `eid` (`eid`),
  KEY `inputtime` (`inputtime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='收藏夹表';



# Dump of table dr_1_news_flag
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_news_flag`;

CREATE TABLE `dr_1_news_flag` (
  `flag` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '文档标记id',
  `id` int(10) unsigned NOT NULL COMMENT '文档内容id',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '作者uid',
  `catid` tinyint(3) unsigned NOT NULL COMMENT '栏目id',
  KEY `flag` (`flag`,`id`,`uid`),
  KEY `catid` (`catid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='标记表';



# Dump of table dr_1_news_index
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_news_index`;

CREATE TABLE `dr_1_news_index` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` mediumint(8) unsigned NOT NULL COMMENT '作者uid',
  `catid` tinyint(3) unsigned NOT NULL COMMENT '栏目id',
  `status` tinyint(2) NOT NULL COMMENT '审核状态',
  `inputtime` int(10) unsigned NOT NULL COMMENT '录入时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `catid` (`catid`),
  KEY `status` (`status`),
  KEY `inputtime` (`inputtime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='内容索引表';



# Dump of table dr_1_news_search
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_news_search`;

CREATE TABLE `dr_1_news_search` (
  `id` varchar(32) NOT NULL,
  `catid` tinyint(3) unsigned NOT NULL COMMENT '栏目id',
  `params` text NOT NULL COMMENT '参数数组',
  `keyword` varchar(255) NOT NULL COMMENT '关键字',
  `contentid` mediumtext NOT NULL COMMENT 'id集合',
  `inputtime` int(10) unsigned NOT NULL COMMENT '搜索时间',
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`),
  KEY `catid` (`catid`),
  KEY `keyword` (`keyword`),
  KEY `inputtime` (`inputtime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='搜索表';



# Dump of table dr_1_news_search_index
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_news_search_index`;

CREATE TABLE `dr_1_news_search_index` (
  `id` varchar(32) NOT NULL,
  `cid` int(10) unsigned NOT NULL COMMENT '文档Id',
  `inputtime` int(10) unsigned NOT NULL COMMENT '搜索时间',
  KEY `id` (`id`),
  KEY `cid` (`cid`),
  KEY `inputtime` (`inputtime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='搜索索引表';



# Dump of table dr_1_news_verify
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_news_verify`;

CREATE TABLE `dr_1_news_verify` (
  `id` int(10) unsigned NOT NULL,
  `catid` tinyint(3) unsigned NOT NULL COMMENT '栏目id',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '作者uid',
  `author` varchar(50) NOT NULL COMMENT '作者',
  `status` tinyint(2) NOT NULL COMMENT '审核状态',
  `content` mediumtext NOT NULL COMMENT '具体内容',
  `backuid` mediumint(8) unsigned NOT NULL COMMENT '操作人uid',
  `backinfo` text NOT NULL COMMENT '操作退回信息',
  `inputtime` int(10) unsigned NOT NULL COMMENT '录入时间',
  UNIQUE KEY `id` (`id`),
  KEY `uid` (`uid`),
  KEY `catid` (`catid`),
  KEY `status` (`status`),
  KEY `inputtime` (`inputtime`),
  KEY `backuid` (`backuid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='内容审核表';



# Dump of table dr_1_order
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_order`;

CREATE TABLE `dr_1_order` (
  `id` bigint(18) NOT NULL AUTO_INCREMENT COMMENT 'oid',
  `sn` varchar(50) NOT NULL COMMENT '流水序列号',
  `mid` varchar(50) NOT NULL COMMENT '模块名',
  `yuyue` tinyint(1) NOT NULL COMMENT '是否预约',
  `buy_uid` mediumint(8) unsigned DEFAULT NULL COMMENT '购买者id',
  `buy_username` varchar(50) DEFAULT NULL COMMENT '购买者name',
  `buy_step` tinyint(1) NOT NULL COMMENT '购买步骤流程',
  `sell_uid` mediumint(8) unsigned DEFAULT NULL COMMENT '出售者id',
  `sell_username` varchar(50) DEFAULT NULL COMMENT '出售者name',
  `order_time` int(11) DEFAULT NULL COMMENT '下单时间',
  `order_status` tinyint(1) unsigned DEFAULT NULL COMMENT '订单状态',
  `order_price` decimal(10,2) DEFAULT NULL COMMENT '订单金额',
  `order_price_sj` decimal(10,2) DEFAULT NULL,
  `order_score` tinyint(11) DEFAULT NULL COMMENT '是否虚拟币支付',
  `order_youhui` decimal(10,2) NOT NULL COMMENT '优惠的价格',
  `order_comment` int(10) NOT NULL COMMENT '针对商铺的评论id',
  `pay_type` tinyint(2) DEFAULT NULL COMMENT '付款方式',
  `pay_id` int(10) DEFAULT NULL COMMENT '付款id',
  `pay_status` tinyint(1) unsigned DEFAULT NULL COMMENT '付款状态',
  `pay_time` int(10) NOT NULL COMMENT '付款时间',
  `shipping_time` int(10) DEFAULT NULL COMMENT '发货时间',
  `shipping_stime` int(10) NOT NULL COMMENT '收货时间',
  `shipping_status` tinyint(1) unsigned NOT NULL COMMENT '物流状态',
  `shipping_price` decimal(10,2) NOT NULL COMMENT '运费价格',
  `shipping_name` varchar(100) NOT NULL COMMENT '收货人姓名',
  `shipping_phone` varchar(50) NOT NULL COMMENT '收货人手机',
  `tableid` tinyint(3) unsigned DEFAULT '0' COMMENT '附表号',
  `my_title` varchar(255) NOT NULL,
  `my_time` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `sn` (`sn`),
  KEY `buy_uid` (`buy_uid`),
  KEY `buy_username` (`buy_username`),
  KEY `sell_uid` (`sell_uid`),
  KEY `sell_username` (`sell_username`),
  KEY `order_time` (`order_time`),
  KEY `order_status` (`order_status`),
  KEY `pay_id` (`pay_id`),
  KEY `pay_status` (`pay_status`),
  KEY `shipping_time` (`shipping_time`),
  KEY `shipping_status` (`shipping_status`),
  KEY `order_price` (`order_price`),
  KEY `order_comment` (`order_comment`),
  KEY `shipping_phone` (`shipping_phone`),
  KEY `mid` (`mid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='订单信息表';



# Dump of table dr_1_order_buy
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_order_buy`;

CREATE TABLE `dr_1_order_buy` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `mid` varchar(50) NOT NULL COMMENT '模块名称',
  `oid` bigint(15) unsigned NOT NULL COMMENT '订单id',
  `uid` int(10) NOT NULL COMMENT '购买者id',
  `cid` int(10) NOT NULL COMMENT '内容id',
  `catid` int(10) NOT NULL COMMENT '栏目id',
  `comment` int(10) NOT NULL COMMENT '评论id',
  `specification` varchar(50) NOT NULL COMMENT '规格信息',
  `quantity` int(10) NOT NULL COMMENT '购买数量',
  PRIMARY KEY (`id`),
  KEY `cc` (`uid`,`oid`,`comment`,`cid`,`mid`),
  KEY `bb` (`mid`,`cid`,`uid`,`oid`),
  KEY `aa` (`mid`,`oid`,`cid`,`specification`),
  KEY `uid` (`uid`),
  KEY `oid` (`oid`),
  KEY `catid` (`catid`),
  KEY `comment` (`comment`),
  KEY `quantity` (`quantity`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='购买记录表';



# Dump of table dr_1_order_data_0
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_order_data_0`;

CREATE TABLE `dr_1_order_data_0` (
  `id` bigint(18) NOT NULL COMMENT 'oid',
  `buy_uid` mediumint(8) unsigned DEFAULT NULL COMMENT '购买者id',
  `buy_note` text COMMENT '购买者备注或留言',
  `sell_note` text COMMENT '商家备注',
  `sell_uid` mediumint(8) unsigned DEFAULT NULL COMMENT '出售者id',
  `shipping_type` varchar(50) DEFAULT NULL COMMENT '物流方式',
  `shipping_sn` varchar(50) DEFAULT NULL COMMENT '物流/快递单号',
  `shipping_city` varchar(100) DEFAULT NULL COMMENT '物流城市',
  `shipping_zipcode` varchar(32) DEFAULT NULL COMMENT '物流邮编',
  `shipping_address` varchar(255) DEFAULT NULL COMMENT '物流收货地址',
  `content_news` mediumtext NOT NULL,
  `content_weixin` mediumtext NOT NULL,
  `content_quan` mediumtext NOT NULL,
  `content_weibo` mediumtext NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`),
  KEY `buy_uid` (`buy_uid`),
  KEY `sell_uid` (`sell_uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='订单信息附表';



# Dump of table dr_1_order_goods
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_order_goods`;

CREATE TABLE `dr_1_order_goods` (
  `id` bigint(18) NOT NULL AUTO_INCREMENT COMMENT 'gid',
  `oid` bigint(18) unsigned NOT NULL COMMENT '订单id',
  `mid` varchar(20) NOT NULL COMMENT '模块名',
  `cid` int(11) unsigned NOT NULL COMMENT '内容id',
  `title` varchar(255) NOT NULL COMMENT '标题',
  `catid` int(10) NOT NULL COMMENT '栏目',
  `thumb` varchar(100) NOT NULL COMMENT '图片',
  `url` varchar(255) NOT NULL COMMENT '地址',
  `specification` varchar(100) NOT NULL COMMENT '规格',
  `quantity` int(10) NOT NULL COMMENT '购买数量',
  `sn` varchar(100) NOT NULL COMMENT '商品编码',
  `sku` text NOT NULL,
  `price` decimal(10,2) NOT NULL COMMENT '总价格',
  `order_price` decimal(10,2) NOT NULL COMMENT '商品单价',
  PRIMARY KEY (`id`),
  KEY `oid` (`oid`),
  KEY `mid` (`mid`),
  KEY `cid` (`cid`),
  KEY `title` (`title`),
  KEY `order_price` (`order_price`),
  KEY `catid` (`catid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='订单商品表';



# Dump of table dr_1_order_operate
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_order_operate`;

CREATE TABLE `dr_1_order_operate` (
  `id` bigint(15) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `oid` bigint(18) NOT NULL COMMENT '订单id',
  `uid` int(10) NOT NULL COMMENT '操作人',
  `username` varchar(100) NOT NULL COMMENT '操作人账号',
  `order_status` tinyint(2) NOT NULL COMMENT '订单状态',
  `pay_status` tinyint(2) NOT NULL COMMENT '付款状态',
  `shipping_status` tinyint(2) NOT NULL COMMENT '物流状态',
  `note` text NOT NULL COMMENT '备注信息',
  `inputtime` int(10) NOT NULL COMMENT '操作时间',
  `inputip` varchar(100) NOT NULL COMMENT 'IP地址',
  PRIMARY KEY (`id`),
  KEY `oid` (`oid`),
  KEY `order_status` (`order_status`),
  KEY `pay_status` (`pay_status`),
  KEY `inputtime` (`inputtime`),
  KEY `shipping_status` (`shipping_status`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='订单操作记录表';



# Dump of table dr_1_order_transfer
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_order_transfer`;

CREATE TABLE `dr_1_order_transfer` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `oid` mediumint(8) unsigned NOT NULL COMMENT '订单id',
  `sn` varchar(255) NOT NULL COMMENT '订单流水号',
  `note` text COMMENT '备注',
  `sell_uid` mediumint(8) unsigned NOT NULL COMMENT '商家id',
  `buy_uid` mediumint(8) unsigned NOT NULL COMMENT '卖家id',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '后台录入人uid',
  `bank_sn` bigint(15) unsigned NOT NULL COMMENT '银行卡号',
  `username` varchar(100) NOT NULL COMMENT '后台录入人账号',
  `bank_note` varchar(225) NOT NULL COMMENT '转账凭证图片',
  `bank_name` varchar(100) NOT NULL COMMENT '银行名称',
  `inputtime` int(10) unsigned NOT NULL COMMENT '录入时间',
  PRIMARY KEY (`id`),
  KEY `bank_sn` (`bank_sn`),
  KEY `oid` (`oid`),
  KEY `sn` (`sn`),
  KEY `sell_uid` (`sell_uid`),
  KEY `buy_uid` (`buy_uid`),
  KEY `uid` (`uid`),
  KEY `inputtime` (`inputtime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='转账受理表';



# Dump of table dr_1_page
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_page`;

CREATE TABLE `dr_1_page` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `module` varchar(20) NOT NULL COMMENT '模块dir',
  `pid` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '上级id',
  `pids` varchar(255) NOT NULL COMMENT '所有上级id',
  `name` varchar(255) NOT NULL COMMENT '单页名称',
  `dirname` varchar(30) NOT NULL COMMENT '栏目目录',
  `pdirname` varchar(100) NOT NULL COMMENT '上级目录',
  `child` tinyint(1) unsigned NOT NULL COMMENT '是否有子类',
  `childids` varchar(255) NOT NULL COMMENT '下级所有id',
  `thumb` varchar(255) NOT NULL COMMENT '缩略图',
  `title` varchar(255) NOT NULL COMMENT 'seo标题',
  `keywords` varchar(255) NOT NULL COMMENT 'seo关键字',
  `description` varchar(255) NOT NULL COMMENT 'seo描述',
  `content` mediumtext COMMENT '单页内容',
  `attachment` text COMMENT '附件信息',
  `template` varchar(30) NOT NULL COMMENT '模板文件',
  `urlrule` smallint(5) unsigned DEFAULT NULL COMMENT 'url规则id',
  `urllink` varchar(255) NOT NULL COMMENT 'url外链',
  `getchild` tinyint(1) unsigned NOT NULL COMMENT '将下级第一个菜单作为当前菜单',
  `show` tinyint(1) unsigned NOT NULL COMMENT '是否显示在菜单',
  `url` varchar(255) NOT NULL COMMENT 'url地址',
  `setting` mediumtext NOT NULL COMMENT '自定义内容',
  `displayorder` tinyint(2) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `mid` (`module`),
  KEY `pid` (`pid`),
  KEY `show` (`show`),
  KEY `displayorder` (`displayorder`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='单页表';

LOCK TABLES `dr_1_page` WRITE;
/*!40000 ALTER TABLE `dr_1_page` DISABLE KEYS */;

INSERT INTO `dr_1_page` (`id`, `module`, `pid`, `pids`, `name`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `title`, `keywords`, `description`, `content`, `attachment`, `template`, `urlrule`, `urllink`, `getchild`, `show`, `url`, `setting`, `displayorder`)
VALUES
	(1,'',0,'0','服务协议','fuwuxieyi','',0,'1','','服务协议','','','<p>服务协议服务协议服务协议</p><p>服务协议服务协议服务协议服务协议</p>','','page.html',0,'',1,1,'/index.php?c=page&id=1','',0);

/*!40000 ALTER TABLE `dr_1_page` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table dr_1_quan
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_quan`;

CREATE TABLE `dr_1_quan` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `catid` smallint(5) unsigned NOT NULL COMMENT '栏目id',
  `title` varchar(255) DEFAULT NULL COMMENT '主题',
  `thumb` varchar(255) DEFAULT NULL,
  `keywords` varchar(255) DEFAULT NULL COMMENT '关键字',
  `description` text COMMENT '描述',
  `hits` mediumint(8) unsigned DEFAULT NULL COMMENT '浏览数',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '作者id',
  `author` varchar(50) NOT NULL COMMENT '作者名称',
  `status` tinyint(2) NOT NULL COMMENT '状态',
  `url` varchar(255) DEFAULT NULL COMMENT '地址',
  `link_id` int(10) NOT NULL DEFAULT '0' COMMENT '同步id',
  `tableid` smallint(5) unsigned NOT NULL COMMENT '附表id',
  `inputip` varchar(15) DEFAULT NULL COMMENT '录入者ip',
  `inputtime` int(10) unsigned NOT NULL COMMENT '录入时间',
  `updatetime` int(10) unsigned NOT NULL COMMENT '更新时间',
  `comments` int(10) unsigned NOT NULL COMMENT '评论数量',
  `favorites` int(10) unsigned NOT NULL COMMENT '收藏数量',
  `displayorder` tinyint(3) NOT NULL DEFAULT '0',
  `order_price` decimal(10,2) DEFAULT NULL,
  `diqu` mediumint(8) unsigned DEFAULT NULL,
  `haoyoushuliang` varchar(255) DEFAULT NULL,
  `nianling` varchar(255) DEFAULT NULL,
  `xingbie` varchar(255) DEFAULT NULL,
  `haoyoujietu` varchar(255) DEFAULT NULL,
  `pinglunjietu` varchar(255) DEFAULT NULL,
  `haoyoumiaoshu` text,
  `xiadanbeizhu` text,
  `mingrenzhiye` varchar(222) DEFAULT NULL,
  `xingyezhiye` varchar(222) DEFAULT NULL,
  `price_zf` decimal(10,2) DEFAULT NULL,
  `price_fx` decimal(10,2) DEFAULT NULL,
  `isflag` varchar(255) DEFAULT NULL,
  `price_zf_sj` decimal(10,2) DEFAULT NULL,
  `price_fx_sj` decimal(10,2) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `catid` (`catid`,`updatetime`),
  KEY `link_id` (`link_id`),
  KEY `comments` (`comments`),
  KEY `favorites` (`favorites`),
  KEY `status` (`status`),
  KEY `hits` (`hits`),
  KEY `displayorder` (`displayorder`,`updatetime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='主表';



# Dump of table dr_1_quan_category
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_quan_category`;

CREATE TABLE `dr_1_quan_category` (
  `id` tinyint(3) unsigned NOT NULL AUTO_INCREMENT,
  `pid` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '上级id',
  `pids` varchar(255) NOT NULL COMMENT '所有上级id',
  `name` varchar(30) NOT NULL COMMENT '栏目名称',
  `letter` char(1) NOT NULL COMMENT '首字母',
  `dirname` varchar(30) NOT NULL COMMENT '栏目目录',
  `pdirname` varchar(100) NOT NULL COMMENT '上级目录',
  `child` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否有下级',
  `childids` text NOT NULL COMMENT '下级所有id',
  `thumb` varchar(255) NOT NULL COMMENT '栏目图片',
  `show` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '是否显示',
  `permission` text COMMENT '会员权限',
  `setting` text NOT NULL COMMENT '属性配置',
  `displayorder` tinyint(3) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `show` (`show`),
  KEY `module` (`pid`,`displayorder`,`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='栏目表';

LOCK TABLES `dr_1_quan_category` WRITE;
/*!40000 ALTER TABLE `dr_1_quan_category` DISABLE KEYS */;

INSERT INTO `dr_1_quan_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`)
VALUES
	(1,0,'0','名人朋友圈','m','mingrenpengyouquan','',0,'1','',1,NULL,'a:4:{s:4:\\\"edit\\\";s:1:\\\"0\\\";s:7:\\\"linkurl\\\";s:0:\\\"\\\";s:3:\\\"seo\\\";a:4:{s:10:\\\"show_title\\\";s:74:\\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\\";s:10:\\\"list_title\\\";s:58:\\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\\";s:13:\\\"list_keywords\\\";s:0:\\\"\\\";s:16:\\\"list_description\\\";s:0:\\\"\\\";}s:8:\\\"template\\\";a:5:{s:8:\\\"pagesize\\\";s:2:\\\"20\\\";s:4:\\\"show\\\";s:9:\\\"show.html\\\";s:8:\\\"category\\\";s:13:\\\"category.html\\\";s:4:\\\"list\\\";s:9:\\\"list.html\\\";s:6:\\\"search\\\";s:11:\\\"search.html\\\";}}',0),
	(2,0,'0','草根朋友圈','c','caogenpengyouquan','',0,'2','',1,'a:4:{s:3:\\\"4_5\\\";a:7:{s:3:\\\"add\\\";s:1:\\\"1\\\";s:4:\\\"edit\\\";s:1:\\\"1\\\";s:10:\\\"experience\\\";s:1:\\\"0\\\";s:5:\\\"score\\\";s:1:\\\"0\\\";s:7:\\\"postnum\\\";s:1:\\\"0\\\";s:6:\\\"verify\\\";s:1:\\\"1\\\";s:9:\\\"postcount\\\";s:1:\\\"0\\\";}s:3:\\\"4_6\\\";a:7:{s:3:\\\"add\\\";s:1:\\\"1\\\";s:4:\\\"edit\\\";s:1:\\\"1\\\";s:10:\\\"experience\\\";s:1:\\\"0\\\";s:5:\\\"score\\\";s:1:\\\"0\\\";s:7:\\\"postnum\\\";s:1:\\\"0\\\";s:6:\\\"verify\\\";s:1:\\\"1\\\";s:9:\\\"postcount\\\";s:1:\\\"0\\\";}s:3:\\\"4_7\\\";a:7:{s:3:\\\"add\\\";s:1:\\\"1\\\";s:4:\\\"edit\\\";s:1:\\\"1\\\";s:10:\\\"experience\\\";s:1:\\\"0\\\";s:5:\\\"score\\\";s:1:\\\"0\\\";s:7:\\\"postnum\\\";s:1:\\\"0\\\";s:6:\\\"verify\\\";s:1:\\\"1\\\";s:9:\\\"postcount\\\";s:1:\\\"0\\\";}s:3:\\\"4_8\\\";a:7:{s:3:\\\"add\\\";s:1:\\\"1\\\";s:4:\\\"edit\\\";s:1:\\\"1\\\";s:10:\\\"experience\\\";s:1:\\\"0\\\";s:5:\\\"score\\\";s:1:\\\"0\\\";s:7:\\\"postnum\\\";s:1:\\\"0\\\";s:6:\\\"verify\\\";s:1:\\\"1\\\";s:9:\\\"postcount\\\";s:1:\\\"0\\\";}}','a:6:{s:4:\\\"edit\\\";s:1:\\\"0\\\";s:7:\\\"linkurl\\\";s:0:\\\"\\\";s:3:\\\"seo\\\";a:4:{s:10:\\\"show_title\\\";s:74:\\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\\";s:10:\\\"list_title\\\";s:58:\\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\\";s:13:\\\"list_keywords\\\";s:0:\\\"\\\";s:16:\\\"list_description\\\";s:0:\\\"\\\";}s:8:\\\"template\\\";a:5:{s:8:\\\"pagesize\\\";s:2:\\\"20\\\";s:4:\\\"show\\\";s:9:\\\"show.html\\\";s:8:\\\"category\\\";s:13:\\\"category.html\\\";s:4:\\\"list\\\";s:9:\\\"list.html\\\";s:6:\\\"search\\\";s:11:\\\"search.html\\\";}s:5:\\\"admin\\\";a:0:{}s:6:\\\"member\\\";a:0:{}}',0);

/*!40000 ALTER TABLE `dr_1_quan_category` ENABLE KEYS */;
UNLOCK TABLES;



# Dump of table dr_1_quan_favorite
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_quan_favorite`;

CREATE TABLE `dr_1_quan_favorite` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `cid` int(10) unsigned NOT NULL COMMENT '文档id',
  `eid` int(10) unsigned DEFAULT NULL COMMENT '扩展id',
  `uid` mediumint(8) unsigned NOT NULL COMMENT 'uid',
  `url` varchar(255) NOT NULL COMMENT 'URL地址',
  `title` varchar(255) NOT NULL COMMENT '标题',
  `inputtime` int(10) unsigned NOT NULL COMMENT '录入时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `cid` (`cid`),
  KEY `eid` (`eid`),
  KEY `inputtime` (`inputtime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='收藏夹表';



# Dump of table dr_1_quan_flag
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_quan_flag`;

CREATE TABLE `dr_1_quan_flag` (
  `flag` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '文档标记id',
  `id` int(10) unsigned NOT NULL COMMENT '文档内容id',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '作者uid',
  `catid` tinyint(3) unsigned NOT NULL COMMENT '栏目id',
  KEY `flag` (`flag`,`id`,`uid`),
  KEY `catid` (`catid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='标记表';



# Dump of table dr_1_quan_hits
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_quan_hits`;

CREATE TABLE `dr_1_quan_hits` (
  `id` int(10) unsigned NOT NULL COMMENT '文章id',
  `hits` int(10) unsigned NOT NULL COMMENT '总点击数',
  `day_hits` int(10) unsigned NOT NULL COMMENT '本日点击',
  `week_hits` int(10) unsigned NOT NULL COMMENT '本周点击',
  `month_hits` int(10) unsigned NOT NULL COMMENT '本月点击',
  `year_hits` int(10) unsigned NOT NULL COMMENT '年点击量',
  UNIQUE KEY `id` (`id`),
  KEY `day_hits` (`day_hits`),
  KEY `week_hits` (`week_hits`),
  KEY `month_hits` (`month_hits`),
  KEY `year_hits` (`year_hits`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='时段点击量统计';

LOCK TABLES `dr_1_quan_hits` WRITE;
/*!40000 ALTER TABLE `dr_1_quan_hits` DISABLE KEYS */;

INSERT INTO `dr_1_quan_hits` (`id`, `hits`, `day_hits`, `week_hits`, `month_hits`, `year_hits`)
VALUES
	(1,1,1,2,2,1);

/*!40000 ALTER TABLE `dr_1_quan_hits` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table dr_1_quan_index
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_quan_index`;

CREATE TABLE `dr_1_quan_index` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` mediumint(8) unsigned NOT NULL COMMENT '作者uid',
  `catid` tinyint(3) unsigned NOT NULL COMMENT '栏目id',
  `status` tinyint(2) NOT NULL COMMENT '审核状态',
  `inputtime` int(10) unsigned NOT NULL COMMENT '录入时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `catid` (`catid`),
  KEY `status` (`status`),
  KEY `inputtime` (`inputtime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='内容索引表';



# Dump of table dr_1_quan_search
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_quan_search`;

CREATE TABLE `dr_1_quan_search` (
  `id` varchar(32) NOT NULL,
  `catid` tinyint(3) unsigned NOT NULL COMMENT '栏目id',
  `params` text NOT NULL COMMENT '参数数组',
  `keyword` varchar(255) NOT NULL COMMENT '关键字',
  `contentid` mediumtext NOT NULL COMMENT 'id集合',
  `inputtime` int(10) unsigned NOT NULL COMMENT '搜索时间',
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`),
  KEY `catid` (`catid`),
  KEY `keyword` (`keyword`),
  KEY `inputtime` (`inputtime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='搜索表';



# Dump of table dr_1_quan_search_index
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_quan_search_index`;

CREATE TABLE `dr_1_quan_search_index` (
  `id` varchar(32) NOT NULL,
  `cid` int(10) unsigned NOT NULL COMMENT '文档Id',
  `inputtime` int(10) unsigned NOT NULL COMMENT '搜索时间',
  KEY `id` (`id`),
  KEY `cid` (`cid`),
  KEY `inputtime` (`inputtime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='搜索索引表';

LOCK TABLES `dr_1_quan_search_index` WRITE;
/*!40000 ALTER TABLE `dr_1_quan_search_index` DISABLE KEYS */;

INSERT INTO `dr_1_quan_search_index` (`id`, `cid`, `inputtime`)
VALUES
	('c25d6e8945c57f783af257dcb7d00f22',1,1465205774);

/*!40000 ALTER TABLE `dr_1_quan_search_index` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table dr_1_quan_verify
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_quan_verify`;

CREATE TABLE `dr_1_quan_verify` (
  `id` int(10) unsigned NOT NULL,
  `catid` tinyint(3) unsigned NOT NULL COMMENT '栏目id',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '作者uid',
  `author` varchar(50) NOT NULL COMMENT '作者',
  `status` tinyint(2) NOT NULL COMMENT '审核状态',
  `content` mediumtext NOT NULL COMMENT '具体内容',
  `backuid` mediumint(8) unsigned NOT NULL COMMENT '操作人uid',
  `backinfo` text NOT NULL COMMENT '操作退回信息',
  `inputtime` int(10) unsigned NOT NULL COMMENT '录入时间',
  UNIQUE KEY `id` (`id`),
  KEY `uid` (`uid`),
  KEY `catid` (`catid`),
  KEY `status` (`status`),
  KEY `inputtime` (`inputtime`),
  KEY `backuid` (`backuid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='内容审核表';



# Dump of table dr_1_remote
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_remote`;

CREATE TABLE `dr_1_remote` (
  `id` tinyint(2) unsigned NOT NULL AUTO_INCREMENT,
  `url` varchar(255) NOT NULL,
  `type` tinyint(2) NOT NULL COMMENT '远程附件类型',
  `name` varchar(50) NOT NULL,
  `value` text NOT NULL,
  `exts` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='远程附件表';



# Dump of table dr_1_weibo
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_weibo`;

CREATE TABLE `dr_1_weibo` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `catid` smallint(5) unsigned NOT NULL COMMENT '栏目id',
  `title` varchar(255) DEFAULT NULL COMMENT '主题',
  `thumb` varchar(255) DEFAULT NULL,
  `keywords` varchar(255) DEFAULT NULL COMMENT '关键字',
  `description` text COMMENT '描述',
  `hits` mediumint(8) unsigned DEFAULT NULL COMMENT '浏览数',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '作者id',
  `author` varchar(50) NOT NULL COMMENT '作者名称',
  `status` tinyint(2) NOT NULL COMMENT '状态',
  `url` varchar(255) DEFAULT NULL COMMENT '地址',
  `link_id` int(10) NOT NULL DEFAULT '0' COMMENT '同步id',
  `tableid` smallint(5) unsigned NOT NULL COMMENT '附表id',
  `inputip` varchar(15) DEFAULT NULL COMMENT '录入者ip',
  `inputtime` int(10) unsigned NOT NULL COMMENT '录入时间',
  `updatetime` int(10) unsigned NOT NULL COMMENT '更新时间',
  `comments` int(10) unsigned NOT NULL COMMENT '评论数量',
  `favorites` int(10) unsigned NOT NULL COMMENT '收藏数量',
  `displayorder` tinyint(3) NOT NULL DEFAULT '0',
  `order_price` decimal(10,2) DEFAULT NULL,
  `fensishuliang` varchar(255) DEFAULT NULL,
  `diqu` mediumint(8) unsigned DEFAULT NULL,
  `mingrenzhiye` varchar(222) DEFAULT NULL,
  `meitilingyu` varchar(222) DEFAULT NULL,
  `changjianfenlei` varchar(222) DEFAULT NULL,
  `price_ygzf` decimal(10,2) DEFAULT NULL,
  `price_rgzf` decimal(10,2) DEFAULT NULL,
  `price_ygzf2` decimal(10,2) DEFAULT NULL,
  `price_rgzf2` decimal(10,2) DEFAULT NULL,
  `price_ygzf_sj` decimal(10,2) DEFAULT NULL,
  `price_rgzf_sj` decimal(10,2) DEFAULT NULL,
  `price_ygzf2_sj` decimal(10,2) DEFAULT NULL,
  `price_rgzf2_sj` decimal(10,2) DEFAULT NULL,
  `isflag` varchar(255) DEFAULT NULL,
  `weibodizhi` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `catid` (`catid`,`updatetime`),
  KEY `link_id` (`link_id`),
  KEY `comments` (`comments`),
  KEY `favorites` (`favorites`),
  KEY `status` (`status`),
  KEY `hits` (`hits`),
  KEY `displayorder` (`displayorder`,`updatetime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='主表';



# Dump of table dr_1_weibo_category
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_weibo_category`;

CREATE TABLE `dr_1_weibo_category` (
  `id` tinyint(3) unsigned NOT NULL AUTO_INCREMENT,
  `pid` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '上级id',
  `pids` varchar(255) NOT NULL COMMENT '所有上级id',
  `name` varchar(30) NOT NULL COMMENT '栏目名称',
  `letter` char(1) NOT NULL COMMENT '首字母',
  `dirname` varchar(30) NOT NULL COMMENT '栏目目录',
  `pdirname` varchar(100) NOT NULL COMMENT '上级目录',
  `child` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否有下级',
  `childids` text NOT NULL COMMENT '下级所有id',
  `thumb` varchar(255) NOT NULL COMMENT '栏目图片',
  `show` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '是否显示',
  `permission` text COMMENT '会员权限',
  `setting` text NOT NULL COMMENT '属性配置',
  `displayorder` tinyint(3) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `show` (`show`),
  KEY `module` (`pid`,`displayorder`,`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='栏目表';

LOCK TABLES `dr_1_weibo_category` WRITE;
/*!40000 ALTER TABLE `dr_1_weibo_category` DISABLE KEYS */;

INSERT INTO `dr_1_weibo_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`)
VALUES
	(1,0,'0','名人新浪微博','m','mingrenxinlangweibo','',0,'1','',1,NULL,'a:4:{s:4:\\\"edit\\\";s:1:\\\"0\\\";s:7:\\\"linkurl\\\";s:0:\\\"\\\";s:3:\\\"seo\\\";a:4:{s:10:\\\"show_title\\\";s:74:\\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\\";s:10:\\\"list_title\\\";s:58:\\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\\";s:13:\\\"list_keywords\\\";s:0:\\\"\\\";s:16:\\\"list_description\\\";s:0:\\\"\\\";}s:8:\\\"template\\\";a:5:{s:8:\\\"pagesize\\\";s:2:\\\"20\\\";s:4:\\\"show\\\";s:9:\\\"show.html\\\";s:8:\\\"category\\\";s:13:\\\"category.html\\\";s:4:\\\"list\\\";s:9:\\\"list.html\\\";s:6:\\\"search\\\";s:11:\\\"search.html\\\";}}',0),
	(2,0,'0','草根新浪微博','c','caogenxinlangweibo','',0,'2','',1,'a:1:{s:3:\\\"4_5\\\";a:7:{s:3:\\\"add\\\";s:1:\\\"1\\\";s:4:\\\"edit\\\";s:1:\\\"1\\\";s:10:\\\"experience\\\";s:1:\\\"0\\\";s:5:\\\"score\\\";s:1:\\\"0\\\";s:7:\\\"postnum\\\";s:1:\\\"0\\\";s:6:\\\"verify\\\";s:1:\\\"1\\\";s:9:\\\"postcount\\\";s:1:\\\"0\\\";}}','a:6:{s:4:\\\"edit\\\";s:1:\\\"0\\\";s:7:\\\"linkurl\\\";s:0:\\\"\\\";s:3:\\\"seo\\\";a:4:{s:10:\\\"show_title\\\";s:74:\\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\\";s:10:\\\"list_title\\\";s:58:\\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\\";s:13:\\\"list_keywords\\\";s:0:\\\"\\\";s:16:\\\"list_description\\\";s:0:\\\"\\\";}s:8:\\\"template\\\";a:5:{s:8:\\\"pagesize\\\";s:2:\\\"20\\\";s:4:\\\"show\\\";s:9:\\\"show.html\\\";s:8:\\\"category\\\";s:13:\\\"category.html\\\";s:4:\\\"list\\\";s:9:\\\"list.html\\\";s:6:\\\"search\\\";s:11:\\\"search.html\\\";}s:5:\\\"admin\\\";a:0:{}s:6:\\\"member\\\";a:0:{}}',0);

/*!40000 ALTER TABLE `dr_1_weibo_category` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table dr_1_weibo_favorite
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_weibo_favorite`;

CREATE TABLE `dr_1_weibo_favorite` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `cid` int(10) unsigned NOT NULL COMMENT '文档id',
  `eid` int(10) unsigned DEFAULT NULL COMMENT '扩展id',
  `uid` mediumint(8) unsigned NOT NULL COMMENT 'uid',
  `url` varchar(255) NOT NULL COMMENT 'URL地址',
  `title` varchar(255) NOT NULL COMMENT '标题',
  `inputtime` int(10) unsigned NOT NULL COMMENT '录入时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `cid` (`cid`),
  KEY `eid` (`eid`),
  KEY `inputtime` (`inputtime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='收藏夹表';



# Dump of table dr_1_weibo_flag
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_weibo_flag`;

CREATE TABLE `dr_1_weibo_flag` (
  `flag` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '文档标记id',
  `id` int(10) unsigned NOT NULL COMMENT '文档内容id',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '作者uid',
  `catid` tinyint(3) unsigned NOT NULL COMMENT '栏目id',
  KEY `flag` (`flag`,`id`,`uid`),
  KEY `catid` (`catid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='标记表';



# Dump of table dr_1_weibo_hits
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_weibo_hits`;

CREATE TABLE `dr_1_weibo_hits` (
  `id` int(10) unsigned NOT NULL COMMENT '文章id',
  `hits` int(10) unsigned NOT NULL COMMENT '总点击数',
  `day_hits` int(10) unsigned NOT NULL COMMENT '本日点击',
  `week_hits` int(10) unsigned NOT NULL COMMENT '本周点击',
  `month_hits` int(10) unsigned NOT NULL COMMENT '本月点击',
  `year_hits` int(10) unsigned NOT NULL COMMENT '年点击量',
  UNIQUE KEY `id` (`id`),
  KEY `day_hits` (`day_hits`),
  KEY `week_hits` (`week_hits`),
  KEY `month_hits` (`month_hits`),
  KEY `year_hits` (`year_hits`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='时段点击量统计';

LOCK TABLES `dr_1_weibo_hits` WRITE;
/*!40000 ALTER TABLE `dr_1_weibo_hits` DISABLE KEYS */;

INSERT INTO `dr_1_weibo_hits` (`id`, `hits`, `day_hits`, `week_hits`, `month_hits`, `year_hits`)
VALUES
	(1,1,1,2,2,1);

/*!40000 ALTER TABLE `dr_1_weibo_hits` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table dr_1_weibo_index
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_weibo_index`;

CREATE TABLE `dr_1_weibo_index` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` mediumint(8) unsigned NOT NULL COMMENT '作者uid',
  `catid` tinyint(3) unsigned NOT NULL COMMENT '栏目id',
  `status` tinyint(2) NOT NULL COMMENT '审核状态',
  `inputtime` int(10) unsigned NOT NULL COMMENT '录入时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `catid` (`catid`),
  KEY `status` (`status`),
  KEY `inputtime` (`inputtime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='内容索引表';



# Dump of table dr_1_weibo_search
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_weibo_search`;

CREATE TABLE `dr_1_weibo_search` (
  `id` varchar(32) NOT NULL,
  `catid` tinyint(3) unsigned NOT NULL COMMENT '栏目id',
  `params` text NOT NULL COMMENT '参数数组',
  `keyword` varchar(255) NOT NULL COMMENT '关键字',
  `contentid` mediumtext NOT NULL COMMENT 'id集合',
  `inputtime` int(10) unsigned NOT NULL COMMENT '搜索时间',
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`),
  KEY `catid` (`catid`),
  KEY `keyword` (`keyword`),
  KEY `inputtime` (`inputtime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='搜索表';



# Dump of table dr_1_weibo_search_index
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_weibo_search_index`;

CREATE TABLE `dr_1_weibo_search_index` (
  `id` varchar(32) NOT NULL,
  `cid` int(10) unsigned NOT NULL COMMENT '文档Id',
  `inputtime` int(10) unsigned NOT NULL COMMENT '搜索时间',
  KEY `id` (`id`),
  KEY `cid` (`cid`),
  KEY `inputtime` (`inputtime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='搜索索引表';


# Dump of table dr_1_weibo_verify
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_weibo_verify`;

CREATE TABLE `dr_1_weibo_verify` (
  `id` int(10) unsigned NOT NULL,
  `catid` tinyint(3) unsigned NOT NULL COMMENT '栏目id',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '作者uid',
  `author` varchar(50) NOT NULL COMMENT '作者',
  `status` tinyint(2) NOT NULL COMMENT '审核状态',
  `content` mediumtext NOT NULL COMMENT '具体内容',
  `backuid` mediumint(8) unsigned NOT NULL COMMENT '操作人uid',
  `backinfo` text NOT NULL COMMENT '操作退回信息',
  `inputtime` int(10) unsigned NOT NULL COMMENT '录入时间',
  UNIQUE KEY `id` (`id`),
  KEY `uid` (`uid`),
  KEY `catid` (`catid`),
  KEY `status` (`status`),
  KEY `inputtime` (`inputtime`),
  KEY `backuid` (`backuid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='内容审核表';



# Dump of table dr_1_weixin
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_weixin`;

CREATE TABLE IF NOT EXISTS `dr_1_weixin` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `catid` smallint(5) unsigned NOT NULL COMMENT '栏目id',
  `title` varchar(255) DEFAULT NULL,
  `thumb` varchar(255) DEFAULT NULL,
  `keywords` varchar(255) DEFAULT NULL COMMENT '关键字',
  `description` text COMMENT '描述',
  `hits` mediumint(8) unsigned DEFAULT NULL COMMENT '浏览数',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '作者id',
  `author` varchar(50) NOT NULL COMMENT '作者名称',
  `status` tinyint(2) NOT NULL COMMENT '状态',
  `url` varchar(255) DEFAULT NULL COMMENT '地址',
  `link_id` int(10) NOT NULL DEFAULT '0' COMMENT '同步id',
  `tableid` smallint(5) unsigned NOT NULL COMMENT '附表id',
  `inputip` varchar(15) DEFAULT NULL COMMENT '录入者ip',
  `inputtime` int(10) unsigned NOT NULL COMMENT '录入时间',
  `updatetime` int(10) unsigned NOT NULL COMMENT '更新时间',
  `comments` int(10) unsigned NOT NULL COMMENT '评论数量',
  `favorites` int(10) unsigned NOT NULL COMMENT '收藏数量',
  `displayorder` tinyint(3) NOT NULL DEFAULT '0',
  `order_price` decimal(10,2) DEFAULT NULL,
  `fensishuliang` varchar(255) DEFAULT NULL,
  `diqufenbu` mediumint(8) unsigned DEFAULT NULL,
  `meitilingyu` varchar(222) DEFAULT NULL,
  `changjianfenlei` varchar(222) DEFAULT NULL,
  `weixinhao` varchar(255) DEFAULT NULL,
  `xiadanbeizhu` varchar(255) DEFAULT NULL,
  `erweima` varchar(255) DEFAULT NULL,
  `fensijietu` varchar(255) DEFAULT NULL,
  `price_dttt` decimal(10,2) DEFAULT NULL,
  `price_dtct` decimal(10,2) DEFAULT NULL,
  `price_dnt` decimal(10,2) DEFAULT NULL,
  `isflag` varchar(255) DEFAULT NULL,
  `price_dttt_sj` decimal(10,2) DEFAULT NULL,
  `price_dtct_sj` decimal(10,2) DEFAULT NULL,
  `price_dnt_sj` decimal(10,2) DEFAULT NULL,
  `cankaoyuedu` varchar(255) DEFAULT NULL,
  `zhoupinlu` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `catid` (`catid`,`updatetime`),
  KEY `link_id` (`link_id`),
  KEY `comments` (`comments`),
  KEY `favorites` (`favorites`),
  KEY `status` (`status`),
  KEY `hits` (`hits`),
  KEY `displayorder` (`displayorder`,`updatetime`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 COMMENT='主表';



# Dump of table dr_1_weixin_category
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_weixin_category`;

CREATE TABLE `dr_1_weixin_category` (
  `id` tinyint(3) unsigned NOT NULL AUTO_INCREMENT,
  `pid` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '上级id',
  `pids` varchar(255) NOT NULL COMMENT '所有上级id',
  `name` varchar(30) NOT NULL COMMENT '栏目名称',
  `letter` char(1) NOT NULL COMMENT '首字母',
  `dirname` varchar(30) NOT NULL COMMENT '栏目目录',
  `pdirname` varchar(100) NOT NULL COMMENT '上级目录',
  `child` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否有下级',
  `childids` text NOT NULL COMMENT '下级所有id',
  `thumb` varchar(255) NOT NULL COMMENT '栏目图片',
  `show` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '是否显示',
  `permission` text COMMENT '会员权限',
  `setting` text NOT NULL COMMENT '属性配置',
  `displayorder` tinyint(3) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `show` (`show`),
  KEY `module` (`pid`,`displayorder`,`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='栏目表';

LOCK TABLES `dr_1_weixin_category` WRITE;
/*!40000 ALTER TABLE `dr_1_weixin_category` DISABLE KEYS */;

INSERT INTO `dr_1_weixin_category` (`id`, `pid`, `pids`, `name`, `letter`, `dirname`, `pdirname`, `child`, `childids`, `thumb`, `show`, `permission`, `setting`, `displayorder`)
VALUES
	(1,0,'0','名人微信','m','mingrenweixin','',0,'1','',1,'a:4:{s:3:\\\"4_5\\\";a:5:{s:10:\\\"experience\\\";s:1:\\\"0\\\";s:5:\\\"score\\\";s:1:\\\"0\\\";s:7:\\\"postnum\\\";s:1:\\\"0\\\";s:6:\\\"verify\\\";s:1:\\\"1\\\";s:9:\\\"postcount\\\";s:1:\\\"0\\\";}s:3:\\\"4_6\\\";a:5:{s:10:\\\"experience\\\";s:1:\\\"0\\\";s:5:\\\"score\\\";s:1:\\\"0\\\";s:7:\\\"postnum\\\";s:1:\\\"0\\\";s:6:\\\"verify\\\";s:1:\\\"1\\\";s:9:\\\"postcount\\\";s:1:\\\"0\\\";}s:3:\\\"4_7\\\";a:5:{s:10:\\\"experience\\\";s:1:\\\"0\\\";s:5:\\\"score\\\";s:1:\\\"0\\\";s:7:\\\"postnum\\\";s:1:\\\"0\\\";s:6:\\\"verify\\\";s:1:\\\"1\\\";s:9:\\\"postcount\\\";s:1:\\\"0\\\";}s:3:\\\"4_8\\\";a:5:{s:10:\\\"experience\\\";s:1:\\\"0\\\";s:5:\\\"score\\\";s:1:\\\"0\\\";s:7:\\\"postnum\\\";s:1:\\\"0\\\";s:6:\\\"verify\\\";s:1:\\\"1\\\";s:9:\\\"postcount\\\";s:1:\\\"0\\\";}}','a:6:{s:4:\\\"edit\\\";s:1:\\\"0\\\";s:7:\\\"linkurl\\\";s:0:\\\"\\\";s:3:\\\"seo\\\";a:4:{s:10:\\\"show_title\\\";s:74:\\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\\";s:10:\\\"list_title\\\";s:58:\\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\\";s:13:\\\"list_keywords\\\";s:0:\\\"\\\";s:16:\\\"list_description\\\";s:0:\\\"\\\";}s:8:\\\"template\\\";a:5:{s:8:\\\"pagesize\\\";s:2:\\\"20\\\";s:4:\\\"show\\\";s:9:\\\"show.html\\\";s:8:\\\"category\\\";s:13:\\\"category.html\\\";s:4:\\\"list\\\";s:9:\\\"list.html\\\";s:6:\\\"search\\\";s:11:\\\"search.html\\\";}s:5:\\\"admin\\\";a:0:{}s:6:\\\"member\\\";a:0:{}}',0),
	(2,0,'0','草根微信','c','caogenweixin','',0,'2','',1,'a:4:{s:3:\\\"4_5\\\";a:7:{s:3:\\\"add\\\";s:1:\\\"1\\\";s:4:\\\"edit\\\";s:1:\\\"1\\\";s:10:\\\"experience\\\";s:1:\\\"0\\\";s:5:\\\"score\\\";s:1:\\\"0\\\";s:7:\\\"postnum\\\";s:1:\\\"0\\\";s:6:\\\"verify\\\";s:1:\\\"1\\\";s:9:\\\"postcount\\\";s:1:\\\"0\\\";}s:3:\\\"4_6\\\";a:7:{s:3:\\\"add\\\";s:1:\\\"1\\\";s:4:\\\"edit\\\";s:1:\\\"1\\\";s:10:\\\"experience\\\";s:1:\\\"0\\\";s:5:\\\"score\\\";s:1:\\\"0\\\";s:7:\\\"postnum\\\";s:1:\\\"0\\\";s:6:\\\"verify\\\";s:1:\\\"1\\\";s:9:\\\"postcount\\\";s:1:\\\"0\\\";}s:3:\\\"4_7\\\";a:7:{s:3:\\\"add\\\";s:1:\\\"1\\\";s:4:\\\"edit\\\";s:1:\\\"1\\\";s:10:\\\"experience\\\";s:1:\\\"0\\\";s:5:\\\"score\\\";s:1:\\\"0\\\";s:7:\\\"postnum\\\";s:1:\\\"0\\\";s:6:\\\"verify\\\";s:1:\\\"1\\\";s:9:\\\"postcount\\\";s:1:\\\"0\\\";}s:3:\\\"4_8\\\";a:7:{s:3:\\\"add\\\";s:1:\\\"1\\\";s:4:\\\"edit\\\";s:1:\\\"1\\\";s:10:\\\"experience\\\";s:1:\\\"0\\\";s:5:\\\"score\\\";s:1:\\\"0\\\";s:7:\\\"postnum\\\";s:1:\\\"0\\\";s:6:\\\"verify\\\";s:1:\\\"1\\\";s:9:\\\"postcount\\\";s:1:\\\"0\\\";}}','a:6:{s:4:\\\"edit\\\";s:1:\\\"0\\\";s:7:\\\"linkurl\\\";s:0:\\\"\\\";s:3:\\\"seo\\\";a:4:{s:10:\\\"show_title\\\";s:74:\\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\\";s:10:\\\"list_title\\\";s:58:\\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\\";s:13:\\\"list_keywords\\\";s:0:\\\"\\\";s:16:\\\"list_description\\\";s:0:\\\"\\\";}s:8:\\\"template\\\";a:5:{s:8:\\\"pagesize\\\";s:2:\\\"20\\\";s:4:\\\"show\\\";s:9:\\\"show.html\\\";s:8:\\\"category\\\";s:13:\\\"category.html\\\";s:4:\\\"list\\\";s:9:\\\"list.html\\\";s:6:\\\"search\\\";s:11:\\\"search.html\\\";}s:5:\\\"admin\\\";a:0:{}s:6:\\\"member\\\";a:0:{}}',0);


UNLOCK TABLES;

DROP TABLE IF EXISTS `dr_1_weixin_favorite`;

CREATE TABLE `dr_1_weixin_favorite` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `cid` int(10) unsigned NOT NULL COMMENT '文档id',
  `eid` int(10) unsigned DEFAULT NULL COMMENT '扩展id',
  `uid` mediumint(8) unsigned NOT NULL COMMENT 'uid',
  `url` varchar(255) NOT NULL COMMENT 'URL地址',
  `title` varchar(255) NOT NULL COMMENT '标题',
  `inputtime` int(10) unsigned NOT NULL COMMENT '录入时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `cid` (`cid`),
  KEY `eid` (`eid`),
  KEY `inputtime` (`inputtime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='收藏夹表';



# Dump of table dr_1_weixin_flag
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_weixin_flag`;

CREATE TABLE `dr_1_weixin_flag` (
  `flag` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '文档标记id',
  `id` int(10) unsigned NOT NULL COMMENT '文档内容id',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '作者uid',
  `catid` tinyint(3) unsigned NOT NULL COMMENT '栏目id',
  KEY `flag` (`flag`,`id`,`uid`),
  KEY `catid` (`catid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='标记表';



# Dump of table dr_1_weixin_hits
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_weixin_hits`;

CREATE TABLE `dr_1_weixin_hits` (
  `id` int(10) unsigned NOT NULL COMMENT '文章id',
  `hits` int(10) unsigned NOT NULL COMMENT '总点击数',
  `day_hits` int(10) unsigned NOT NULL COMMENT '本日点击',
  `week_hits` int(10) unsigned NOT NULL COMMENT '本周点击',
  `month_hits` int(10) unsigned NOT NULL COMMENT '本月点击',
  `year_hits` int(10) unsigned NOT NULL COMMENT '年点击量',
  UNIQUE KEY `id` (`id`),
  KEY `day_hits` (`day_hits`),
  KEY `week_hits` (`week_hits`),
  KEY `month_hits` (`month_hits`),
  KEY `year_hits` (`year_hits`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='时段点击量统计';



# Dump of table dr_1_weixin_index
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_weixin_index`;

CREATE TABLE `dr_1_weixin_index` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` mediumint(8) unsigned NOT NULL COMMENT '作者uid',
  `catid` tinyint(3) unsigned NOT NULL COMMENT '栏目id',
  `status` tinyint(2) NOT NULL COMMENT '审核状态',
  `inputtime` int(10) unsigned NOT NULL COMMENT '录入时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `catid` (`catid`),
  KEY `status` (`status`),
  KEY `inputtime` (`inputtime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='内容索引表';



# Dump of table dr_1_weixin_search
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_weixin_search`;

CREATE TABLE `dr_1_weixin_search` (
  `id` varchar(32) NOT NULL,
  `catid` tinyint(3) unsigned NOT NULL COMMENT '栏目id',
  `params` text NOT NULL COMMENT '参数数组',
  `keyword` varchar(255) NOT NULL COMMENT '关键字',
  `contentid` mediumtext NOT NULL COMMENT 'id集合',
  `inputtime` int(10) unsigned NOT NULL COMMENT '搜索时间',
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`),
  KEY `catid` (`catid`),
  KEY `keyword` (`keyword`),
  KEY `inputtime` (`inputtime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='搜索表';



# Dump of table dr_1_weixin_search_index
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_weixin_search_index`;

CREATE TABLE `dr_1_weixin_search_index` (
  `id` varchar(32) NOT NULL,
  `cid` int(10) unsigned NOT NULL COMMENT '文档Id',
  `inputtime` int(10) unsigned NOT NULL COMMENT '搜索时间',
  KEY `id` (`id`),
  KEY `cid` (`cid`),
  KEY `inputtime` (`inputtime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='搜索索引表';



# Dump of table dr_1_weixin_verify
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_1_weixin_verify`;

CREATE TABLE `dr_1_weixin_verify` (
  `id` int(10) unsigned NOT NULL,
  `catid` tinyint(3) unsigned NOT NULL COMMENT '栏目id',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '作者uid',
  `author` varchar(50) NOT NULL COMMENT '作者',
  `status` tinyint(2) NOT NULL COMMENT '审核状态',
  `content` mediumtext NOT NULL COMMENT '具体内容',
  `backuid` mediumint(8) unsigned NOT NULL COMMENT '操作人uid',
  `backinfo` text NOT NULL COMMENT '操作退回信息',
  `inputtime` int(10) unsigned NOT NULL COMMENT '录入时间',
  UNIQUE KEY `id` (`id`),
  KEY `uid` (`uid`),
  KEY `catid` (`catid`),
  KEY `status` (`status`),
  KEY `inputtime` (`inputtime`),
  KEY `backuid` (`backuid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='内容审核表';



# Dump of table dr_admin
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_admin`;

CREATE TABLE `dr_admin` (
  `uid` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `realname` varchar(50) DEFAULT NULL COMMENT '管理员姓名',
  `usermenu` text COMMENT '自定义面板菜单，序列化数组格式',
  `color` varchar(50) DEFAULT NULL COMMENT '后台主题',
  PRIMARY KEY (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='管理员表';

LOCK TABLES `dr_admin` WRITE;
/*!40000 ALTER TABLE `dr_admin` DISABLE KEYS */;

INSERT INTO `dr_admin` (`uid`, `realname`, `usermenu`, `color`)
VALUES
	(1,'网站创始人','','light');

/*!40000 ALTER TABLE `dr_admin` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table dr_admin_login
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_admin_login`;

CREATE TABLE `dr_admin_login` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` mediumint(8) unsigned DEFAULT NULL COMMENT '会员uid',
  `loginip` varchar(50) NOT NULL COMMENT '登录Ip',
  `logintime` int(10) unsigned NOT NULL COMMENT '登录时间',
  `useragent` varchar(255) NOT NULL COMMENT '客户端信息',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `loginip` (`loginip`),
  KEY `logintime` (`logintime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='登录日志记录';



# Dump of table dr_admin_menu
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_admin_menu`;

CREATE TABLE `dr_admin_menu` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `pid` smallint(5) unsigned NOT NULL COMMENT '上级菜单id',
  `name` text NOT NULL COMMENT '菜单语言名称',
  `uri` varchar(255) DEFAULT NULL COMMENT 'uri字符串',
  `url` varchar(255) DEFAULT NULL COMMENT '外链地址',
  `mark` varchar(20) DEFAULT NULL COMMENT '菜单标识',
  `hidden` tinyint(1) unsigned DEFAULT NULL COMMENT '是否隐藏',
  `displayorder` tinyint(3) unsigned DEFAULT NULL COMMENT '排序值',
  `icon` varchar(255) DEFAULT NULL COMMENT '图标标示',
  PRIMARY KEY (`id`),
  KEY `list` (`pid`),
  KEY `displayorder` (`displayorder`),
  KEY `mark` (`mark`),
  KEY `hidden` (`hidden`),
  KEY `uri` (`uri`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='后台菜单表';



# Dump of table dr_admin_role
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_admin_role`;

CREATE TABLE `dr_admin_role` (
  `id` smallint(5) NOT NULL AUTO_INCREMENT,
  `site` varchar(255) NOT NULL COMMENT '允许管理的站点，序列化数组格式',
  `name` text NOT NULL COMMENT '角色组语言名称',
  `system` text NOT NULL COMMENT '系统权限',
  `module` text NOT NULL COMMENT '模块权限',
  `application` text NOT NULL COMMENT '应用权限',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='后台角色权限表';

LOCK TABLES `dr_admin_role` WRITE;
/*!40000 ALTER TABLE `dr_admin_role` DISABLE KEYS */;

INSERT INTO `dr_admin_role` (`id`, `site`, `name`, `system`, `module`, `application`)
VALUES
	(1,'','超级管理员','','',''),
	(2,'','网站编辑员','','','');

/*!40000 ALTER TABLE `dr_admin_role` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table dr_admin_verify
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_admin_verify`;

CREATE TABLE `dr_admin_verify` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `name` text NOT NULL COMMENT '名称',
  `verify` text NOT NULL COMMENT '审核部署',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='审核管理表';

LOCK TABLES `dr_admin_verify` WRITE;
/*!40000 ALTER TABLE `dr_admin_verify` DISABLE KEYS */;

INSERT INTO `dr_admin_verify` (`id`, `name`, `verify`)
VALUES
	(1,'审核一次','a:1:{i:1;a:2:{i:0;s:1:\\\"2\\\";i:1;s:1:\\\"3\\\";}}');

/*!40000 ALTER TABLE `dr_admin_verify` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table dr_application
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_application`;

CREATE TABLE `dr_application` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `module` text COMMENT '模块划分',
  `dirname` varchar(50) NOT NULL COMMENT '目录名称',
  `setting` text COMMENT '配置信息',
  `disabled` tinyint(1) DEFAULT '0' COMMENT '是否禁用',
  PRIMARY KEY (`id`),
  UNIQUE KEY `dirname` (`dirname`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='应用表';

LOCK TABLES `dr_application` WRITE;
/*!40000 ALTER TABLE `dr_application` DISABLE KEYS */;

INSERT INTO `dr_application` (`id`, `module`, `dirname`, `setting`, `disabled`)
VALUES
	(1,'','cash','',0);

/*!40000 ALTER TABLE `dr_application` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table dr_attachment
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_attachment`;

CREATE TABLE `dr_attachment` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `uid` mediumint(8) unsigned NOT NULL COMMENT '会员id',
  `author` varchar(50) NOT NULL COMMENT '会员',
  `siteid` tinyint(3) unsigned NOT NULL COMMENT '站点id',
  `related` varchar(50) NOT NULL COMMENT '相关表标识',
  `tableid` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '附件副表id',
  `download` mediumint(8) NOT NULL DEFAULT '0' COMMENT '下载次数',
  `filesize` int(10) unsigned NOT NULL COMMENT '文件大小',
  `fileext` varchar(20) NOT NULL COMMENT '文件扩展名',
  `filemd5` varchar(50) NOT NULL COMMENT '文件md5值',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `author` (`author`),
  KEY `relatedtid` (`related`),
  KEY `fileext` (`fileext`),
  KEY `filemd5` (`filemd5`),
  KEY `siteid` (`siteid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='附件表';



# Dump of table dr_attachment_0
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_attachment_0`;

CREATE TABLE `dr_attachment_0` (
  `id` mediumint(8) unsigned NOT NULL COMMENT '附件id',
  `uid` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '会员id',
  `author` varchar(50) NOT NULL COMMENT '会员',
  `related` varchar(50) NOT NULL COMMENT '相关表标识',
  `filename` varchar(255) NOT NULL DEFAULT '' COMMENT '原文件名',
  `fileext` varchar(20) NOT NULL COMMENT '文件扩展名',
  `filesize` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '文件大小',
  `attachment` varchar(255) NOT NULL DEFAULT '' COMMENT '服务器路径',
  `remote` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '远程附件id',
  `attachinfo` text NOT NULL COMMENT '附件信息',
  `inputtime` int(10) unsigned NOT NULL COMMENT '入库时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='附件表0';



# Dump of table dr_attachment_1
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_attachment_1`;

CREATE TABLE `dr_attachment_1` (
  `id` mediumint(8) unsigned NOT NULL COMMENT '附件id',
  `uid` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '会员id',
  `author` varchar(50) NOT NULL COMMENT '会员',
  `related` varchar(50) NOT NULL COMMENT '相关表标识',
  `filename` varchar(255) NOT NULL DEFAULT '' COMMENT '原文件名',
  `fileext` varchar(20) NOT NULL COMMENT '文件扩展名',
  `filesize` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '文件大小',
  `attachment` varchar(255) NOT NULL DEFAULT '' COMMENT '服务器路径',
  `remote` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '远程附件id',
  `attachinfo` text NOT NULL COMMENT '附件信息',
  `inputtime` int(10) unsigned NOT NULL COMMENT '入库时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='附件表1';



# Dump of table dr_attachment_2
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_attachment_2`;

CREATE TABLE `dr_attachment_2` (
  `id` mediumint(8) unsigned NOT NULL COMMENT '附件id',
  `uid` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '会员id',
  `author` varchar(50) NOT NULL COMMENT '会员',
  `related` varchar(50) NOT NULL COMMENT '相关表标识',
  `filename` varchar(255) NOT NULL DEFAULT '' COMMENT '原文件名',
  `fileext` varchar(20) NOT NULL COMMENT '文件扩展名',
  `filesize` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '文件大小',
  `attachment` varchar(255) NOT NULL DEFAULT '' COMMENT '服务器路径',
  `remote` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '远程附件id',
  `attachinfo` text NOT NULL COMMENT '附件信息',
  `inputtime` int(10) unsigned NOT NULL COMMENT '入库时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='附件表2';



# Dump of table dr_attachment_3
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_attachment_3`;

CREATE TABLE `dr_attachment_3` (
  `id` mediumint(8) unsigned NOT NULL COMMENT '附件id',
  `uid` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '会员id',
  `author` varchar(50) NOT NULL COMMENT '会员',
  `related` varchar(50) NOT NULL COMMENT '相关表标识',
  `filename` varchar(255) NOT NULL DEFAULT '' COMMENT '原文件名',
  `fileext` varchar(20) NOT NULL COMMENT '文件扩展名',
  `filesize` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '文件大小',
  `attachment` varchar(255) NOT NULL DEFAULT '' COMMENT '服务器路径',
  `remote` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '远程附件id',
  `attachinfo` text NOT NULL COMMENT '附件信息',
  `inputtime` int(10) unsigned NOT NULL COMMENT '入库时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='附件表3';



# Dump of table dr_attachment_4
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_attachment_4`;

CREATE TABLE `dr_attachment_4` (
  `id` mediumint(8) unsigned NOT NULL COMMENT '附件id',
  `uid` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '会员id',
  `author` varchar(50) NOT NULL COMMENT '会员',
  `related` varchar(50) NOT NULL COMMENT '相关表标识',
  `filename` varchar(255) NOT NULL DEFAULT '' COMMENT '原文件名',
  `fileext` varchar(20) NOT NULL COMMENT '文件扩展名',
  `filesize` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '文件大小',
  `attachment` varchar(255) NOT NULL DEFAULT '' COMMENT '服务器路径',
  `remote` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '远程附件id',
  `attachinfo` text NOT NULL COMMENT '附件信息',
  `inputtime` int(10) unsigned NOT NULL COMMENT '入库时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='附件表4';



# Dump of table dr_attachment_5
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_attachment_5`;

CREATE TABLE `dr_attachment_5` (
  `id` mediumint(8) unsigned NOT NULL COMMENT '附件id',
  `uid` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '会员id',
  `author` varchar(50) NOT NULL COMMENT '会员',
  `related` varchar(50) NOT NULL COMMENT '相关表标识',
  `filename` varchar(255) NOT NULL DEFAULT '' COMMENT '原文件名',
  `fileext` varchar(20) NOT NULL COMMENT '文件扩展名',
  `filesize` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '文件大小',
  `attachment` varchar(255) NOT NULL DEFAULT '' COMMENT '服务器路径',
  `remote` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '远程附件id',
  `attachinfo` text NOT NULL COMMENT '附件信息',
  `inputtime` int(10) unsigned NOT NULL COMMENT '入库时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='附件表5';



# Dump of table dr_attachment_6
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_attachment_6`;

CREATE TABLE `dr_attachment_6` (
  `id` mediumint(8) unsigned NOT NULL COMMENT '附件id',
  `uid` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '会员id',
  `author` varchar(50) NOT NULL COMMENT '会员',
  `related` varchar(50) NOT NULL COMMENT '相关表标识',
  `filename` varchar(255) NOT NULL DEFAULT '' COMMENT '原文件名',
  `fileext` varchar(20) NOT NULL COMMENT '文件扩展名',
  `filesize` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '文件大小',
  `attachment` varchar(255) NOT NULL DEFAULT '' COMMENT '服务器路径',
  `remote` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '远程附件id',
  `attachinfo` text NOT NULL COMMENT '附件信息',
  `inputtime` int(10) unsigned NOT NULL COMMENT '入库时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='附件表6';



# Dump of table dr_attachment_7
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_attachment_7`;

CREATE TABLE `dr_attachment_7` (
  `id` mediumint(8) unsigned NOT NULL COMMENT '附件id',
  `uid` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '会员id',
  `author` varchar(50) NOT NULL COMMENT '会员',
  `related` varchar(50) NOT NULL COMMENT '相关表标识',
  `filename` varchar(255) NOT NULL DEFAULT '' COMMENT '原文件名',
  `fileext` varchar(20) NOT NULL COMMENT '文件扩展名',
  `filesize` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '文件大小',
  `attachment` varchar(255) NOT NULL DEFAULT '' COMMENT '服务器路径',
  `remote` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '远程附件id',
  `attachinfo` text NOT NULL COMMENT '附件信息',
  `inputtime` int(10) unsigned NOT NULL COMMENT '入库时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='附件表7';



# Dump of table dr_attachment_8
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_attachment_8`;

CREATE TABLE `dr_attachment_8` (
  `id` mediumint(8) unsigned NOT NULL COMMENT '附件id',
  `uid` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '会员id',
  `author` varchar(50) NOT NULL COMMENT '会员',
  `related` varchar(50) NOT NULL COMMENT '相关表标识',
  `filename` varchar(255) NOT NULL DEFAULT '' COMMENT '原文件名',
  `fileext` varchar(20) NOT NULL COMMENT '文件扩展名',
  `filesize` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '文件大小',
  `attachment` varchar(255) NOT NULL DEFAULT '' COMMENT '服务器路径',
  `remote` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '远程附件id',
  `attachinfo` text NOT NULL COMMENT '附件信息',
  `inputtime` int(10) unsigned NOT NULL COMMENT '入库时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='附件表8';



# Dump of table dr_attachment_9
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_attachment_9`;

CREATE TABLE `dr_attachment_9` (
  `id` mediumint(8) unsigned NOT NULL COMMENT '附件id',
  `uid` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '会员id',
  `author` varchar(50) NOT NULL COMMENT '会员',
  `related` varchar(50) NOT NULL COMMENT '相关表标识',
  `filename` varchar(255) NOT NULL DEFAULT '' COMMENT '原文件名',
  `fileext` varchar(20) NOT NULL COMMENT '文件扩展名',
  `filesize` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '文件大小',
  `attachment` varchar(255) NOT NULL DEFAULT '' COMMENT '服务器路径',
  `remote` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '远程附件id',
  `attachinfo` text NOT NULL COMMENT '附件信息',
  `inputtime` int(10) unsigned NOT NULL COMMENT '入库时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='附件表9';



# Dump of table dr_attachment_unused
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_attachment_unused`;

CREATE TABLE `dr_attachment_unused` (
  `id` mediumint(8) unsigned NOT NULL COMMENT '附件id',
  `uid` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '会员id',
  `author` varchar(50) NOT NULL COMMENT '会员',
  `siteid` tinyint(3) unsigned NOT NULL COMMENT '站点id',
  `filename` varchar(255) NOT NULL DEFAULT '' COMMENT '原文件名',
  `fileext` varchar(20) NOT NULL COMMENT '文件扩展名',
  `filesize` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '文件大小',
  `attachment` varchar(255) NOT NULL DEFAULT '' COMMENT '服务器路径',
  `remote` tinyint(2) unsigned NOT NULL DEFAULT '0' COMMENT '远程附件id',
  `attachinfo` text NOT NULL COMMENT '附件信息',
  `inputtime` int(10) unsigned NOT NULL COMMENT '入库时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `author` (`author`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='未使用的附件表';



# Dump of table dr_comment
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_comment`;

CREATE TABLE `dr_comment` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL COMMENT '名称',
  `value` text COMMENT '配置信息',
  `field` text COMMENT '自定义字段信息',
  PRIMARY KEY (`id`),
  KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='评论配置表';



# Dump of table dr_controller
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_controller`;

CREATE TABLE `dr_controller` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL COMMENT '名称',
  `app` varchar(100) NOT NULL COMMENT '网站,会员,后台',
  `type` tinyint(1) unsigned NOT NULL COMMENT '前台0会员1后台2',
  `cname` varchar(100) NOT NULL COMMENT '控制器名称',
  `file` varchar(100) NOT NULL COMMENT '文件路径',
  `url` varchar(255) NOT NULL COMMENT '访问地址',
  `meta_title` varchar(255) NOT NULL COMMENT '网页标题',
  `meta_keywords` varchar(255) NOT NULL COMMENT '网页关键字',
  `meta_description` varchar(255) NOT NULL COMMENT '网页描述',
  `inputtime` int(10) unsigned NOT NULL COMMENT '录入时间',
  PRIMARY KEY (`id`),
  KEY `inputtime` (`inputtime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='自定义控制器表';



# Dump of table dr_cron_queue
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_cron_queue`;

CREATE TABLE `dr_cron_queue` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `type` tinyint(2) unsigned NOT NULL COMMENT '类型',
  `value` text NOT NULL COMMENT '值',
  `status` tinyint(1) unsigned NOT NULL COMMENT '状态',
  `error` varchar(255) NOT NULL COMMENT '错误信息',
  `updatetime` int(10) unsigned NOT NULL COMMENT '执行时间',
  `inputtime` int(10) unsigned NOT NULL COMMENT '写入时间',
  PRIMARY KEY (`id`),
  KEY `type` (`type`),
  KEY `status` (`status`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='任务队列表';



# Dump of table dr_downservers
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_downservers`;

CREATE TABLE `dr_downservers` (
  `id` tinyint(3) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL COMMENT '服务器名',
  `server` varchar(255) NOT NULL COMMENT '服务器地址',
  `displayorder` tinyint(3) NOT NULL COMMENT '排序值',
  PRIMARY KEY (`id`),
  KEY `displayorder` (`displayorder`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='下载镜像服务器';



# Dump of table dr_field
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_field`;

CREATE TABLE `dr_field` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `name` text NOT NULL COMMENT '字段别名语言',
  `fieldname` varchar(50) NOT NULL COMMENT '字段名称',
  `fieldtype` varchar(50) NOT NULL COMMENT '字段类型',
  `relatedid` smallint(5) unsigned NOT NULL COMMENT '相关id',
  `relatedname` varchar(20) NOT NULL COMMENT '相关表',
  `isedit` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '是否可修改',
  `ismain` tinyint(1) unsigned NOT NULL COMMENT '是否主表',
  `issystem` tinyint(1) unsigned NOT NULL COMMENT '是否系统表',
  `ismember` tinyint(1) unsigned NOT NULL COMMENT '是否会员可见',
  `issearch` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '是否可搜索',
  `disabled` tinyint(1) unsigned NOT NULL COMMENT '禁用？',
  `setting` text NOT NULL COMMENT '配置信息',
  `displayorder` tinyint(3) NOT NULL COMMENT '排序',
  PRIMARY KEY (`id`),
  KEY `list` (`relatedid`,`disabled`,`issystem`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='字段表';

INSERT INTO `dr_field` VALUES(1, '相关附件', 'attachment', 'Files', 1, 'page', 1, 1, 1, 1, 0, 0, 'a:2:{s:6:"option";a:5:{s:5:"width";s:3:"80%";s:4:"size";s:1:"2";s:5:"count";s:2:"10";s:3:"ext";s:31:"jpg,gif,png,ppt,doc,xls,rar,zip";s:10:"uploadpath";s:0:"";}s:8:"validate";a:9:{s:8:"required";s:1:"0";s:7:"pattern";s:0:"";s:9:"errortips";s:0:"";s:6:"isedit";s:1:"0";s:3:"xss";s:1:"0";s:5:"check";s:0:"";s:6:"filter";s:0:"";s:4:"tips";s:0:"";s:8:"formattr";s:0:"";}}', 0);
INSERT INTO `dr_field` VALUES(2, '单页内容', 'content', 'Ueditor', 1, 'page', 1, 1, 1, 1, 0, 0, 'a:2:{s:6:"option";a:7:{s:5:"width";s:3:"90%";s:6:"height";s:3:"400";s:4:"mode";s:1:"1";s:4:"tool";s:0:"";s:5:"mode2";s:1:"1";s:5:"tool2";s:0:"";s:5:"value";s:0:"";}s:8:"validate";a:9:{s:8:"required";s:1:"1";s:7:"pattern";s:0:"";s:9:"errortips";s:0:"";s:6:"isedit";s:1:"0";s:3:"xss";s:1:"1";s:5:"check";s:0:"";s:6:"filter";s:0:"";s:4:"tips";s:0:"";s:8:"formattr";s:0:"";}}', 0);
INSERT INTO `dr_field` VALUES(3, '媒体名称', 'title', 'Text', 1, 'module', 1, 1, 1, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:5:{s:5:\\"width\\";s:3:\\"400\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:7:\\"VARCHAR\\";s:11:\\"fieldlength\\";s:3:\\"255\\";}s:8:\\"validate\\";a:8:{s:8:\\"required\\";s:1:\\"1\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:3:\\"xss\\";s:1:\\"1\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:48:\\"onblur=\\"check_title();get_keywords(\\''keywords\\'');\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(4, '媒体LOGO', 'thumb', 'File', 1, 'module', 1, 1, 1, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:3:{s:4:\\"size\\";s:2:\\"10\\";s:3:\\"ext\\";s:11:\\"jpg,gif,png\\";s:10:\\"uploadpath\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(5, '关键字', 'keywords', 'Text', 1, 'module', 1, 1, 1, 1, 1, 1, 'a:2:{s:6:\\"option\\";a:3:{s:5:\\"width\\";i:400;s:9:\\"fieldtype\\";s:7:\\"VARCHAR\\";s:11:\\"fieldlength\\";s:3:\\"255\\";}s:8:\\"validate\\";a:2:{s:3:\\"xss\\";i:1;s:8:\\"formattr\\";s:22:\\" data-role=\\"tagsinput\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(6, '描述', 'description', 'Textarea', 1, 'module', 1, 1, 1, 1, 1, 0, 'a:2:{s:6:\\"option\\";a:4:{s:5:\\"width\\";i:500;s:6:\\"height\\";i:60;s:9:\\"fieldtype\\";s:7:\\"VARCHAR\\";s:11:\\"fieldlength\\";s:3:\\"255\\";}s:8:\\"validate\\";a:2:{s:3:\\"xss\\";i:1;s:6:\\"filter\\";s:12:\\"dr_clearhtml\\";}}', 0);
INSERT INTO `dr_field` VALUES(7, '内容', 'content', 'Ueditor', 1, 'module', 1, 0, 1, 1, 1, 1, 'a:2:{s:6:\\"option\\";a:3:{s:4:\\"mode\\";i:1;s:5:\\"width\\";s:3:\\"90%\\";s:6:\\"height\\";i:400;}s:8:\\"validate\\";a:2:{s:3:\\"xss\\";i:1;s:8:\\"required\\";i:1;}}', 0);
INSERT INTO `dr_field` VALUES(90, '是否需要来源', 'shifouxuyaolaiyuan', 'Radio', 1, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:4:{s:7:\\"options\\";s:7:\\"是\n否\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(89, '网址收录', 'wangzhishoulu', 'Text', 1, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:4:{s:7:\\"options\\";s:148:\\"不限|0\n新闻收录\n不保证网页收录\n包网页收录\n网页收录\n不包新闻收录\n不包网页收录\n不保证新闻收录\n包新闻收录\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(97, '媒体截图', 'meitijietu', 'File', 1, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:3:{s:4:\\"size\\";s:2:\\"22\\";s:3:\\"ext\\";s:11:\\"jpg,gif,png\\";s:10:\\"uploadpath\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(98, '是否推荐', 'isflag', 'Radio', 1, 'module', 1, 1, 0, 0, 0, 0, 'a:2:{s:6:\\"option\\";a:4:{s:7:\\"options\\";s:11:\\"是|1\n否|0\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(12, '地区', 'diqu', 'Linkage', 1, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:2:{s:7:\\"linkage\\";s:7:\\"address\\";s:5:\\"value\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(88, '新闻源', 'xinwenyuan', 'Text', 1, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:4:{s:7:\\"options\\";s:31:\\"不限|0\n网页收录\n新闻源\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(16, '价格', 'order_price', 'Price', 1, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:2:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(40, '描述', 'description', 'Textarea', 4, 'module', 1, 1, 1, 1, 1, 0, 'a:2:{s:6:\\"option\\";a:4:{s:5:\\"width\\";i:500;s:6:\\"height\\";i:60;s:9:\\"fieldtype\\";s:7:\\"VARCHAR\\";s:11:\\"fieldlength\\";s:3:\\"255\\";}s:8:\\"validate\\";a:2:{s:3:\\"xss\\";i:1;s:6:\\"filter\\";s:12:\\"dr_clearhtml\\";}}', 0);
INSERT INTO `dr_field` VALUES(41, '内容', 'content', 'Ueditor', 4, 'module', 1, 0, 1, 1, 1, 1, 'a:2:{s:6:\\"option\\";a:3:{s:4:\\"mode\\";i:1;s:5:\\"width\\";s:3:\\"90%\\";s:6:\\"height\\";i:400;}s:8:\\"validate\\";a:2:{s:3:\\"xss\\";i:1;s:8:\\"required\\";i:1;}}', 0);
INSERT INTO `dr_field` VALUES(38, '微信头像', 'thumb', 'File', 4, 'module', 1, 1, 1, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:3:{s:4:\\"size\\";s:2:\\"10\\";s:3:\\"ext\\";s:11:\\"jpg,gif,png\\";s:10:\\"uploadpath\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(39, '关键字', 'keywords', 'Text', 4, 'module', 1, 1, 1, 1, 1, 1, 'a:2:{s:6:\\"option\\";a:3:{s:5:\\"width\\";i:400;s:9:\\"fieldtype\\";s:7:\\"VARCHAR\\";s:11:\\"fieldlength\\";s:3:\\"255\\";}s:8:\\"validate\\";a:2:{s:3:\\"xss\\";i:1;s:8:\\"formattr\\";s:22:\\" data-role=\\"tagsinput\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(36, '价格', 'order_price', 'Price', 3, 'module', 1, 1, 0, 0, 0, 1, 'a:2:{s:6:\\"option\\";a:2:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(37, '微信名称', 'title', 'Text', 4, 'module', 1, 1, 1, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:5:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:7:\\"VARCHAR\\";s:11:\\"fieldlength\\";s:3:\\"255\\";}s:8:\\"validate\\";a:8:{s:8:\\"required\\";s:1:\\"1\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:3:\\"xss\\";s:1:\\"1\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:48:\\"onblur=\\"check_title();get_keywords(\\''keywords\\'');\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(31, '媒体名称', 'title', 'Text', 3, 'module', 1, 1, 1, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:5:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:7:\\"VARCHAR\\";s:11:\\"fieldlength\\";s:3:\\"255\\";}s:8:\\"validate\\";a:8:{s:8:\\"required\\";s:1:\\"1\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:3:\\"xss\\";s:1:\\"1\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:48:\\"onblur=\\"check_title();get_keywords(\\''keywords\\'');\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(32, '头像图片', 'thumb', 'File', 3, 'module', 1, 1, 1, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:3:{s:4:\\"size\\";s:2:\\"10\\";s:3:\\"ext\\";s:11:\\"jpg,gif,png\\";s:10:\\"uploadpath\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(33, '关键字', 'keywords', 'Text', 3, 'module', 1, 1, 1, 1, 1, 1, 'a:2:{s:6:\\"option\\";a:3:{s:5:\\"width\\";i:400;s:9:\\"fieldtype\\";s:7:\\"VARCHAR\\";s:11:\\"fieldlength\\";s:3:\\"255\\";}s:8:\\"validate\\";a:2:{s:3:\\"xss\\";i:1;s:8:\\"formattr\\";s:22:\\" data-role=\\"tagsinput\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(34, '描述', 'description', 'Textarea', 3, 'module', 1, 1, 1, 1, 1, 0, 'a:2:{s:6:\\"option\\";a:4:{s:5:\\"width\\";i:500;s:6:\\"height\\";i:60;s:9:\\"fieldtype\\";s:7:\\"VARCHAR\\";s:11:\\"fieldlength\\";s:3:\\"255\\";}s:8:\\"validate\\";a:2:{s:3:\\"xss\\";i:1;s:6:\\"filter\\";s:12:\\"dr_clearhtml\\";}}', 0);
INSERT INTO `dr_field` VALUES(35, '内容', 'content', 'Ueditor', 3, 'module', 1, 0, 1, 1, 1, 1, 'a:2:{s:6:\\"option\\";a:3:{s:4:\\"mode\\";i:1;s:5:\\"width\\";s:3:\\"90%\\";s:6:\\"height\\";i:400;}s:8:\\"validate\\";a:2:{s:3:\\"xss\\";i:1;s:8:\\"required\\";i:1;}}', 0);
INSERT INTO `dr_field` VALUES(42, '微信名称', 'title', 'Text', 5, 'module', 1, 1, 1, 1, 0, 0, 'a:1:{s:8:\\"validate\\";a:8:{s:8:\\"required\\";s:1:\\"1\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:3:\\"xss\\";s:1:\\"1\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:48:\\"onblur=\\"check_title();get_keywords(\\''keywords\\'');\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(43, '头像', 'thumb', 'File', 5, 'module', 1, 1, 1, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:3:{s:4:\\"size\\";s:2:\\"11\\";s:3:\\"ext\\";s:11:\\"jpg,gif,png\\";s:10:\\"uploadpath\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(44, '标签', 'keywords', 'Text', 5, 'module', 1, 1, 1, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:5:{s:5:\\"width\\";s:3:\\"400\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:7:\\"VARCHAR\\";s:11:\\"fieldlength\\";s:3:\\"255\\";}s:8:\\"validate\\";a:8:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:3:\\"xss\\";s:1:\\"1\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:22:\\" data-role=\\"tagsinput\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(45, '描述', 'description', 'Textarea', 5, 'module', 1, 1, 1, 1, 1, 0, 'a:2:{s:6:\\"option\\";a:4:{s:5:\\"width\\";i:500;s:6:\\"height\\";i:60;s:9:\\"fieldtype\\";s:7:\\"VARCHAR\\";s:11:\\"fieldlength\\";s:3:\\"255\\";}s:8:\\"validate\\";a:2:{s:3:\\"xss\\";i:1;s:6:\\"filter\\";s:12:\\"dr_clearhtml\\";}}', 0);
INSERT INTO `dr_field` VALUES(46, '内容', 'content', 'Ueditor', 5, 'module', 1, 0, 1, 1, 1, 1, 'a:2:{s:6:\\"option\\";a:3:{s:4:\\"mode\\";i:1;s:5:\\"width\\";s:3:\\"90%\\";s:6:\\"height\\";i:400;}s:8:\\"validate\\";a:2:{s:3:\\"xss\\";i:1;s:8:\\"required\\";i:1;}}', 0);
INSERT INTO `dr_field` VALUES(47, '投放价格', 'order_price', 'Price', 5, 'module', 1, 1, 0, 1, 0, 1, 'a:2:{s:6:\\"option\\";a:2:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(48, '价格', 'order_price', 'Price', 4, 'module', 1, 1, 0, 1, 0, 1, 'a:1:{s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(49, '媒体领域', 'meitilingyu', 'Select', 1, 'weixin-1', 1, 1, 0, 1, 1, 0, 'a:2:{s:6:\\"option\\";a:4:{s:7:\\"options\\";s:291:\\"创意/生活\n新闻时政\n互联网\n综合媒体\n时尚搭配\n财经\n个人自媒体\n星座/禅学\n旅游摄影\n美食\n文学/艺术\n汽车\n娱乐八卦\n影视\n美妆瘦身\n亲子/育儿\n游戏/动漫\n养生/健康\n健身/运动\n情感心理\n管理/营销\nIT数码\n家居房产\n幽默搞笑\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:7:\\"VARCHAR\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(55, '粉丝数量', 'fensishuliang', 'Text', 3, 'module', 1, 1, 0, 0, 0, 0, 'a:2:{s:6:\\"option\\";a:5:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(51, '常见分类', 'changjianfenlei', 'Select', 2, 'weixin-1', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:4:{s:7:\\"options\\";s:224:\\"新闻资讯\n时尚\n娱乐\n生活\n旅游摄影\n科技IT\n互联网\n美容瘦身\n汽车\n家居房产\n美食\n星座命理\n母婴育儿\n财经情感\n游戏动漫\n购物\n体育锻炼\n健康养生\n教育培训\n幽默\n职场\n其它\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(52, '粉丝数量', 'fensishuliang', 'Text', 5, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:5:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(53, '地区分布', 'diqufenbu', 'Linkage', 5, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:2:{s:7:\\"linkage\\";s:7:\\"address\\";s:5:\\"value\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(76, '硬广转发价', 'price_ygzf', 'Price', 3, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:2:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(77, '软广转发价', 'price_rgzf', 'Price', 3, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:2:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(56, '地方/媒体', 'diqu', 'Linkage', 3, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:2:{s:7:\\"linkage\\";s:7:\\"address\\";s:5:\\"value\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(57, '名人职业', 'mingrenzhiye', 'Select', 1, 'weibo-1', 1, 1, 0, 0, 0, 0, 'a:2:{s:6:\\"option\\";a:4:{s:7:\\"options\\";s:460:\\"影视演员\n歌手\n模特\n主持人\n段子手\n摄影师\n作家\n音乐人\n体育人\n美容护肤达人\n网络红人\n游戏动漫达人\n旅游达人\nIT名人\n影视幕后\n时尚达人\n漫画家\n造型师\n童星\n舞蹈家\n相声曲艺\n记者\n美食家\n娱评人\n设计师\n商界名人\n情感专家\n教育家\n营销专家\n养生专家\n医生\n汽车达人\n财经专家\n数码达人\n男优/女优\n网购达人\n母婴专家\n风水家\n房地产\n收藏家\n星座达人\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(58, '媒体领域', 'meitilingyu', 'Select', 1, 'weibo-1', 1, 1, 0, 0, 0, 0, 'a:2:{s:6:\\"option\\";a:4:{s:7:\\"options\\";s:291:\\"创意/生活\n新闻时政\n互联网\n综合媒体\n时尚搭配\n财经\n个人自媒体\n星座/禅学\n旅游摄影\n美食\n文学/艺术\n汽车\n娱乐八卦\n影视\n美妆瘦身\n亲子/育儿\n游戏/动漫\n养生/健康\n健身/运动\n情感心理\n管理/营销\nIT数码\n家居房产\n幽默搞笑\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(59, '常见分类', 'changjianfenlei', 'Select', 2, 'weibo-1', 1, 1, 0, 0, 0, 0, 'a:2:{s:6:\\"option\\";a:4:{s:7:\\"options\\";s:224:\\"新闻资讯\n时尚\n娱乐\n生活\n旅游摄影\n科技IT\n互联网\n美容瘦身\n汽车\n家居房产\n美食\n星座命理\n母婴育儿\n财经情感\n游戏动漫\n购物\n体育锻炼\n健康养生\n教育培训\n幽默\n职场\n其它\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(60, '名人职业', 'mingrenzhiye', 'Select', 1, 'quan-1', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:4:{s:7:\\"options\\";s:227:\\"财经名人\n美妆达人\n美食达人\n时尚达人\n网络红人\n段子手\n漫画家\n互联网精英\n旅游达人\n母婴专家\n模特\n作家\n设计师\n情感专家\n媒体人\n游戏动漫达人\n影视演员\nIT达人\n汽车达人\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(61, '行业/职业', 'xingyezhiye', 'Select', 2, 'quan-1', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:4:{s:7:\\"options\\";s:125:\\"学生\n白领\n蓝领\n模特\n微商\n自媒体\n企业家\n美妆达人\n网络红人\n个体商户\n自由职业\nIT互联网\n其它\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(62, '地区分布', 'diqu', 'Linkage', 4, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:2:{s:7:\\"linkage\\";s:7:\\"address\\";s:5:\\"value\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(63, '好友数量', 'haoyoushuliang', 'Text', 4, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:5:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(64, '行业分类', 'xingyefenlei', 'Select', 1, 'news-1', 1, 1, 0, 0, 0, 0, 'a:2:{s:6:\\"option\\";a:4:{s:7:\\"options\\";s:208:\\"不限\r\n资讯\r\n时尚\r\n娱乐\r\n财经\r\n汽车\r\n家居\r\n生活\r\n科技\r\n游戏动漫\r\n房产\r\n食品\r\n旅游\r\n母婴育儿\r\n体育\r\n健康\r\n教育\r\n艺术\r\n收藏\r\n制造\r\n物流\r\n企业加盟\r\n公益\r\n其它\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(66, '微信号', 'weixinhao', 'Text', 5, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:5:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(67, '下单备注', 'xiadanbeizhu', 'Checkbox', 5, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:2:{s:7:\\"options\\";s:57:\\"可接硬广\n可接微店\n可接管理培训\n仅接品牌\\";s:5:\\"value\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(68, '二维码', 'erweima', 'File', 5, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:3:{s:4:\\"size\\";s:2:\\"22\\";s:3:\\"ext\\";s:11:\\"jpg,gif,png\\";s:10:\\"uploadpath\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(69, '粉丝截图', 'fensijietu', 'File', 5, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:3:{s:4:\\"size\\";s:2:\\"22\\";s:3:\\"ext\\";s:11:\\"jpg,gif,png\\";s:10:\\"uploadpath\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(70, '年龄', 'nianling', 'Text', 4, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:5:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(71, '性别', 'xingbie', 'Radio', 4, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:4:{s:7:\\"options\\";s:7:\\"男\n女\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(72, '好友截图', 'haoyoujietu', 'File', 4, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:3:{s:4:\\"size\\";s:2:\\"22\\";s:3:\\"ext\\";s:11:\\"jpg,gif,png\\";s:10:\\"uploadpath\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(73, '评论截图', 'pinglunjietu', 'File', 4, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:3:{s:4:\\"size\\";s:2:\\"22\\";s:3:\\"ext\\";s:11:\\"jpg,gif,png\\";s:10:\\"uploadpath\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(74, '好友描述', 'haoyoumiaoshu', 'Textarea', 4, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:4:{s:5:\\"width\\";s:3:\\"300\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";s:6:\\"height\\";s:3:\\"100\\";s:5:\\"value\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(75, '下单备注', 'xiadanbeizhu', 'Textarea', 4, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:4:{s:5:\\"width\\";s:3:\\"300\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";s:6:\\"height\\";s:3:\\"100\\";s:5:\\"value\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(78, '硬广直发价', 'price_ygzf2', 'Price', 3, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:2:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(79, '软广直发价', 'price_rgzf2', 'Price', 3, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:2:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(86, '直发报价', 'price_zf', 'Price', 4, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:2:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(85, '第3-n条', 'price_dnt', 'Price', 5, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:2:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(83, '多图头条', 'price_dttt', 'Price', 5, 'module', 1, 1, 0, 1, 0, 0, 'a:1:{s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(84, '多图次条', 'price_dtct', 'Price', 5, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:2:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(87, '分享报价', 'price_fx', 'Price', 4, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:2:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(91, '案例地址', 'anlidizhi', 'Text', 1, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:5:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(92, '媒体地址', 'meitidizhi', 'Text', 1, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:5:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(93, '周末能否发稿', 'zhoumonengfoufagao', 'Radio', 1, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:4:{s:7:\\"options\\";s:10:\\"不能\n能\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(94, '文本链接', 'wenbenlianjie', 'Text', 1, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:4:{s:7:\\"options\\";s:92:\\"不限|0\n可带文本网址\n可做超链\n不能带网址、二维码、微信号、电话等\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(95, '标题长度限制', 'biaotichangduxianzhi', 'Text', 1, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:4:{s:7:\\"options\\";s:74:\\"30个字以内\n17个字以内\n18个字以内\n21个字以内\n24个字以内\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(96, '门户类型', 'menhuleixing', 'Text', 1, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:4:{s:7:\\"options\\";s:54:\\"不限|0\n地方门户\n行业门户\n重点门户\n其他\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(99, '是否认证', 'isflag', 'Radio', 3, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:4:{s:7:\\"options\\";s:11:\\"是|1\n否|0\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(100, '是否认证', 'isflag', 'Radio', 4, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:4:{s:7:\\"options\\";s:11:\\"是|1\n否|0\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(101, '是否认证', 'isflag', 'Radio', 5, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:4:{s:7:\\"options\\";s:11:\\"是|1\n否|0\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(102, '微博地址', 'weibodizhi', 'Text', 3, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:5:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(103, '参考阅读', 'cankaoyuedu', 'Text', 5, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:5:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(104, '周频率', 'zhoupinlu', 'Text', 5, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:5:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);

INSERT INTO `dr_field` VALUES(119, '视频链接', 'shipinlianjie', 'Text', 6, 'module', 1, 1, 0, 0, 0, 0, 'a:2:{s:6:\\"option\\";a:5:{s:5:\\"width\\";s:3:\\"400\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);


# Dump of table dr_linkage
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_linkage`;

CREATE TABLE `dr_linkage` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL COMMENT '菜单名称',
  `type` tinyint(1) unsigned NOT NULL,
  `code` char(20) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `code` (`code`),
  KEY `module` (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='联动菜单表';

LOCK TABLES `dr_linkage` WRITE;
/*!40000 ALTER TABLE `dr_linkage` DISABLE KEYS */;

INSERT INTO `dr_linkage` (`id`, `name`, `type`, `code`)
VALUES
	(1,'中国地区',0,'address');

/*!40000 ALTER TABLE `dr_linkage` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table dr_linkage_data_1
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_linkage_data_1`;

CREATE TABLE `dr_linkage_data_1` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `site` mediumint(5) unsigned NOT NULL COMMENT '站点id',
  `pid` mediumint(8) unsigned NOT NULL DEFAULT '0' COMMENT '上级id',
  `pids` varchar(255) DEFAULT NULL COMMENT '所有上级id',
  `name` varchar(30) NOT NULL COMMENT '栏目名称',
  `cname` varchar(30) NOT NULL COMMENT '别名',
  `child` tinyint(1) unsigned DEFAULT '0' COMMENT '是否有下级',
  `childids` text COMMENT '下级所有id',
  `displayorder` tinyint(3) DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `cname` (`cname`),
  KEY `list` (`site`,`displayorder`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='联动菜单数据表';

LOCK TABLES `dr_linkage_data_1` WRITE;
/*!40000 ALTER TABLE `dr_linkage_data_1` DISABLE KEYS */;

INSERT INTO `dr_linkage_data_1` (`id`, `site`, `pid`, `pids`, `name`, `cname`, `child`, `childids`, `displayorder`)
VALUES
	(1,1,0,'0','北京市','beijing',0,'1',1),
	(2,1,0,'0','天津市','tianjin',0,'2',2),
	(3,1,0,'0','河北省','hebei',1,'3,65,66,67,68,69,70,71,72,73,74,75',3),
	(4,1,0,'0','山西省','shanxi',1,'4,248,259,271,277,291,298,305,317,331,346,364',4),
	(5,1,0,'0','辽宁省','liaoning',1,'5,491,505,516,524,532,539,546,554,561,569,577,582,590,598',5),
	(6,1,0,'0','吉林省','jilin',1,'6,605,616,626,633,638,646,653,659,665',6),
	(7,1,0,'0','黑龙江省','heilongjiang',1,'7,674,693,710,720,729,738,748,766,777,782,793,800,811',7),
	(8,1,0,'0','江苏省','jiangsu',1,'8,833,834,835,836,837,838,839,840,841,842,843,844,845',9),
	(9,1,0,'0','浙江省','zhejiang',1,'9,846,847,848,849,850,851,852,853,854,855,856',10),
	(10,1,0,'0','安徽省','anhui',1,'10,857,858,859,860,861,862,863,864,865,866,867,868,869,870,871,872',11),
	(11,1,0,'0','福建省','fujian',1,'11,873,874,875,876,877,878,879,880,881',12),
	(12,1,0,'0','江西省','jiangxi',1,'12,882,883,884,885,886,887,888,889,890,891,892',13),
	(13,1,0,'0','山东省','shandong',1,'13,893,894,895,896,897,898,899,900,901,902,903,904,905,906,907,908,909',14),
	(14,1,0,'0','河南省','henan',1,'14,910,911,912,913,914,915,916,917,918,919,920,921,922,923,924,925,926',15),
	(15,1,0,'0','湖北省','hubei',1,'15,927,928,929,930,931,932,933,934,935,936,937,938,939',16),
	(16,1,0,'0','湖南省','hunan',1,'16,940,941,942,943,944,945,946,947,948,949,950,951,952,953',17),
	(17,1,0,'0','广东省','guangdong',1,'17,954,955,956,957,958,959,960,961,962,963,964,965,966,967,968,969,972,973,974,1149',18),
	(18,1,0,'0','海南省','hainan',1,'18,990',19),
	(19,1,0,'0','重庆市','zhongqing',0,'19',20),
	(20,1,0,'0','四川省','sichuan',1,'20,1046,1047,1048,1049,1050,1051,1052,1053,1054,1055,1056,1057,1058,1059,1060,1061,1062,1063,1064,1065,1066',21),
	(21,1,0,'0','贵州省','guizhou',1,'21,1067,1068,1069,1070,1071,1072,1073,1074,1075',22),
	(22,1,0,'0','云南省','yunnan',1,'22,1076,1077,1078,1079,1080,1081,1082,1083,1084,1085,1086,1087,1088,1089,1090,1091',23),
	(23,1,0,'0','陕西省','shanxi1',1,'23,1099,1100,1101,1102,1103,1104,1105,1106,1107,1108',24),
	(24,1,0,'0','甘肃省','gansu',1,'24,1109,1110,1111,1112,1113,1114,1115,1116,1117,1118,1119,1120,1121',25),
	(25,1,0,'0','青海省','qinghai',1,'25,1122,1123,1124,1125,1126,1127,1128,1129',26),
	(26,1,0,'0','宁夏','ningxia',1,'26,1130,1131,1132,1133,1134',27),
	(27,1,0,'0','西藏','xicang',1,'27,1092,1093,1094,1095,1096,1097,1098',28),
	(28,1,0,'0','新疆','xinjiang',1,'28,1135,1136,1137,1138,1139,1140,1141,1142,1143,1144,1145,1146,1147,1148',29),
	(29,1,0,'0','内蒙古','neimenggu',1,'29,378,388,398,402,415,424,433,447,455,467,474,487',30),
	(30,1,0,'0','香港','xianggang',0,'30',31),
	(31,1,0,'0','澳门','aomen',0,'31',32),
	(32,1,0,'0','台湾','taiwan',0,'32',33),
	(65,1,3,'0,3','石家庄市','shijiazhuang',0,'65',0),
	(66,1,3,'0,3','唐山市','tangshan',0,'66',0),
	(67,1,3,'0,3','秦皇岛市','qinhuangdao',0,'67',0),
	(68,1,3,'0,3','邯郸市','handan',0,'68',0),
	(69,1,3,'0,3','邢台市','xingtai',0,'69',0),
	(70,1,3,'0,3','保定市','baoding',0,'70',0),
	(71,1,3,'0,3','张家口市','zhangjiakou',0,'71',0),
	(72,1,3,'0,3','承德市','chengde',0,'72',0),
	(73,1,3,'0,3','沧州市','cangzhou',0,'73',0),
	(74,1,3,'0,3','廊坊市','langfang',0,'74',0),
	(75,1,3,'0,3','衡水市','hengshui',0,'75',0),
	(248,1,4,'0,4','太原市','taiyuan',0,'248',0),
	(259,1,4,'0,4','大同市','datong',0,'259',0),
	(271,1,4,'0,4','阳泉市','yangquan',0,'271',0),
	(277,1,4,'0,4','长治市','changzhi',0,'277',0),
	(291,1,4,'0,4','晋城市','jincheng',0,'291',0),
	(298,1,4,'0,4','朔州市','shuozhou',0,'298',0),
	(305,1,4,'0,4','晋中市','jinzhong',0,'305',0),
	(317,1,4,'0,4','运城市','yuncheng',0,'317',0),
	(331,1,4,'0,4','忻州市','xinzhou',0,'331',0),
	(346,1,4,'0,4','临汾市','linfen',0,'346',0),
	(364,1,4,'0,4','吕梁市','luliang',0,'364',0),
	(378,1,29,'0,29','呼和浩特市','huhehaote',0,'378',0),
	(388,1,29,'0,29','包头市','baotou',0,'388',0),
	(398,1,29,'0,29','乌海市','wuhai',0,'398',0),
	(402,1,29,'0,29','赤峰市','chifeng',0,'402',0),
	(415,1,29,'0,29','通辽市','tongliao',0,'415',0),
	(424,1,29,'0,29','鄂尔多斯市','eerduosi',0,'424',0),
	(433,1,29,'0,29','呼伦贝尔市','hulunbeier',0,'433',0),
	(447,1,29,'0,29','巴彦淖尔市','bayannaoer',0,'447',0),
	(455,1,29,'0,29','乌兰察布市','wulanchabu',0,'455',0),
	(467,1,29,'0,29','兴安盟','xinganmeng',0,'467',0),
	(474,1,29,'0,29','锡林郭勒盟','xilinguolemeng',0,'474',0),
	(487,1,29,'0,29','阿拉善盟','alashanmeng',0,'487',0),
	(491,1,5,'0,5','沈阳市','shenyang',0,'491',0),
	(505,1,5,'0,5','大连市','dalian',0,'505',0),
	(516,1,5,'0,5','鞍山市','anshan',0,'516',0),
	(524,1,5,'0,5','抚顺市','fushun',0,'524',0),
	(532,1,5,'0,5','本溪市','benxi',0,'532',0),
	(539,1,5,'0,5','丹东市','dandong',0,'539',0),
	(546,1,5,'0,5','锦州市','jinzhou',0,'546',0),
	(554,1,5,'0,5','营口市','yingkou',0,'554',0),
	(561,1,5,'0,5','阜新市','fuxin',0,'561',0),
	(569,1,5,'0,5','辽阳市','liaoyang',0,'569',0),
	(577,1,5,'0,5','盘锦市','panjin',0,'577',0),
	(582,1,5,'0,5','铁岭市','tieling',0,'582',0),
	(590,1,5,'0,5','朝阳市','chaoyang',0,'590',0),
	(598,1,5,'0,5','葫芦岛市','huludao',0,'598',0),
	(605,1,6,'0,6','长春市','changchun',0,'605',0),
	(616,1,6,'0,6','吉林市','jilin1',0,'616',0),
	(626,1,6,'0,6','四平市','siping',0,'626',0),
	(633,1,6,'0,6','辽源市','liaoyuan',0,'633',0),
	(638,1,6,'0,6','通化市','tonghua',0,'638',0),
	(646,1,6,'0,6','白山市','baishan',0,'646',0),
	(653,1,6,'0,6','松原市','songyuan',0,'653',0),
	(659,1,6,'0,6','白城市','baicheng',0,'659',0),
	(665,1,6,'0,6','延边自治州','yanbianzhou',0,'665',0),
	(674,1,7,'0,7','哈尔滨市','haerbin',0,'674',0),
	(693,1,7,'0,7','齐齐哈尔市','qiqihaer',0,'693',0),
	(710,1,7,'0,7','鸡西市','jixi',0,'710',0),
	(720,1,7,'0,7','鹤岗市','hegang',0,'720',0),
	(729,1,7,'0,7','双鸭山市','shuangyashan',0,'729',0),
	(738,1,7,'0,7','大庆市','daqing',0,'738',0),
	(748,1,7,'0,7','伊春市','yichun',0,'748',0),
	(766,1,7,'0,7','佳木斯市','jiamusi',0,'766',0),
	(777,1,7,'0,7','七台河市','qitaihe',0,'777',0),
	(782,1,7,'0,7','牡丹江市','mudanjiang',0,'782',0),
	(793,1,7,'0,7','黑河市','heihe',0,'793',0),
	(800,1,7,'0,7','绥化市','suihua',0,'800',0),
	(811,1,7,'0,7','大兴安岭地区','daxinganling',0,'811',0),
	(815,1,0,'0','上海市','shanghai',0,'815',8),
	(833,1,8,'0,8','南京市','nanjing',0,'833',0),
	(834,1,8,'0,8','无锡市','wuxi',0,'834',0),
	(835,1,8,'0,8','徐州市','xuzhou',0,'835',0),
	(836,1,8,'0,8','常州市','changzhou',0,'836',0),
	(837,1,8,'0,8','苏州市','suzhou',0,'837',0),
	(838,1,8,'0,8','南通市','nantong',0,'838',0),
	(839,1,8,'0,8','连云港市','lianyungang',0,'839',0),
	(840,1,8,'0,8','淮安市','huaian',0,'840',0),
	(841,1,8,'0,8','盐城市','yancheng',0,'841',0),
	(842,1,8,'0,8','扬州市','yangzhou',0,'842',0),
	(843,1,8,'0,8','镇江市','zhenjiang',0,'843',0),
	(844,1,8,'0,8','泰州市','taizhou',0,'844',0),
	(845,1,8,'0,8','宿迁市','xiuqian',0,'845',0),
	(846,1,9,'0,9','杭州市','hangzhou',0,'846',0),
	(847,1,9,'0,9','宁波市','ningbo',0,'847',0),
	(848,1,9,'0,9','温州市','wenzhou',0,'848',0),
	(849,1,9,'0,9','嘉兴市','jiaxing',0,'849',0),
	(850,1,9,'0,9','湖州市','huzhou',0,'850',0),
	(851,1,9,'0,9','绍兴市','shaoxing',0,'851',0),
	(852,1,9,'0,9','金华市','jinhua',0,'852',0),
	(853,1,9,'0,9','衢州市','quzhou',0,'853',0),
	(854,1,9,'0,9','舟山市','zhoushan',0,'854',0),
	(855,1,9,'0,9','台州市','taizhou1',0,'855',0),
	(856,1,9,'0,9','丽水市','lishui',0,'856',0),
	(857,1,10,'0,10','合肥市','hefei',0,'857',0),
	(858,1,10,'0,10','芜湖市','wuhu',0,'858',0),
	(859,1,10,'0,10','蚌埠市','bangbu',0,'859',0),
	(860,1,10,'0,10','淮南市','huainan',0,'860',0),
	(861,1,10,'0,10','马鞍山市','maanshan',0,'861',0),
	(862,1,10,'0,10','淮北市','huaibei',0,'862',0),
	(863,1,10,'0,10','铜陵市','tongling',0,'863',0),
	(864,1,10,'0,10','安庆市','anqing',0,'864',0),
	(865,1,10,'0,10','黄山市','huangshan',0,'865',0),
	(866,1,10,'0,10','滁州市','chuzhou',0,'866',0),
	(867,1,10,'0,10','阜阳市','fuyang',0,'867',0),
	(868,1,10,'0,10','宿州市','xiuzhou',0,'868',0),
	(869,1,10,'0,10','六安市','liuan',0,'869',0),
	(870,1,10,'0,10','亳州市','bozhou',0,'870',0),
	(871,1,10,'0,10','池州市','shizhou',0,'871',0),
	(872,1,10,'0,10','宣城市','xuancheng',0,'872',0),
	(873,1,11,'0,11','福州市','fuzhou',0,'873',0),
	(874,1,11,'0,11','厦门市','shamen',0,'874',0),
	(875,1,11,'0,11','莆田市','putian',0,'875',0),
	(876,1,11,'0,11','三明市','sanming',0,'876',0),
	(877,1,11,'0,11','泉州市','quanzhou',0,'877',0),
	(878,1,11,'0,11','漳州市','zhangzhou',0,'878',0),
	(879,1,11,'0,11','南平市','nanping',0,'879',0),
	(880,1,11,'0,11','龙岩市','longyan',0,'880',0),
	(881,1,11,'0,11','宁德市','ningde',0,'881',0),
	(882,1,12,'0,12','南昌市','nanchang',0,'882',0),
	(883,1,12,'0,12','景德镇市','jingdezhen',0,'883',0),
	(884,1,12,'0,12','萍乡市','pingxiang',0,'884',0),
	(885,1,12,'0,12','九江市','jiujiang',0,'885',0),
	(886,1,12,'0,12','新余市','xinyu',0,'886',0),
	(887,1,12,'0,12','鹰潭市','yingtan',0,'887',0),
	(888,1,12,'0,12','赣州市','ganzhou',0,'888',0),
	(889,1,12,'0,12','吉安市','jian',0,'889',0),
	(890,1,12,'0,12','宜春市','yichun1',0,'890',0),
	(891,1,12,'0,12','抚州市','fuzhou1',0,'891',0),
	(892,1,12,'0,12','上饶市','shangrao',0,'892',0),
	(893,1,13,'0,13','济南市','jinan',0,'893',0),
	(894,1,13,'0,13','青岛市','qingdao',0,'894',0),
	(895,1,13,'0,13','淄博市','zibo',0,'895',0),
	(896,1,13,'0,13','枣庄市','zaozhuang',0,'896',0),
	(897,1,13,'0,13','东营市','dongying',0,'897',0),
	(898,1,13,'0,13','烟台市','yantai',0,'898',0),
	(899,1,13,'0,13','潍坊市','weifang',0,'899',0),
	(900,1,13,'0,13','济宁市','jining',0,'900',0),
	(901,1,13,'0,13','泰安市','taian',0,'901',0),
	(902,1,13,'0,13','威海市','weihai',0,'902',0),
	(903,1,13,'0,13','日照市','rizhao',0,'903',0),
	(904,1,13,'0,13','莱芜市','laiwu',0,'904',0),
	(905,1,13,'0,13','临沂市','linyi',0,'905',0),
	(906,1,13,'0,13','德州市','dezhou',0,'906',0),
	(907,1,13,'0,13','聊城市','liaocheng',0,'907',0),
	(908,1,13,'0,13','滨州市','binzhou',0,'908',0),
	(909,1,13,'0,13','菏泽市','heze',0,'909',0),
	(910,1,14,'0,14','郑州市','zhengzhou',0,'910',0),
	(911,1,14,'0,14','开封市','kaifeng',0,'911',0),
	(912,1,14,'0,14','洛阳市','luoyang',0,'912',0),
	(913,1,14,'0,14','平顶山市','pingdingshan',0,'913',0),
	(914,1,14,'0,14','安阳市','anyang',0,'914',0),
	(915,1,14,'0,14','鹤壁市','hebi',0,'915',0),
	(916,1,14,'0,14','新乡市','xinxiang',0,'916',0),
	(917,1,14,'0,14','焦作市','jiaozuo',0,'917',0),
	(918,1,14,'0,14','濮阳市','puyang',0,'918',0),
	(919,1,14,'0,14','许昌市','xuchang',0,'919',0),
	(920,1,14,'0,14','漯河市','leihe',0,'920',0),
	(921,1,14,'0,14','三门峡市','sanmenxia',0,'921',0),
	(922,1,14,'0,14','南阳市','nanyang',0,'922',0),
	(923,1,14,'0,14','商丘市','shangqiu',0,'923',0),
	(924,1,14,'0,14','信阳市','xinyang',0,'924',0),
	(925,1,14,'0,14','周口市','zhoukou',0,'925',0),
	(926,1,14,'0,14','驻马店市','zhumadian',0,'926',0),
	(927,1,15,'0,15','武汉市','wuhan',0,'927',0),
	(928,1,15,'0,15','黄石市','huangshi',0,'928',0),
	(929,1,15,'0,15','十堰市','shiyan',0,'929',0),
	(930,1,15,'0,15','宜昌市','yichang',0,'930',0),
	(931,1,15,'0,15','襄阳市','xiangyang',0,'931',0),
	(932,1,15,'0,15','鄂州市','ezhou',0,'932',0),
	(933,1,15,'0,15','荆门市','jingmen',0,'933',0),
	(934,1,15,'0,15','孝感市','xiaogan',0,'934',0),
	(935,1,15,'0,15','荆州市','jingzhou',0,'935',0),
	(936,1,15,'0,15','黄冈市','huanggang',0,'936',0),
	(937,1,15,'0,15','咸宁市','xianning',0,'937',0),
	(938,1,15,'0,15','随州市','suizhou',0,'938',0),
	(939,1,15,'0,15','恩施自治州','enshizhou',0,'939',0),
	(940,1,16,'0,16','长沙市','changsha',0,'940',0),
	(941,1,16,'0,16','株洲市','zhuzhou',0,'941',0),
	(942,1,16,'0,16','湘潭市','xiangtan',0,'942',0),
	(943,1,16,'0,16','衡阳市','hengyang',0,'943',0),
	(944,1,16,'0,16','邵阳市','shaoyang',0,'944',0),
	(945,1,16,'0,16','岳阳市','yueyang',0,'945',0),
	(946,1,16,'0,16','常德市','changde',0,'946',0),
	(947,1,16,'0,16','张家界市','zhangjiajie',0,'947',0),
	(948,1,16,'0,16','益阳市','yiyang',0,'948',0),
	(949,1,16,'0,16','郴州市','chenzhou',0,'949',0),
	(950,1,16,'0,16','永州市','yongzhou',0,'950',0),
	(951,1,16,'0,16','怀化市','huaihua',0,'951',0),
	(952,1,16,'0,16','娄底市','loudi',0,'952',0),
	(953,1,16,'0,16','湘西自治州','xiangxizhou',0,'953',0),
	(954,1,17,'0,17','广州市','guangzhou',0,'954',0),
	(955,1,17,'0,17','韶关市','shaoguan',0,'955',0),
	(956,1,17,'0,17','深圳市','shenchou',0,'956',0),
	(957,1,17,'0,17','珠海市','zhuhai',0,'957',0),
	(958,1,17,'0,17','汕头市','shantou',0,'958',0),
	(959,1,17,'0,17','佛山市','foshan',0,'959',0),
	(960,1,17,'0,17','江门市','jiangmen',0,'960',0),
	(961,1,17,'0,17','湛江市','zhanjiang',0,'961',0),
	(962,1,17,'0,17','茂名市','maoming',0,'962',0),
	(963,1,17,'0,17','肇庆市','zhaoqing',0,'963',0),
	(964,1,17,'0,17','惠州市','huizhou',0,'964',0),
	(965,1,17,'0,17','梅州市','meizhou',0,'965',0),
	(966,1,17,'0,17','汕尾市','shanwei',0,'966',0),
	(967,1,17,'0,17','河源市','heyuan',0,'967',0),
	(968,1,17,'0,17','阳江市','yangjiang',0,'968',0),
	(969,1,17,'0,17','清远市','qingyuan',0,'969',0),
	(972,1,17,'0,17','潮州市','chaozhou',0,'972',0),
	(973,1,17,'0,17','揭阳市','jieyang',0,'973',0),
	(974,1,17,'0,17','云浮市','yunfu',0,'974',0),
	(975,1,0,'0','广西','guangxi',1,'975,976,977,978,979,980,981,982,983,984,985,986,987,988,989',18),
	(976,1,975,'0,975','南宁市','nanning',0,'976',0),
	(977,1,975,'0,975','柳州市','liuzhou',0,'977',0),
	(978,1,975,'0,975','桂林市','guilin',0,'978',0),
	(979,1,975,'0,975','梧州市','wuzhou',0,'979',0),
	(980,1,975,'0,975','北海市','beihai',0,'980',0),
	(981,1,975,'0,975','防城港市','fangchenggang',0,'981',0),
	(982,1,975,'0,975','钦州市','qinzhou',0,'982',0),
	(983,1,975,'0,975','贵港市','guigang',0,'983',0),
	(984,1,975,'0,975','玉林市','yulin',0,'984',0),
	(985,1,975,'0,975','百色市','baise',0,'985',0),
	(986,1,975,'0,975','贺州市','hezhou',0,'986',0),
	(987,1,975,'0,975','河池市','heshi',0,'987',0),
	(988,1,975,'0,975','来宾市','laibin',0,'988',0),
	(989,1,975,'0,975','崇左市','chongzuo',0,'989',0),
	(990,1,18,'0,18','海口市','haikou',0,'990',0),
	(1046,1,20,'0,20','成都市','chengdou',0,'1046',0),
	(1047,1,20,'0,20','自贡市','zigong',0,'1047',0),
	(1048,1,20,'0,20','攀枝花市','panzhihua',0,'1048',0),
	(1049,1,20,'0,20','泸州市','luzhou',0,'1049',0),
	(1050,1,20,'0,20','德阳市','deyang',0,'1050',0),
	(1051,1,20,'0,20','绵阳市','mianyang',0,'1051',0),
	(1052,1,20,'0,20','广元市','guangyuan',0,'1052',0),
	(1053,1,20,'0,20','遂宁市','suining',0,'1053',0),
	(1054,1,20,'0,20','内江市','neijiang',0,'1054',0),
	(1055,1,20,'0,20','乐山市','leshan',0,'1055',0),
	(1056,1,20,'0,20','南充市','nanchong',0,'1056',0),
	(1057,1,20,'0,20','眉山市','meishan',0,'1057',0),
	(1058,1,20,'0,20','宜宾市','yibin',0,'1058',0),
	(1059,1,20,'0,20','广安市','guangan',0,'1059',0),
	(1060,1,20,'0,20','达州市','dazhou',0,'1060',0),
	(1061,1,20,'0,20','雅安市','yaan',0,'1061',0),
	(1062,1,20,'0,20','巴中市','bazhong',0,'1062',0),
	(1063,1,20,'0,20','资阳市','ziyang',0,'1063',0),
	(1064,1,20,'0,20','阿坝自治州','abazhou',0,'1064',0),
	(1065,1,20,'0,20','甘孜自治州','ganzizhou',0,'1065',0),
	(1066,1,20,'0,20','凉山自治州','liangshanzhou',0,'1066',0),
	(1067,1,21,'0,21','贵阳市','guiyang',0,'1067',0),
	(1068,1,21,'0,21','六盘水市','liupanshui',0,'1068',0),
	(1069,1,21,'0,21','遵义市','zunyi',0,'1069',0),
	(1070,1,21,'0,21','安顺市','anshun',0,'1070',0),
	(1071,1,21,'0,21','毕节市','bijie',0,'1071',0),
	(1072,1,21,'0,21','铜仁市','tongren',0,'1072',0),
	(1073,1,21,'0,21','黔西南自治州','qianxinanzhou',0,'1073',0),
	(1074,1,21,'0,21','黔东南自治州','qiandongnanzhou',0,'1074',0),
	(1075,1,21,'0,21','黔南自治州','qiannanzhou',0,'1075',0),
	(1076,1,22,'0,22','昆明市','kunming',0,'1076',0),
	(1077,1,22,'0,22','曲靖市','qujing',0,'1077',0),
	(1078,1,22,'0,22','玉溪市','yuxi',0,'1078',0),
	(1079,1,22,'0,22','保山市','baoshan',0,'1079',0),
	(1080,1,22,'0,22','昭通市','zhaotong',0,'1080',0),
	(1081,1,22,'0,22','丽江市','lijiang',0,'1081',0),
	(1082,1,22,'0,22','普洱市','puer',0,'1082',0),
	(1083,1,22,'0,22','临沧市','lincang',0,'1083',0),
	(1084,1,22,'0,22','楚雄自治州','chuxiongzhou',0,'1084',0),
	(1085,1,22,'0,22','红河自治州','honghezhou',0,'1085',0),
	(1086,1,22,'0,22','文山自治州','wenshanzhou',0,'1086',0),
	(1087,1,22,'0,22','西双版纳自治州','xishuangbannazhou',0,'1087',0),
	(1088,1,22,'0,22','大理自治州','dalizhou',0,'1088',0),
	(1089,1,22,'0,22','德宏自治州','dehongzhou',0,'1089',0),
	(1090,1,22,'0,22','怒江自治州','nujiangzhou',0,'1090',0),
	(1091,1,22,'0,22','迪庆自治州','diqingzhou',0,'1091',0),
	(1092,1,27,'0,27','拉萨市','lasa',0,'1092',0),
	(1093,1,27,'0,27','昌都地区','changdou',0,'1093',0),
	(1094,1,27,'0,27','山南地区','shannan',0,'1094',0),
	(1095,1,27,'0,27','日喀则地区','rikaze',0,'1095',0),
	(1096,1,27,'0,27','那曲地区','naqu',0,'1096',0),
	(1097,1,27,'0,27','阿里地区','ali',0,'1097',0),
	(1098,1,27,'0,27','林芝地区','linzhi',0,'1098',0),
	(1099,1,23,'0,23','西安市','xian',0,'1099',0),
	(1100,1,23,'0,23','铜川市','tongchuan',0,'1100',0),
	(1101,1,23,'0,23','宝鸡市','baoji',0,'1101',0),
	(1102,1,23,'0,23','咸阳市','xianyang',0,'1102',0),
	(1103,1,23,'0,23','渭南市','weinan',0,'1103',0),
	(1104,1,23,'0,23','延安市','yanan',0,'1104',0),
	(1105,1,23,'0,23','汉中市','hanzhong',0,'1105',0),
	(1106,1,23,'0,23','榆林市','yulin1',0,'1106',0),
	(1107,1,23,'0,23','安康市','ankang',0,'1107',0),
	(1108,1,23,'0,23','商洛市','shangluo',0,'1108',0),
	(1109,1,24,'0,24','兰州市','lanzhou',0,'1109',0),
	(1110,1,24,'0,24','嘉峪关市','jiayuguan',0,'1110',0),
	(1111,1,24,'0,24','白银市','baiyin',0,'1111',0),
	(1112,1,24,'0,24','天水市','tianshui',0,'1112',0),
	(1113,1,24,'0,24','武威市','wuwei',0,'1113',0),
	(1114,1,24,'0,24','张掖市','zhangye',0,'1114',0),
	(1115,1,24,'0,24','平凉市','pingliang',0,'1115',0),
	(1116,1,24,'0,24','酒泉市','jiuquan',0,'1116',0),
	(1117,1,24,'0,24','庆阳市','qingyang',0,'1117',0),
	(1118,1,24,'0,24','定西市','dingxi',0,'1118',0),
	(1119,1,24,'0,24','陇南市','longnan',0,'1119',0),
	(1120,1,24,'0,24','临夏自治州','linxiazhou',0,'1120',0),
	(1121,1,24,'0,24','甘南自治州','gannanzhou',0,'1121',0),
	(1122,1,25,'0,25','西宁市','xining',0,'1122',0),
	(1123,1,25,'0,25','海东地区','haidong',0,'1123',0),
	(1124,1,25,'0,25','海北自治州','haibeizhou',0,'1124',0),
	(1125,1,25,'0,25','黄南自治州','huangnanzhou',0,'1125',0),
	(1126,1,25,'0,25','海南自治州','hainanzhou',0,'1126',0),
	(1127,1,25,'0,25','果洛自治州','guoluozhou',0,'1127',0),
	(1128,1,25,'0,25','玉树自治州','yushuzhou',0,'1128',0),
	(1129,1,25,'0,25','海西自治州','haixizhou',0,'1129',0),
	(1130,1,26,'0,26','银川市','yinchuan',0,'1130',0),
	(1131,1,26,'0,26','石嘴山市','shizuishan',0,'1131',0),
	(1132,1,26,'0,26','吴忠市','wuzhong',0,'1132',0),
	(1133,1,26,'0,26','固原市','guyuan',0,'1133',0),
	(1134,1,26,'0,26','中卫市','zhongwei',0,'1134',0),
	(1135,1,28,'0,28','乌鲁木齐市','wulumuqi',0,'1135',0),
	(1136,1,28,'0,28','克拉玛依市','kelamayi',0,'1136',0),
	(1137,1,28,'0,28','吐鲁番地区','tulufan',0,'1137',0),
	(1138,1,28,'0,28','哈密地区','hami',0,'1138',0),
	(1139,1,28,'0,28','昌吉自治州','changjizhou',0,'1139',0),
	(1140,1,28,'0,28','博尔塔拉自治州','boertalazhou',0,'1140',0),
	(1141,1,28,'0,28','巴音郭楞自治州','bayinguolengzhou',0,'1141',0),
	(1142,1,28,'0,28','阿克苏地区','akesu',0,'1142',0),
	(1143,1,28,'0,28','克孜勒自治州','kezilezhou',0,'1143',0),
	(1144,1,28,'0,28','喀什地区','kashi',0,'1144',0),
	(1145,1,28,'0,28','和田地区','hetian',0,'1145',0),
	(1146,1,28,'0,28','伊犁自治州','yilizhou',0,'1146',0),
	(1147,1,28,'0,28','塔城地区','tacheng',0,'1147',0),
	(1148,1,28,'0,28','阿勒泰地区','aletai',0,'1148',0),
	(1149,1,17,'0,17','东莞市','dongguan',0,'1149',0);

/*!40000 ALTER TABLE `dr_linkage_data_1` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table dr_mail_queue
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_mail_queue`;

CREATE TABLE `dr_mail_queue` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `email` varchar(50) NOT NULL COMMENT '邮件地址',
  `subject` varchar(255) NOT NULL COMMENT '邮件标题',
  `message` text NOT NULL COMMENT '邮件内容',
  `status` tinyint(1) unsigned NOT NULL COMMENT '发送状态',
  `updatetime` int(10) unsigned NOT NULL COMMENT '更新时间',
  PRIMARY KEY (`id`),
  KEY `status` (`status`),
  KEY `updatetime` (`updatetime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='邮件队列表';



# Dump of table dr_mail_smtp
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_mail_smtp`;

CREATE TABLE `dr_mail_smtp` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `host` varchar(255) NOT NULL,
  `user` varchar(255) NOT NULL,
  `pass` varchar(255) NOT NULL,
  `port` mediumint(8) unsigned NOT NULL,
  `displayorder` tinyint(2) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `displayorder` (`displayorder`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='邮件账户表';



# Dump of table dr_member
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_member`;

CREATE TABLE `dr_member` (
  `uid` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `email` char(40) NOT NULL DEFAULT '' COMMENT '邮箱地址',
  `username` varchar(50) NOT NULL DEFAULT '' COMMENT '用户名',
  `password` char(32) NOT NULL DEFAULT '' COMMENT '加密密码',
  `salt` char(10) NOT NULL COMMENT '随机加密码',
  `name` varchar(50) NOT NULL COMMENT '姓名',
  `phone` char(20) NOT NULL COMMENT '手机号码',
  `avatar` varchar(255) NOT NULL COMMENT '头像地址',
  `money` decimal(10,2) unsigned NOT NULL COMMENT 'RMB',
  `freeze` decimal(10,2) unsigned NOT NULL COMMENT '冻结RMB',
  `spend` decimal(10,2) unsigned NOT NULL COMMENT '消费RMB总额',
  `score` int(10) unsigned NOT NULL COMMENT '虚拟币',
  `experience` int(10) unsigned NOT NULL COMMENT '经验值',
  `adminid` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '管理组id',
  `groupid` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '用户组id',
  `levelid` smallint(5) unsigned NOT NULL COMMENT '会员级别',
  `overdue` int(10) unsigned NOT NULL COMMENT '到期时间',
  `regip` varchar(15) NOT NULL COMMENT '注册ip',
  `regtime` int(10) unsigned NOT NULL COMMENT '注册时间',
  `randcode` mediumint(6) unsigned NOT NULL COMMENT '随机验证码',
  `ismobile` tinyint(1) unsigned DEFAULT NULL COMMENT '手机认证标识',
  PRIMARY KEY (`uid`),
  KEY `username` (`username`),
  KEY `email` (`email`),
  KEY `groupid` (`groupid`),
  KEY `adminid` (`adminid`),
  KEY `phone` (`phone`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='会员表';

LOCK TABLES `dr_member` WRITE;
/*!40000 ALTER TABLE `dr_member` DISABLE KEYS */;

INSERT INTO `dr_member` (`uid`, `email`, `username`, `password`, `salt`, `name`, `phone`, `avatar`, `money`, `freeze`, `spend`, `score`, `experience`, `adminid`, `groupid`, `levelid`, `overdue`, `regip`, `regtime`, `randcode`, `ismobile`)
VALUES
	(1,'{email}','admin','b742ddcf8bd6a3f8859f321de6c3c73e','fe9fc289c3','创始人','13999999999','1',0.00,0.00,4712.00,10000,10115,1,3,1,0,'',0,0,0);

/*!40000 ALTER TABLE `dr_member` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table dr_member_address
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_member_address`;

CREATE TABLE `dr_member_address` (
  `id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `uid` mediumint(8) unsigned NOT NULL COMMENT '会员id',
  `city` mediumint(8) unsigned NOT NULL COMMENT '城市id',
  `name` varchar(50) NOT NULL COMMENT '姓名',
  `phone` varchar(20) NOT NULL COMMENT '电话',
  `zipcode` varchar(10) NOT NULL COMMENT '邮编',
  `address` varchar(255) NOT NULL COMMENT '地址',
  `default` tinyint(1) unsigned NOT NULL COMMENT '是否默认',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`,`default`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='会员收货地址表';



# Dump of table dr_member_cash_account
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_member_cash_account`;

CREATE TABLE `dr_member_cash_account` (
  `uid` mediumint(8) unsigned NOT NULL COMMENT '申请人uid',
  `bank` varchar(50) NOT NULL COMMENT '银行名称',
  `branch` varchar(100) NOT NULL COMMENT '开户网点',
  `account` varchar(50) NOT NULL COMMENT '收款帐号',
  `truename` varchar(50) NOT NULL COMMENT '收款户名',
  PRIMARY KEY (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='会员申请提现账号';




# Dump of table dr_member_cash_log
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_member_cash_log`;

CREATE TABLE `dr_member_cash_log` (
  `id` bigint(20) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '申请人uid',
  `username` varchar(50) NOT NULL COMMENT '申请人账号',
  `bank` varchar(50) NOT NULL COMMENT '银行名称',
  `branch` varchar(100) NOT NULL COMMENT '开户网点',
  `account` varchar(50) NOT NULL COMMENT '收款帐号',
  `truename` varchar(50) NOT NULL COMMENT '收款户名',
  `amount` decimal(10,2) unsigned NOT NULL DEFAULT '0.00' COMMENT '提款金额',
  `fee` decimal(10,2) unsigned NOT NULL DEFAULT '0.00' COMMENT '手续费',
  `inputip` varchar(50) NOT NULL DEFAULT '' COMMENT '申请IP',
  `inputtime` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '申请时间',
  `euid` mediumint(8) unsigned NOT NULL COMMENT '处理人uid',
  `editor` varchar(30) NOT NULL DEFAULT '' COMMENT '处理人账号',
  `edittime` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '处理时间',
  `note` text COMMENT '处理备注',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '处理状态',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `uid_2` (`uid`,`status`),
  KEY `username` (`username`),
  KEY `inputtime` (`inputtime`),
  KEY `euid` (`euid`),
  KEY `editor` (`editor`),
  KEY `edittime` (`edittime`),
  KEY `status` (`status`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='会员申请提现记录';



# Dump of table dr_member_data
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_member_data`;

CREATE TABLE `dr_member_data` (
  `uid` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `complete` tinyint(1) unsigned NOT NULL COMMENT '完善资料标识',
  `is_auth` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '实名认证标识',
  PRIMARY KEY (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='会员表';

LOCK TABLES `dr_member_data` WRITE;
/*!40000 ALTER TABLE `dr_member_data` DISABLE KEYS */;

INSERT INTO `dr_member_data` (`uid`, `complete`, `is_auth`)
VALUES
	(1,1,0);

/*!40000 ALTER TABLE `dr_member_data` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table dr_member_group
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_member_group`;

CREATE TABLE `dr_member_group` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `name` text NOT NULL COMMENT '会员组名称',
  `theme` varchar(255) NOT NULL COMMENT '风格目录',
  `template` varchar(50) NOT NULL COMMENT '模板目录',
  `price` decimal(10,2) NOT NULL COMMENT '售价',
  `unit` tinyint(1) unsigned NOT NULL COMMENT '价格单位:1虚拟卡，2金钱',
  `limit` tinyint(1) unsigned NOT NULL COMMENT '售价限制：1月，2半年，3年',
  `overdue` smallint(5) unsigned NOT NULL COMMENT '过期后变成的组',
  `allowapply` tinyint(1) unsigned NOT NULL COMMENT '是否允许会员申请',
  `allowspace` tinyint(1) unsigned NOT NULL COMMENT '是否允许会员空间',
  `allowfield` text NOT NULL COMMENT '可用字段，序列化数组格式',
  `spacefield` text NOT NULL COMMENT '空间字段，序列化数组格式',
  `spacedomain` tinyint(1) unsigned DEFAULT NULL COMMENT '是否启用空间域名',
  `spacetemplate` varchar(50) DEFAULT NULL COMMENT '空间默认模板',
  `displayorder` tinyint(3) NOT NULL COMMENT '排序',
  PRIMARY KEY (`id`),
  KEY `displayorder` (`displayorder`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='会员组表';

LOCK TABLES `dr_member_group` WRITE;
/*!40000 ALTER TABLE `dr_member_group` DISABLE KEYS */;

INSERT INTO `dr_member_group` (`id`, `name`, `theme`, `template`, `price`, `unit`, `limit`, `overdue`, `allowapply`, `allowspace`, `allowfield`, `spacefield`, `spacedomain`, `spacetemplate`, `displayorder`)
VALUES
	(3,'广告主','default','default',0.00,1,1,3,0,0,'','',0,NULL,0),
	(4,'媒体主','default','default',0.00,2,4,3,0,0,'','',0,NULL,0);

/*!40000 ALTER TABLE `dr_member_group` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table dr_member_level
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_member_level`;

CREATE TABLE `dr_member_level` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `groupid` smallint(5) unsigned NOT NULL,
  `name` varchar(255) NOT NULL COMMENT '会员级别名称',
  `stars` tinyint(2) NOT NULL COMMENT '星星数量',
  `experience` int(10) unsigned NOT NULL COMMENT '经验值要求',
  `allowupgrade` tinyint(1) NOT NULL COMMENT '允许自动升级',
  PRIMARY KEY (`id`),
  KEY `experience` (`experience`),
  KEY `groupid` (`groupid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='会员级别表';

LOCK TABLES `dr_member_level` WRITE;
/*!40000 ALTER TABLE `dr_member_level` DISABLE KEYS */;

INSERT INTO `dr_member_level` (`id`, `groupid`, `name`, `stars`, `experience`, `allowupgrade`)
VALUES
	(1,3,'初级',1,0,0),
	(5,4,'普通',16,0,0);

/*!40000 ALTER TABLE `dr_member_level` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table dr_member_login
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_member_login`;

CREATE TABLE `dr_member_login` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` mediumint(8) unsigned DEFAULT NULL COMMENT '会员uid',
  `oauthid` varchar(30) NOT NULL COMMENT '快捷登录方式',
  `loginip` varchar(50) NOT NULL COMMENT '登录Ip',
  `logintime` int(10) unsigned NOT NULL COMMENT '登录时间',
  `useragent` varchar(255) NOT NULL COMMENT '客户端信息',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `loginip` (`loginip`),
  KEY `logintime` (`logintime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='登录日志记录';


# Dump of table dr_member_menu
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_member_menu`;

CREATE TABLE `dr_member_menu` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `pid` smallint(5) unsigned NOT NULL COMMENT '上级菜单id',
  `name` text NOT NULL COMMENT '菜单名称',
  `uri` varchar(255) DEFAULT NULL COMMENT 'uri字符串',
  `url` varchar(255) DEFAULT NULL COMMENT 'url',
  `mark` varchar(50) DEFAULT NULL COMMENT '菜单标识',
  `hidden` tinyint(1) unsigned DEFAULT NULL COMMENT '是否隐藏',
  `target` tinyint(3) unsigned DEFAULT NULL COMMENT '新窗口',
  `displayorder` tinyint(3) unsigned DEFAULT NULL COMMENT '排序值',
  `icon` varchar(30) DEFAULT NULL COMMENT '图标',
  PRIMARY KEY (`id`),
  KEY `list` (`pid`),
  KEY `displayorder` (`displayorder`),
  KEY `mark` (`mark`),
  KEY `hidden` (`hidden`),
  KEY `uri` (`uri`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='会员菜单表';



# Dump of table dr_member_new_notice
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_member_new_notice`;

CREATE TABLE `dr_member_new_notice` (
  `uid` smallint(8) unsigned NOT NULL,
  PRIMARY KEY (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='新通知提醒表';



# Dump of table dr_member_notice_0
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_member_notice_0`;

CREATE TABLE `dr_member_notice_0` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type` tinyint(1) unsigned NOT NULL COMMENT '类型',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '通知者uid',
  `isnew` tinyint(1) unsigned NOT NULL COMMENT '新提醒',
  `content` text NOT NULL COMMENT '通知内容',
  `inputtime` int(10) unsigned NOT NULL COMMENT '提交时间',
  PRIMARY KEY (`id`),
  KEY `isnew` (`isnew`),
  KEY `type` (`type`,`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='会员通知提醒表';



# Dump of table dr_member_notice_1
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_member_notice_1`;

CREATE TABLE `dr_member_notice_1` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type` tinyint(1) unsigned NOT NULL COMMENT '类型',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '通知者uid',
  `isnew` tinyint(1) unsigned NOT NULL COMMENT '新提醒',
  `content` text NOT NULL COMMENT '通知内容',
  `inputtime` int(10) unsigned NOT NULL COMMENT '提交时间',
  PRIMARY KEY (`id`),
  KEY `isnew` (`isnew`),
  KEY `type` (`type`,`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='会员通知提醒表';



# Dump of table dr_member_notice_2
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_member_notice_2`;

CREATE TABLE `dr_member_notice_2` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type` tinyint(1) unsigned NOT NULL COMMENT '类型',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '通知者uid',
  `isnew` tinyint(1) unsigned NOT NULL COMMENT '新提醒',
  `content` text NOT NULL COMMENT '通知内容',
  `inputtime` int(10) unsigned NOT NULL COMMENT '提交时间',
  PRIMARY KEY (`id`),
  KEY `isnew` (`isnew`),
  KEY `type` (`type`,`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='会员通知提醒表';



# Dump of table dr_member_notice_3
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_member_notice_3`;

CREATE TABLE `dr_member_notice_3` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type` tinyint(1) unsigned NOT NULL COMMENT '类型',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '通知者uid',
  `isnew` tinyint(1) unsigned NOT NULL COMMENT '新提醒',
  `content` text NOT NULL COMMENT '通知内容',
  `inputtime` int(10) unsigned NOT NULL COMMENT '提交时间',
  PRIMARY KEY (`id`),
  KEY `isnew` (`isnew`),
  KEY `type` (`type`,`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='会员通知提醒表';



# Dump of table dr_member_notice_4
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_member_notice_4`;

CREATE TABLE `dr_member_notice_4` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type` tinyint(1) unsigned NOT NULL COMMENT '类型',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '通知者uid',
  `isnew` tinyint(1) unsigned NOT NULL COMMENT '新提醒',
  `content` text NOT NULL COMMENT '通知内容',
  `inputtime` int(10) unsigned NOT NULL COMMENT '提交时间',
  PRIMARY KEY (`id`),
  KEY `isnew` (`isnew`),
  KEY `type` (`type`,`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='会员通知提醒表';



# Dump of table dr_member_notice_5
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_member_notice_5`;

CREATE TABLE `dr_member_notice_5` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type` tinyint(1) unsigned NOT NULL COMMENT '类型',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '通知者uid',
  `isnew` tinyint(1) unsigned NOT NULL COMMENT '新提醒',
  `content` text NOT NULL COMMENT '通知内容',
  `inputtime` int(10) unsigned NOT NULL COMMENT '提交时间',
  PRIMARY KEY (`id`),
  KEY `isnew` (`isnew`),
  KEY `type` (`type`,`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='会员通知提醒表';



# Dump of table dr_member_notice_6
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_member_notice_6`;

CREATE TABLE `dr_member_notice_6` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type` tinyint(1) unsigned NOT NULL COMMENT '类型',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '通知者uid',
  `isnew` tinyint(1) unsigned NOT NULL COMMENT '新提醒',
  `content` text NOT NULL COMMENT '通知内容',
  `inputtime` int(10) unsigned NOT NULL COMMENT '提交时间',
  PRIMARY KEY (`id`),
  KEY `isnew` (`isnew`),
  KEY `type` (`type`,`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='会员通知提醒表';



# Dump of table dr_member_notice_7
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_member_notice_7`;

CREATE TABLE `dr_member_notice_7` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type` tinyint(1) unsigned NOT NULL COMMENT '类型',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '通知者uid',
  `isnew` tinyint(1) unsigned NOT NULL COMMENT '新提醒',
  `content` text NOT NULL COMMENT '通知内容',
  `inputtime` int(10) unsigned NOT NULL COMMENT '提交时间',
  PRIMARY KEY (`id`),
  KEY `isnew` (`isnew`),
  KEY `type` (`type`,`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='会员通知提醒表';



# Dump of table dr_member_notice_8
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_member_notice_8`;

CREATE TABLE `dr_member_notice_8` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type` tinyint(1) unsigned NOT NULL COMMENT '类型',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '通知者uid',
  `isnew` tinyint(1) unsigned NOT NULL COMMENT '新提醒',
  `content` text NOT NULL COMMENT '通知内容',
  `inputtime` int(10) unsigned NOT NULL COMMENT '提交时间',
  PRIMARY KEY (`id`),
  KEY `isnew` (`isnew`),
  KEY `type` (`type`,`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='会员通知提醒表';



# Dump of table dr_member_notice_9
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_member_notice_9`;

CREATE TABLE `dr_member_notice_9` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type` tinyint(1) unsigned NOT NULL COMMENT '类型',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '通知者uid',
  `isnew` tinyint(1) unsigned NOT NULL COMMENT '新提醒',
  `content` text NOT NULL COMMENT '通知内容',
  `inputtime` int(10) unsigned NOT NULL COMMENT '提交时间',
  PRIMARY KEY (`id`),
  KEY `isnew` (`isnew`),
  KEY `type` (`type`,`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='会员通知提醒表';



# Dump of table dr_member_oauth
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_member_oauth`;

CREATE TABLE `dr_member_oauth` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `uid` mediumint(8) unsigned NOT NULL COMMENT '会员uid',
  `oid` varchar(255) NOT NULL COMMENT 'OAuth返回id',
  `oauth` varchar(255) NOT NULL,
  `avatar` varchar(255) NOT NULL,
  `nickname` varchar(255) NOT NULL,
  `expire_at` int(10) unsigned NOT NULL,
  `access_token` varchar(255) DEFAULT NULL,
  `refresh_token` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='会员OAuth2授权表';



# Dump of table dr_member_online
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_member_online`;

CREATE TABLE `dr_member_online` (
  `uid` mediumint(8) unsigned NOT NULL AUTO_INCREMENT,
  `time` int(10) unsigned NOT NULL COMMENT '在线时间',
  PRIMARY KEY (`uid`),
  KEY `time` (`time`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='会员在线情况表';

LOCK TABLES `dr_member_online` WRITE;
/*!40000 ALTER TABLE `dr_member_online` DISABLE KEYS */;

INSERT INTO `dr_member_online` (`uid`, `time`)
VALUES
	(1,1465527611);

/*!40000 ALTER TABLE `dr_member_online` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table dr_member_paylog
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_member_paylog`;

CREATE TABLE `dr_member_paylog` (
  `id` bigint(15) unsigned NOT NULL AUTO_INCREMENT,
  `uid` mediumint(8) unsigned NOT NULL,
  `value` decimal(10,2) NOT NULL COMMENT '价格',
  `type` varchar(20) NOT NULL COMMENT '类型',
  `status` tinyint(1) unsigned NOT NULL COMMENT '状态',
  `order` varchar(100) NOT NULL COMMENT '订单号',
  `module` varchar(30) NOT NULL COMMENT '应用或模块目录',
  `note` varchar(255) NOT NULL COMMENT '备注',
  `inputtime` int(10) unsigned NOT NULL COMMENT '时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `order` (`order`),
  KEY `status` (`status`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='支付记录表';



# Dump of table dr_member_scorelog
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_member_scorelog`;

CREATE TABLE `dr_member_scorelog` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `type` tinyint(1) unsigned NOT NULL COMMENT '积分0,虚拟币1',
  `value` int(10) NOT NULL COMMENT '分数变化值',
  `mark` varchar(50) NOT NULL COMMENT '标记',
  `note` varchar(255) NOT NULL COMMENT '备注',
  `inputtime` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `type` (`type`),
  KEY `mark` (`mark`),
  KEY `inputtime` (`inputtime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='得分日志';



# Dump of table dr_member_setting
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_member_setting`;

CREATE TABLE `dr_member_setting` (
  `name` varchar(50) NOT NULL,
  `value` text NOT NULL,
  PRIMARY KEY (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='会员属性参数表';

LOCK TABLES `dr_member_setting` WRITE;
/*!40000 ALTER TABLE `dr_member_setting` DISABLE KEYS */;

INSERT INTO `dr_member_setting` (`name`, `value`)
VALUES
	('member','a:15:{s:8:\\\"pagesize\\\";s:2:\\\"10\\\";s:6:\\\"domain\\\";a:1:{i:1;s:0:\\\"\\\";}s:7:\\\"urlrule\\\";s:1:\\\"0\\\";s:8:\\\"register\\\";s:1:\\\"1\\\";s:8:\\\"regfield\\\";a:2:{i:0;s:8:\\\"username\\\";i:1;s:5:\\\"phone\\\";}s:9:\\\"regverify\\\";s:1:\\\"0\\\";s:9:\\\"regiptime\\\";s:0:\\\"\\\";s:11:\\\"regnamerule\\\";s:14:\\\"/^[0-9a-z]+$/i\\\";s:11:\\\"regnotallow\\\";s:0:\\\"\\\";s:7:\\\"ucenter\\\";s:1:\\\"0\\\";s:10:\\\"ucentercfg\\\";s:0:\\\"\\\";s:5:\\\"field\\\";s:0:\\\"\\\";s:7:\\\"mbfield\\\";s:0:\\\"\\\";s:10:\\\"mergefield\\\";s:166:\\\"					</div>\n				</div>\n<div class=\\\"portlet light\\\" id=\\\"dr_{name}\\\">\n					<div class=\\\"portlet-title mytitle\\\">\n						{text}\n					</div>\n<div class=\\\"portlet-body\\\">\n{value}\\\";s:12:\\\"mbmergefield\\\";s:166:\\\"					</div>\n				</div>\n<div class=\\\"portlet light\\\" id=\\\"dr_{name}\\\">\n					<div class=\\\"portlet-title mytitle\\\">\n						{text}\n					</div>\n<div class=\\\"portlet-body\\\">\n{value}\\\";}'),
	('cash','a:2:{s:2:\\\"fl\\\";s:1:\\\"1\\\";s:3:\\\"min\\\";s:3:\\\"100\\\";}'),
	('permission','a:10:{i:1;a:13:{s:16:\\\"login_experience\\\";s:1:\\\"1\\\";s:11:\\\"login_score\\\";s:1:\\\"0\\\";s:17:\\\"avatar_experience\\\";s:2:\\\"10\\\";s:12:\\\"avatar_score\\\";s:1:\\\"0\\\";s:19:\\\"complete_experience\\\";s:2:\\\"10\\\";s:14:\\\"complete_score\\\";s:1:\\\"0\\\";s:15:\\\"bang_experience\\\";s:2:\\\"10\\\";s:10:\\\"bang_score\\\";s:1:\\\"0\\\";s:14:\\\"jie_experience\\\";s:3:\\\"-10\\\";s:9:\\\"jie_score\\\";s:1:\\\"0\\\";s:17:\\\"update_experience\\\";s:1:\\\"1\\\";s:12:\\\"update_score\\\";s:1:\\\"0\\\";s:10:\\\"attachsize\\\";s:1:\\\"0\\\";}i:2;a:14:{s:16:\\\"login_experience\\\";s:1:\\\"5\\\";s:11:\\\"login_score\\\";s:1:\\\"0\\\";s:17:\\\"avatar_experience\\\";s:2:\\\"10\\\";s:12:\\\"avatar_score\\\";s:1:\\\"0\\\";s:19:\\\"complete_experience\\\";s:2:\\\"10\\\";s:14:\\\"complete_score\\\";s:1:\\\"0\\\";s:15:\\\"bang_experience\\\";s:2:\\\"10\\\";s:10:\\\"bang_score\\\";s:1:\\\"0\\\";s:14:\\\"jie_experience\\\";s:3:\\\"-10\\\";s:9:\\\"jie_score\\\";s:1:\\\"0\\\";s:17:\\\"update_experience\\\";s:1:\\\"1\\\";s:12:\\\"update_score\\\";s:1:\\\"0\\\";s:11:\\\"is_download\\\";s:1:\\\"1\\\";s:10:\\\"attachsize\\\";s:1:\\\"5\\\";}s:3:\\\"3_1\\\";a:15:{s:16:\\\"login_experience\\\";s:1:\\\"5\\\";s:11:\\\"login_score\\\";s:1:\\\"0\\\";s:17:\\\"avatar_experience\\\";s:2:\\\"10\\\";s:12:\\\"avatar_score\\\";s:1:\\\"0\\\";s:19:\\\"complete_experience\\\";s:2:\\\"10\\\";s:14:\\\"complete_score\\\";s:1:\\\"0\\\";s:15:\\\"bang_experience\\\";s:2:\\\"10\\\";s:10:\\\"bang_score\\\";s:1:\\\"0\\\";s:14:\\\"jie_experience\\\";s:3:\\\"-10\\\";s:9:\\\"jie_score\\\";s:1:\\\"0\\\";s:17:\\\"update_experience\\\";s:1:\\\"2\\\";s:12:\\\"update_score\\\";s:1:\\\"0\\\";s:9:\\\"is_upload\\\";s:1:\\\"1\\\";s:11:\\\"is_download\\\";s:1:\\\"1\\\";s:10:\\\"attachsize\\\";s:2:\\\"10\\\";}s:3:\\\"3_2\\\";a:15:{s:16:\\\"login_experience\\\";s:1:\\\"5\\\";s:11:\\\"login_score\\\";s:1:\\\"0\\\";s:17:\\\"avatar_experience\\\";s:2:\\\"10\\\";s:12:\\\"avatar_score\\\";s:1:\\\"0\\\";s:19:\\\"complete_experience\\\";s:2:\\\"10\\\";s:14:\\\"complete_score\\\";s:1:\\\"0\\\";s:15:\\\"bang_experience\\\";s:2:\\\"10\\\";s:10:\\\"bang_score\\\";s:1:\\\"0\\\";s:14:\\\"jie_experience\\\";s:3:\\\"-10\\\";s:9:\\\"jie_score\\\";s:1:\\\"0\\\";s:17:\\\"update_experience\\\";s:1:\\\"2\\\";s:12:\\\"update_score\\\";s:1:\\\"0\\\";s:9:\\\"is_upload\\\";s:1:\\\"1\\\";s:11:\\\"is_download\\\";s:1:\\\"1\\\";s:10:\\\"attachsize\\\";s:2:\\\"10\\\";}s:3:\\\"3_3\\\";a:15:{s:16:\\\"login_experience\\\";s:1:\\\"5\\\";s:11:\\\"login_score\\\";s:1:\\\"0\\\";s:17:\\\"avatar_experience\\\";s:2:\\\"10\\\";s:12:\\\"avatar_score\\\";s:1:\\\"0\\\";s:19:\\\"complete_experience\\\";s:2:\\\"10\\\";s:14:\\\"complete_score\\\";s:1:\\\"0\\\";s:15:\\\"bang_experience\\\";s:2:\\\"10\\\";s:10:\\\"bang_score\\\";s:1:\\\"0\\\";s:14:\\\"jie_experience\\\";s:2:\\\"10\\\";s:9:\\\"jie_score\\\";s:1:\\\"0\\\";s:17:\\\"update_experience\\\";s:1:\\\"2\\\";s:12:\\\"update_score\\\";s:1:\\\"0\\\";s:9:\\\"is_upload\\\";s:1:\\\"1\\\";s:11:\\\"is_download\\\";s:1:\\\"1\\\";s:10:\\\"attachsize\\\";s:2:\\\"20\\\";}s:3:\\\"3_4\\\";a:15:{s:16:\\\"login_experience\\\";s:1:\\\"5\\\";s:11:\\\"login_score\\\";s:1:\\\"0\\\";s:17:\\\"avatar_experience\\\";s:2:\\\"10\\\";s:12:\\\"avatar_score\\\";s:1:\\\"0\\\";s:19:\\\"complete_experience\\\";s:2:\\\"10\\\";s:14:\\\"complete_score\\\";s:1:\\\"0\\\";s:15:\\\"bang_experience\\\";s:2:\\\"10\\\";s:10:\\\"bang_score\\\";s:1:\\\"0\\\";s:14:\\\"jie_experience\\\";s:3:\\\"-10\\\";s:9:\\\"jie_score\\\";s:1:\\\"0\\\";s:17:\\\"update_experience\\\";s:1:\\\"3\\\";s:12:\\\"update_score\\\";s:1:\\\"0\\\";s:9:\\\"is_upload\\\";s:1:\\\"1\\\";s:11:\\\"is_download\\\";s:1:\\\"1\\\";s:10:\\\"attachsize\\\";s:2:\\\"30\\\";}s:3:\\\"4_5\\\";a:15:{s:16:\\\"login_experience\\\";s:2:\\\"10\\\";s:11:\\\"login_score\\\";s:1:\\\"0\\\";s:17:\\\"avatar_experience\\\";s:2:\\\"10\\\";s:12:\\\"avatar_score\\\";s:1:\\\"0\\\";s:19:\\\"complete_experience\\\";s:2:\\\"10\\\";s:14:\\\"complete_score\\\";s:1:\\\"0\\\";s:15:\\\"bang_experience\\\";s:2:\\\"10\\\";s:10:\\\"bang_score\\\";s:1:\\\"0\\\";s:14:\\\"jie_experience\\\";s:2:\\\"10\\\";s:9:\\\"jie_score\\\";s:1:\\\"0\\\";s:17:\\\"update_experience\\\";s:1:\\\"5\\\";s:12:\\\"update_score\\\";s:1:\\\"0\\\";s:9:\\\"is_upload\\\";s:1:\\\"1\\\";s:11:\\\"is_download\\\";s:1:\\\"1\\\";s:10:\\\"attachsize\\\";s:2:\\\"50\\\";}s:3:\\\"4_6\\\";a:15:{s:16:\\\"login_experience\\\";s:2:\\\"10\\\";s:11:\\\"login_score\\\";s:1:\\\"0\\\";s:17:\\\"avatar_experience\\\";s:2:\\\"10\\\";s:12:\\\"avatar_score\\\";s:1:\\\"0\\\";s:19:\\\"complete_experience\\\";s:2:\\\"10\\\";s:14:\\\"complete_score\\\";s:1:\\\"0\\\";s:15:\\\"bang_experience\\\";s:2:\\\"10\\\";s:10:\\\"bang_score\\\";s:1:\\\"0\\\";s:14:\\\"jie_experience\\\";s:3:\\\"-10\\\";s:9:\\\"jie_score\\\";s:1:\\\"0\\\";s:17:\\\"update_experience\\\";s:1:\\\"5\\\";s:12:\\\"update_score\\\";s:1:\\\"0\\\";s:9:\\\"is_upload\\\";s:1:\\\"1\\\";s:11:\\\"is_download\\\";s:1:\\\"1\\\";s:10:\\\"attachsize\\\";s:2:\\\"70\\\";}s:3:\\\"4_7\\\";a:15:{s:16:\\\"login_experience\\\";s:2:\\\"10\\\";s:11:\\\"login_score\\\";s:1:\\\"0\\\";s:17:\\\"avatar_experience\\\";s:2:\\\"10\\\";s:12:\\\"avatar_score\\\";s:1:\\\"0\\\";s:19:\\\"complete_experience\\\";s:2:\\\"10\\\";s:14:\\\"complete_score\\\";s:1:\\\"0\\\";s:15:\\\"bang_experience\\\";s:2:\\\"10\\\";s:10:\\\"bang_score\\\";s:1:\\\"0\\\";s:14:\\\"jie_experience\\\";s:3:\\\"-10\\\";s:9:\\\"jie_score\\\";s:1:\\\"0\\\";s:17:\\\"update_experience\\\";s:1:\\\"5\\\";s:12:\\\"update_score\\\";s:1:\\\"0\\\";s:9:\\\"is_upload\\\";s:1:\\\"1\\\";s:11:\\\"is_download\\\";s:1:\\\"1\\\";s:10:\\\"attachsize\\\";s:3:\\\"100\\\";}s:3:\\\"4_8\\\";a:15:{s:16:\\\"login_experience\\\";s:2:\\\"10\\\";s:11:\\\"login_score\\\";s:1:\\\"0\\\";s:17:\\\"avatar_experience\\\";s:2:\\\"10\\\";s:12:\\\"avatar_score\\\";s:1:\\\"0\\\";s:19:\\\"complete_experience\\\";s:2:\\\"10\\\";s:14:\\\"complete_score\\\";s:1:\\\"0\\\";s:15:\\\"bang_experience\\\";s:2:\\\"10\\\";s:10:\\\"bang_score\\\";s:1:\\\"0\\\";s:14:\\\"jie_experience\\\";s:3:\\\"-10\\\";s:9:\\\"jie_score\\\";s:1:\\\"0\\\";s:17:\\\"update_experience\\\";s:1:\\\"5\\\";s:12:\\\"update_score\\\";s:1:\\\"0\\\";s:9:\\\"is_upload\\\";s:1:\\\"1\\\";s:11:\\\"is_download\\\";s:1:\\\"1\\\";s:10:\\\"attachsize\\\";s:1:\\\"0\\\";}}'),
	('pay','a:2:{s:3:\\\"use\\\";a:5:{i:0;s:6:\\\"alipay\\\";i:1;s:9:\\\"chinabank\\\";i:2;s:6:\\\"paypal\\\";i:3;s:6:\\\"tenpay\\\";i:4;s:6:\\\"weixin\\\";}s:5:\\\"order\\\";a:5:{s:6:\\\"weixin\\\";s:1:\\\"0\\\";s:6:\\\"tenpay\\\";s:1:\\\"0\\\";s:6:\\\"paypal\\\";s:1:\\\"0\\\";s:9:\\\"chinabank\\\";s:1:\\\"0\\\";s:6:\\\"alipay\\\";s:1:\\\"0\\\";}}'),
	('space','a:9:{s:6:\\\"domain\\\";s:0:\\\"\\\";s:4:\\\"edit\\\";s:1:\\\"1\\\";s:6:\\\"verify\\\";s:1:\\\"0\\\";s:7:\\\"rewrite\\\";s:1:\\\"0\\\";s:7:\\\"seojoin\\\";s:1:\\\"_\\\";s:5:\\\"title\\\";s:41:\\\"会员空间_FineCMS自助建站平台！\\\";s:8:\\\"keywords\\\";s:0:\\\"\\\";s:11:\\\"description\\\";s:0:\\\"\\\";s:4:\\\"flag\\\";a:9:{i:1;a:1:{s:4:\\\"name\\\";s:12:\\\"达人空间\\\";}i:2;a:1:{s:4:\\\"name\\\";s:12:\\\"推荐空间\\\";}i:3;a:1:{s:4:\\\"name\\\";s:0:\\\"\\\";}i:4;a:1:{s:4:\\\"name\\\";s:0:\\\"\\\";}i:5;a:1:{s:4:\\\"name\\\";s:0:\\\"\\\";}i:6;a:1:{s:4:\\\"name\\\";s:0:\\\"\\\";}i:7;a:1:{s:4:\\\"name\\\";s:0:\\\"\\\";}i:8;a:1:{s:4:\\\"name\\\";s:0:\\\"\\\";}i:9;a:1:{s:4:\\\"name\\\";s:0:\\\"\\\";}}}');

/*!40000 ALTER TABLE `dr_member_setting` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table dr_module
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_module`;

CREATE TABLE `dr_module` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `site` text COMMENT '站点划分',
  `dirname` varchar(50) NOT NULL COMMENT '目录名称',
  `share` tinyint(1) unsigned DEFAULT NULL COMMENT '是否共享模块',
  `extend` tinyint(1) unsigned DEFAULT NULL COMMENT '是否是扩展模块',
  `sitemap` tinyint(1) unsigned DEFAULT NULL COMMENT '是否生成地图',
  `setting` text COMMENT '配置信息',
  `disabled` tinyint(1) NOT NULL DEFAULT '0' COMMENT '禁用？',
  `displayorder` tinyint(2) DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `dirname` (`dirname`),
  KEY `displayorder` (`displayorder`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='模块表';

LOCK TABLES `dr_module` WRITE;
/*!40000 ALTER TABLE `dr_module` DISABLE KEYS */;

INSERT INTO `dr_module` (`id`, `site`, `dirname`, `share`, `extend`, `sitemap`, `setting`, `disabled`, `displayorder`)
VALUES
	(1,'a:1:{i:1;a:5:{s:3:\\\"use\\\";i:1;s:4:\\\"html\\\";i:0;s:5:\\\"theme\\\";s:7:\\\"default\\\";s:6:\\\"domain\\\";s:0:\\\"\\\";s:8:\\\"template\\\";s:7:\\\"default\\\";}}','news',0,0,1,'a:4:{s:4:\\\"flag\\\";a:9:{i:1;a:3:{s:4:\\\"name\\\";s:12:\\\"推荐首页\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:2;a:3:{s:4:\\\"name\\\";s:12:\\\"推荐频道\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:3;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:4;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:5;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:6;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:7;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:8;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:9;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}}s:6:\\\"search\\\";a:3:{s:5:\\\"close\\\";s:1:\\\"0\\\";s:5:\\\"total\\\";s:3:\\\"500\\\";s:6:\\\"length\\\";s:1:\\\"4\\\";}s:9:\\\"syn2field\\\";s:0:\\\"\\\";s:6:\\\"config\\\";a:0:{}}',0,0),
	(2,'a:1:{i:1;a:5:{s:3:\\\"use\\\";i:1;s:4:\\\"html\\\";i:0;s:5:\\\"theme\\\";s:7:\\\"default\\\";s:6:\\\"domain\\\";s:0:\\\"\\\";s:8:\\\"template\\\";s:7:\\\"default\\\";}}','order',0,0,1,'a:1:{i:1;a:3:{s:10:\\\"permission\\\";a:1:{s:3:\\\"buy\\\";a:1:{s:3:\\\"use\\\";a:4:{i:0;s:1:\\\"1\\\";i:1;s:1:\\\"2\\\";i:2;s:1:\\\"3\\\";i:3;s:1:\\\"4\\\";}}}s:6:\\\"module\\\";a:4:{s:4:\\\"news\\\";a:6:{s:3:\\\"use\\\";s:1:\\\"1\\\";s:6:\\\"volume\\\";s:1:\\\"0\\\";s:8:\\\"quantity\\\";s:1:\\\"0\\\";s:8:\\\"shipping\\\";s:1:\\\"0\\\";s:3:\\\"pay\\\";s:1:\\\"0\\\";s:8:\\\"k_volume\\\";s:1:\\\"0\\\";}s:5:\\\"weibo\\\";a:6:{s:3:\\\"use\\\";s:1:\\\"1\\\";s:6:\\\"volume\\\";s:1:\\\"0\\\";s:8:\\\"quantity\\\";s:1:\\\"0\\\";s:8:\\\"shipping\\\";s:1:\\\"0\\\";s:3:\\\"pay\\\";s:1:\\\"0\\\";s:8:\\\"k_volume\\\";s:1:\\\"0\\\";}s:4:\\\"quan\\\";a:6:{s:3:\\\"use\\\";s:1:\\\"1\\\";s:6:\\\"volume\\\";s:1:\\\"0\\\";s:8:\\\"quantity\\\";s:1:\\\"0\\\";s:8:\\\"shipping\\\";s:1:\\\"0\\\";s:3:\\\"pay\\\";s:1:\\\"0\\\";s:8:\\\"k_volume\\\";s:1:\\\"0\\\";}s:6:\\\"weixin\\\";a:6:{s:3:\\\"use\\\";s:1:\\\"1\\\";s:6:\\\"volume\\\";s:1:\\\"0\\\";s:8:\\\"quantity\\\";s:1:\\\"0\\\";s:8:\\\"shipping\\\";s:1:\\\"0\\\";s:3:\\\"pay\\\";s:1:\\\"0\\\";s:8:\\\"k_volume\\\";s:1:\\\"0\\\";}}s:6:\\\"config\\\";a:8:{s:2:\\\"sn\\\";s:2:\\\"RS\\\";s:5:\\\"otime\\\";s:2:\\\"10\\\";s:5:\\\"close\\\";s:32:\\\"不想要了\n价格太贵\n假号\\\";s:10:\\\"cart_title\\\";s:12:\\\"媒体投放\\\";s:11:\\\"order_title\\\";s:0:\\\"\\\";s:9:\\\"buy_title\\\";s:0:\\\"\\\";s:2:\\\"id\\\";s:0:\\\"\\\";s:3:\\\"key\\\";s:0:\\\"\\\";}}}',0,0),
	(3,'a:1:{i:1;a:5:{s:3:\\\"use\\\";i:1;s:4:\\\"html\\\";i:0;s:5:\\\"theme\\\";s:7:\\\"default\\\";s:6:\\\"domain\\\";s:0:\\\"\\\";s:8:\\\"template\\\";s:7:\\\"default\\\";}}','weibo',0,0,1,'a:4:{s:4:\\\"flag\\\";a:9:{i:1;a:3:{s:4:\\\"name\\\";s:12:\\\"推荐首页\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:2;a:3:{s:4:\\\"name\\\";s:12:\\\"推荐频道\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:3;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:4;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:5;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:6;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:7;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:8;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:9;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}}s:6:\\\"search\\\";a:3:{s:5:\\\"close\\\";s:1:\\\"0\\\";s:5:\\\"total\\\";s:3:\\\"500\\\";s:6:\\\"length\\\";s:1:\\\"4\\\";}s:9:\\\"syn2field\\\";s:0:\\\"\\\";s:6:\\\"config\\\";a:0:{}}',0,0),
	(4,'a:1:{i:1;a:5:{s:3:\\\"use\\\";i:1;s:4:\\\"html\\\";i:0;s:5:\\\"theme\\\";s:7:\\\"default\\\";s:6:\\\"domain\\\";s:0:\\\"\\\";s:8:\\\"template\\\";s:7:\\\"default\\\";}}','quan',0,0,1,'a:4:{s:4:\\\"flag\\\";a:9:{i:1;a:3:{s:4:\\\"name\\\";s:12:\\\"推荐首页\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:2;a:3:{s:4:\\\"name\\\";s:12:\\\"推荐频道\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:3;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:4;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:5;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:6;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:7;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:8;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:9;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}}s:6:\\\"search\\\";a:3:{s:5:\\\"close\\\";s:1:\\\"0\\\";s:5:\\\"total\\\";s:3:\\\"500\\\";s:6:\\\"length\\\";s:1:\\\"4\\\";}s:9:\\\"syn2field\\\";s:0:\\\"\\\";s:6:\\\"config\\\";a:0:{}}',0,0),
	(5,'a:1:{i:1;a:5:{s:3:\\\"use\\\";i:1;s:4:\\\"html\\\";i:0;s:5:\\\"theme\\\";s:7:\\\"default\\\";s:6:\\\"domain\\\";s:0:\\\"\\\";s:8:\\\"template\\\";s:7:\\\"default\\\";}}','weixin',0,0,1,'a:4:{s:4:\\\"flag\\\";a:9:{i:1;a:3:{s:4:\\\"name\\\";s:12:\\\"推荐首页\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:2;a:3:{s:4:\\\"name\\\";s:12:\\\"推荐频道\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:3;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:4;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:5;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:6;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:7;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:8;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}i:9;a:3:{s:4:\\\"name\\\";s:0:\\\"\\\";s:3:\\\"3_1\\\";s:1:\\\"0\\\";s:3:\\\"4_5\\\";s:1:\\\"0\\\";}}s:6:\\\"search\\\";a:3:{s:5:\\\"close\\\";s:1:\\\"0\\\";s:5:\\\"total\\\";s:3:\\\"500\\\";s:6:\\\"length\\\";s:1:\\\"4\\\";}s:9:\\\"syn2field\\\";s:0:\\\"\\\";s:6:\\\"config\\\";a:0:{}}',0,0);

/*!40000 ALTER TABLE `dr_module` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table dr_module_form
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_module_form`;

CREATE TABLE `dr_module_form` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `module` varchar(50) NOT NULL COMMENT '模块目录',
  `name` varchar(50) NOT NULL COMMENT '表单名称',
  `table` varchar(50) NOT NULL COMMENT '表单表名称',
  `disabled` tinyint(1) unsigned NOT NULL COMMENT '是否禁用',
  `permission` text NOT NULL COMMENT '会员权限',
  `setting` text NOT NULL COMMENT '表单配置',
  PRIMARY KEY (`id`),
  KEY `table` (`table`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='模块表单表';



# Dump of table dr_site
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_site`;

CREATE TABLE `dr_site` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL COMMENT '站点名称',
  `domain` varchar(50) NOT NULL COMMENT '站点域名',
  `setting` text NOT NULL COMMENT '站点配置',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='站点表';



# Dump of table dr_urlrule
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_urlrule`;

CREATE TABLE `dr_urlrule` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `type` tinyint(1) unsigned NOT NULL COMMENT '规则类型',
  `name` varchar(50) NOT NULL COMMENT '规则名称',
  `value` text NOT NULL COMMENT '详细规则',
  PRIMARY KEY (`id`),
  KEY `type` (`type`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='URL规则表';



# Dump of table dr_var
# ------------------------------------------------------------

DROP TABLE IF EXISTS `dr_var`;

CREATE TABLE `dr_var` (
  `id` int(10) NOT NULL AUTO_INCREMENT COMMENT 'Id',
  `name` varchar(100) NOT NULL COMMENT '变量描述名称',
  `cname` varchar(100) NOT NULL COMMENT '变量名称',
  `type` tinyint(2) NOT NULL COMMENT '变量类型',
  `value` text NOT NULL COMMENT '变量值',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='自定义变量表';

DROP TABLE IF EXISTS `dr_bs`;
CREATE TABLE `dr_bs` ( `id` INT(11) NOT NULL AUTO_INCREMENT , `user` VARCHAR(255) NOT NULL , `status` TINYINT(1) NOT NULL , `inputtime` INT(11) NOT NULL , `industry` VARCHAR(255) NOT NULL , `budget` VARCHAR(255) NOT NULL , `target` VARCHAR(255) NOT NULL , `category` TEXT NOT NULL , `nickname` VARCHAR(255) NOT NULL , `mobile` VARCHAR(255) NOT NULL , `result` TEXT NOT NULL , PRIMARY KEY (`id`), INDEX (`user`), INDEX (`status`)) ENGINE = MyISAM CHARACTER SET utf8 COLLATE utf8_general_ci;



DROP TABLE IF EXISTS `dr_weixin`;

CREATE TABLE `dr_weixin` (
  `name` varchar(50) NOT NULL,
  `value` text NOT NULL,
  PRIMARY KEY (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='微信属性参数表';


DROP TABLE IF EXISTS `dr_weixin_follow`;

CREATE TABLE `dr_weixin_follow` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `openid` varchar(255) NOT NULL,
  `status` tinyint(1) NOT NULL,
  `uid` int(10) NOT NULL,
  PRIMARY KEY (`id`),
  KEY (`uid`),
  KEY (`status`),
  KEY (`openid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='微信粉丝同步表';




DROP TABLE IF EXISTS `dr_weixin_group`;

CREATE TABLE `dr_weixin_group` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `count` int(10) NOT NULL,
  `wechat_id` int(10) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='微信粉丝分组表';



DROP TABLE IF EXISTS `dr_weixin_keyword`;

CREATE TABLE `dr_weixin_keyword` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `keywords` varchar(255) NOT NULL COMMENT '关键词',
  `mtype` varchar(50) NOT NULL COMMENT '素材类型',
  `content` text NOT NULL,
  `mid` int(10) NOT NULL COMMENT '素材Id',
  `plug` varchar(100) NOT NULL COMMENT '插件名称',
  `count` int(10) NOT NULL,
  `inputtime` int(10) NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `keywords` (`keywords`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='微信关键字回复表';



DROP TABLE IF EXISTS `dr_weixin_material_file`;

CREATE TABLE `dr_weixin_material_file` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(11) unsigned NOT NULL,
  `username` varchar(50) CHARACTER SET utf8 NOT NULL,
  `title` varchar(255) CHARACTER SET utf8 NOT NULL,
  `is_video` tinyint(1) NOT NULL,
  `file` int(10) NOT NULL,
  `description` varchar(255) CHARACTER SET utf8 NOT NULL,
  `wechat_url` varchar(255) NOT NULL,
  `media_id` varchar(100) NOT NULL,
  `inputtime` int(11) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `inputtime` (`inputtime`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='图片素材';



DROP TABLE IF EXISTS `dr_weixin_material_image`;

CREATE TABLE `dr_weixin_material_image` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(11) unsigned NOT NULL,
  `username` varchar(50) NOT NULL,
  `file` varchar(100) CHARACTER SET utf8 NOT NULL,
  `media_id` varchar(100) NOT NULL,
  `wechat_url` varchar(255) NOT NULL,
  `inputtime` int(11) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `inputtime` (`inputtime`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='图片素材';



DROP TABLE IF EXISTS `dr_weixin_material_news`;

CREATE TABLE `dr_weixin_material_news` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(11) unsigned NOT NULL,
  `username` varchar(50) CHARACTER SET utf8 NOT NULL,
  `title` varchar(255) CHARACTER SET utf8 NOT NULL,
  `author` varchar(255) CHARACTER SET utf8 NOT NULL,
  `thumb` int(10) NOT NULL,
  `description` varchar(255) CHARACTER SET utf8 NOT NULL,
  `content` text CHARACTER SET utf8 NOT NULL,
  `linkurl` varchar(255) NOT NULL,
  `url` varchar(255) NOT NULL,
  `group_id` int(10) NOT NULL,
  `thumb_media_id` varchar(255) NOT NULL,
  `media_id` varchar(100) NOT NULL,
  `inputtime` int(11) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `inputtime` (`inputtime`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='图片素材';



DROP TABLE IF EXISTS `dr_weixin_material_text`;

CREATE TABLE `dr_weixin_material_text` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `uid` int(11) unsigned NOT NULL,
  `username` varchar(50) NOT NULL,
  `content` text CHARACTER SET utf8 NOT NULL,
  `inputtime` int(11) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `inputtime` (`inputtime`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COMMENT='文本素材';



DROP TABLE IF EXISTS `dr_weixin_menu`;

CREATE TABLE `dr_weixin_menu` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `pid` int(10) NOT NULL,
  `name` varchar(100) NOT NULL,
  `type` varchar(20) NOT NULL,
  `value` text NOT NULL,
  `displayorder` int(10) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='微信菜单表';



DROP TABLE IF EXISTS `dr_weixin_message`;

CREATE TABLE `dr_weixin_message` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `send` tinyint(1) NOT NULL COMMENT '是否用户提交',
  `openid` varchar(100) NOT NULL,
  `content` text NOT NULL COMMENT '消息内容',
  `inputtime` int(10) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='微信消息记录表';



DROP TABLE IF EXISTS `dr_weixin_user`;

CREATE TABLE `dr_weixin_user` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `uid` int(10) unsigned DEFAULT NULL COMMENT '会员id',
  `username` varchar(100) NOT NULL,
  `groupid` int(10) NOT NULL,
  `openid` varchar(50) NOT NULL COMMENT '唯一id',
  `nickname` text NOT NULL COMMENT '微信昵称',
  `sex` tinyint(1) unsigned DEFAULT NULL COMMENT '性别',
  `city` varchar(30) DEFAULT NULL COMMENT '城市',
  `country` varchar(30) DEFAULT NULL COMMENT '国家',
  `province` varchar(30) DEFAULT NULL COMMENT '省',
  `language` varchar(30) DEFAULT NULL COMMENT '语言',
  `headimgurl` varchar(255) DEFAULT NULL COMMENT '头像地址',
  `subscribe_time` int(10) unsigned NOT NULL COMMENT '关注时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `subscribe_time` (`subscribe_time`),
  KEY `openid` (`openid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='微信粉丝表';

DROP TABLE IF EXISTS `dr_bjd`;
CREATE TABLE `dr_bjd` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(11) NOT NULL,
  `username` varchar(111) NOT NULL,
  `content` mediumtext NOT NULL,
  `price` text NOT NULL,
  `inputtime` int(10) NOT NULL,
  `mid` varchar(20) NOT NULL,
  `catid` int(10) NOT NULL,
  `cids` varchar(255) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;

INSERT INTO `dr_field` VALUES(107, '账号名称', 'title', 'Text', 6, 'module', 1, 1, 1, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:5:{s:5:\\"width\\";s:3:\\"300\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:7:\\"VARCHAR\\";s:11:\\"fieldlength\\";s:3:\\"255\\";}s:8:\\"validate\\";a:8:{s:8:\\"required\\";s:1:\\"1\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:3:\\"xss\\";s:1:\\"1\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:48:\\"onblur=\\"check_title();get_keywords(\\''keywords\\'');\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(108, '头像', 'thumb', 'File', 6, 'module', 1, 1, 1, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:3:{s:4:\\"size\\";s:2:\\"10\\";s:3:\\"ext\\";s:11:\\"jpg,gif,png\\";s:10:\\"uploadpath\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(109, '关键字', 'keywords', 'Text', 6, 'module', 1, 1, 1, 1, 1, 1, 'a:2:{s:6:\\"option\\";a:3:{s:5:\\"width\\";i:400;s:9:\\"fieldtype\\";s:7:\\"VARCHAR\\";s:11:\\"fieldlength\\";s:3:\\"255\\";}s:8:\\"validate\\";a:2:{s:3:\\"xss\\";i:1;s:8:\\"formattr\\";s:22:\\" data-role=\\"tagsinput\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(110, '简介', 'description', 'Textarea', 6, 'module', 1, 1, 1, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:4:{s:5:\\"width\\";s:3:\\"500\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";s:6:\\"height\\";s:2:\\"60\\";s:5:\\"value\\";s:0:\\"\\";}s:8:\\"validate\\";a:8:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:3:\\"xss\\";s:1:\\"1\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:12:\\"dr_clearhtml\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(111, '内容', 'content', 'Ueditor', 6, 'module', 1, 0, 1, 1, 1, 1, 'a:2:{s:6:\\"option\\";a:3:{s:4:\\"mode\\";i:1;s:5:\\"width\\";s:3:\\"90%\\";s:6:\\"height\\";i:400;}s:8:\\"validate\\";a:2:{s:3:\\"xss\\";i:1;s:8:\\"required\\";i:1;}}', 0);
INSERT INTO `dr_field` VALUES(112, '粉丝量', 'fensiliang', 'Text', 6, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:5:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(113, '平均点评量', 'pingjundianpingliang', 'Text', 6, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:5:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(114, '平均播放量', 'pingjunbofangliang', 'Text', 6, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:5:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";s:5:\\"value\\";s:0:\\"\\";s:9:\\"fieldtype\\";s:0:\\"\\";s:11:\\"fieldlength\\";s:0:\\"\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(115, '视频转发价', 'price_zf', 'Price', 6, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:2:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(116, '视频直发价', 'price_zf2', 'Price', 6, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:2:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);
INSERT INTO `dr_field` VALUES(117, '贴片广告价', 'price_tp', 'Price', 6, 'module', 1, 1, 0, 1, 0, 0, 'a:2:{s:6:\\"option\\";a:2:{s:5:\\"width\\";s:3:\\"200\\";s:10:\\"is_mb_auto\\";s:1:\\"0\\";}s:8:\\"validate\\";a:7:{s:8:\\"required\\";s:1:\\"0\\";s:7:\\"pattern\\";s:0:\\"\\";s:9:\\"errortips\\";s:0:\\"\\";s:5:\\"check\\";s:0:\\"\\";s:6:\\"filter\\";s:0:\\"\\";s:4:\\"tips\\";s:0:\\"\\";s:8:\\"formattr\\";s:0:\\"\\";}}', 0);

-- Create syntax for TABLE 'dr_1_video'
CREATE TABLE `dr_1_video` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `catid` smallint(5) unsigned NOT NULL COMMENT '栏目id',
  `title` varchar(255) DEFAULT NULL COMMENT '主题',
  `thumb` varchar(255) DEFAULT NULL,
  `keywords` varchar(255) DEFAULT NULL COMMENT '关键字',
  `shipinlianjie` varchar(255) DEFAULT NULL COMMENT '视频链接',
  `description` text,
  `diqu` mediumint(8) unsigned DEFAULT NULL COMMENT '地区',
  `hits` mediumint(8) unsigned DEFAULT NULL COMMENT '浏览数',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '作者id',
  `author` varchar(50) NOT NULL COMMENT '作者名称',
  `status` tinyint(2) NOT NULL COMMENT '状态',
  `url` varchar(255) DEFAULT NULL COMMENT '地址',
  `link_id` int(10) NOT NULL DEFAULT '0' COMMENT '同步id',
  `tableid` smallint(5) unsigned NOT NULL COMMENT '附表id',
  `inputip` varchar(15) DEFAULT NULL COMMENT '录入者ip',
  `inputtime` int(10) unsigned NOT NULL COMMENT '录入时间',
  `updatetime` int(10) unsigned NOT NULL COMMENT '更新时间',
  `comments` int(10) unsigned NOT NULL COMMENT '评论数量',
  `favorites` int(10) unsigned NOT NULL COMMENT '收藏数量',
  `displayorder` tinyint(3) NOT NULL DEFAULT '0',
  `fensiliang` varchar(255) DEFAULT NULL,
  `pingjundianpingliang` varchar(255) DEFAULT NULL,
  `pingjunbofangliang` varchar(255) DEFAULT NULL,
  `price_zf` decimal(9,2) DEFAULT NULL,
  `price_zf_sj` decimal(9,2) DEFAULT NULL,
  `price_zf2` decimal(9,2) DEFAULT NULL,
  `price_zf2_sj` decimal(9,2) DEFAULT NULL,
  `price_tp` decimal(9,2) DEFAULT NULL,
  `price_tp_sj` decimal(9,2) DEFAULT NULL,
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `catid` (`catid`,`updatetime`),
  KEY `link_id` (`link_id`),
  KEY `comments` (`comments`),
  KEY `favorites` (`favorites`),
  KEY `status` (`status`),
  KEY `hits` (`hits`),
  KEY `displayorder` (`displayorder`,`updatetime`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COMMENT='主表';

-- Create syntax for TABLE 'dr_1_video_category'
CREATE TABLE `dr_1_video_category` (
  `id` tinyint(3) unsigned NOT NULL AUTO_INCREMENT,
  `pid` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT '上级id',
  `pids` varchar(255) NOT NULL COMMENT '所有上级id',
  `name` varchar(30) NOT NULL COMMENT '栏目名称',
  `letter` char(1) NOT NULL COMMENT '首字母',
  `dirname` varchar(30) NOT NULL COMMENT '栏目目录',
  `pdirname` varchar(100) NOT NULL COMMENT '上级目录',
  `child` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否有下级',
  `childids` text NOT NULL COMMENT '下级所有id',
  `thumb` varchar(255) NOT NULL COMMENT '栏目图片',
  `show` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '是否显示',
  `permission` text COMMENT '会员权限',
  `setting` text NOT NULL COMMENT '属性配置',
  `displayorder` tinyint(3) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `show` (`show`),
  KEY `module` (`pid`,`displayorder`,`id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=utf8 COMMENT='栏目表';

-- Create syntax for TABLE 'dr_1_video_favorite'
CREATE TABLE `dr_1_video_favorite` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'id',
  `cid` int(10) unsigned NOT NULL COMMENT '文档id',
  `eid` int(10) unsigned DEFAULT NULL COMMENT '扩展id',
  `uid` mediumint(8) unsigned NOT NULL COMMENT 'uid',
  `url` varchar(255) NOT NULL COMMENT 'URL地址',
  `title` varchar(255) NOT NULL COMMENT '标题',
  `inputtime` int(10) unsigned NOT NULL COMMENT '录入时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `cid` (`cid`),
  KEY `eid` (`eid`),
  KEY `inputtime` (`inputtime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='收藏夹表';

-- Create syntax for TABLE 'dr_1_video_flag'
CREATE TABLE `dr_1_video_flag` (
  `flag` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '文档标记id',
  `id` int(10) unsigned NOT NULL COMMENT '文档内容id',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '作者uid',
  `catid` tinyint(3) unsigned NOT NULL COMMENT '栏目id',
  KEY `flag` (`flag`,`id`,`uid`),
  KEY `catid` (`catid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='标记表';

-- Create syntax for TABLE 'dr_1_video_index'
CREATE TABLE `dr_1_video_index` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `uid` mediumint(8) unsigned NOT NULL COMMENT '作者uid',
  `catid` tinyint(3) unsigned NOT NULL COMMENT '栏目id',
  `status` tinyint(2) NOT NULL COMMENT '审核状态',
  `inputtime` int(10) unsigned NOT NULL COMMENT '录入时间',
  PRIMARY KEY (`id`),
  KEY `uid` (`uid`),
  KEY `catid` (`catid`),
  KEY `status` (`status`),
  KEY `inputtime` (`inputtime`)
) ENGINE=MyISAM AUTO_INCREMENT=2 DEFAULT CHARSET=utf8 COMMENT='内容索引表';

-- Create syntax for TABLE 'dr_1_video_search'
CREATE TABLE `dr_1_video_search` (
  `id` varchar(32) NOT NULL,
  `catid` tinyint(3) unsigned NOT NULL COMMENT '栏目id',
  `params` text NOT NULL COMMENT '参数数组',
  `keyword` varchar(255) NOT NULL COMMENT '关键字',
  `contentid` mediumtext NOT NULL COMMENT 'id集合',
  `inputtime` int(10) unsigned NOT NULL COMMENT '搜索时间',
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`),
  KEY `catid` (`catid`),
  KEY `keyword` (`keyword`),
  KEY `inputtime` (`inputtime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='搜索表';

-- Create syntax for TABLE 'dr_1_video_search_index'
CREATE TABLE `dr_1_video_search_index` (
  `id` varchar(32) NOT NULL,
  `cid` int(10) unsigned NOT NULL COMMENT '文档Id',
  `inputtime` int(10) unsigned NOT NULL COMMENT '搜索时间',
  KEY `id` (`id`),
  KEY `cid` (`cid`),
  KEY `inputtime` (`inputtime`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='搜索索引表';

-- Create syntax for TABLE 'dr_1_video_verify'
CREATE TABLE `dr_1_video_verify` (
  `id` int(10) unsigned NOT NULL,
  `catid` tinyint(3) unsigned NOT NULL COMMENT '栏目id',
  `uid` mediumint(8) unsigned NOT NULL COMMENT '作者uid',
  `author` varchar(50) NOT NULL COMMENT '作者',
  `status` tinyint(2) NOT NULL COMMENT '审核状态',
  `content` mediumtext NOT NULL COMMENT '具体内容',
  `backuid` mediumint(8) unsigned NOT NULL COMMENT '操作人uid',
  `backinfo` text NOT NULL COMMENT '操作退回信息',
  `inputtime` int(10) unsigned NOT NULL COMMENT '录入时间',
  UNIQUE KEY `id` (`id`),
  KEY `uid` (`uid`),
  KEY `catid` (`catid`),
  KEY `status` (`status`),
  KEY `inputtime` (`inputtime`),
  KEY `backuid` (`backuid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='内容审核表';

INSERT INTO `dr_1_video_category` VALUES(1, 0, '0', '美拍账号', 'm', 'meipaizhanghao', '', 0, '1', '', 1, NULL, 'a:4:{s:4:\\"edit\\";s:1:\\"0\\";s:7:\\"linkurl\\";s:0:\\"\\";s:3:\\"seo\\";a:4:{s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:5:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";s:6:\\"search\\";s:11:\\"search.html\\";}}', 0);
INSERT INTO `dr_1_video_category` VALUES(2, 0, '0', '秒拍账号', 'm', 'miaopaizhanghao', '', 0, '2', '', 1, NULL, 'a:4:{s:4:\\"edit\\";s:1:\\"0\\";s:7:\\"linkurl\\";s:0:\\"\\";s:3:\\"seo\\";a:4:{s:10:\\"show_title\\";s:74:\\"[第{page}页{join}]{title}{join}{catname}{join}{modname}{join}{SITE_NAME}\\";s:10:\\"list_title\\";s:58:\\"[第{page}页{join}]{name}{join}{modname}{join}{SITE_NAME}\\";s:13:\\"list_keywords\\";s:0:\\"\\";s:16:\\"list_description\\";s:0:\\"\\";}s:8:\\"template\\";a:5:{s:8:\\"pagesize\\";s:2:\\"20\\";s:4:\\"show\\";s:9:\\"show.html\\";s:8:\\"category\\";s:13:\\"category.html\\";s:4:\\"list\\";s:9:\\"list.html\\";s:6:\\"search\\";s:11:\\"search.html\\";}}', 0);

INSERT INTO `dr_module` VALUES(6, 'a:1:{i:1;a:5:{s:3:\\"use\\";i:1;s:4:\\"html\\";i:0;s:5:\\"theme\\";s:7:\\"default\\";s:6:\\"domain\\";s:0:\\"\\";s:8:\\"template\\";s:7:\\"default\\";}}', 'video', 0, 0, 1, '', 0, 0);
